/*
 * Planck.js v0.3.0-rc.1
 * 
 * Copyright (c) 2016-2018 Ali Shakiba http://shakiba.me/planck.js
 * Copyright (c) 2006-2013 Erin Catto  http://www.gphysics.com
 * 
 * This software is provided 'as-is', without any express or implied
 * warranty.  In no event will the authors be held liable for any damages
 * arising from the use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 * 
 * 1. The origin of this software must not be misrepresented; you must not
 * claim that you wrote the original software. If you use this software
 * in a product, an acknowledgment in the product documentation would be
 * appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 * misrepresented as being the original software.
 * 3. This notice may not be removed or altered from any source distribution.
 */
/*
 * Stage.js 
 * 
 * @copyright 2017 Ali Shakiba http://shakiba.me/stage.js
 * @license The MIT License
 */
!function(t){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=t();else if("function"==typeof define&&define.amd)define([],t);else{var i;"undefined"!=typeof window?i=window:"undefined"!=typeof global?i=global:"undefined"!=typeof self&&(i=self),i.planck=t()}}(function(){return function t(i,e,o){function s(r,a){if(!e[r]){if(!i[r]){var m="function"==typeof require&&require;if(!a&&m)return m(r,!0);if(n)return n(r,!0);var h=new Error("Cannot find module '"+r+"'");throw h.code="MODULE_NOT_FOUND",h}var c=e[r]={exports:{}};i[r][0].call(c.exports,function(t){var e=i[r][1][t];return s(e||t)},c,c.exports,t,i,e,o)}return e[r].exports}for(var n="function"==typeof require&&require,r=0;r<o.length;r++)s(o[r]);return s}({1:[function(t,i,e){function o(t,i){o._super.call(this),this.label("Planck"),i=i||{};var e=this._options={};this._options.speed=i.speed||1,this._options.hz=i.hz||60,Math.abs(this._options.hz)<1&&(this._options.hz=1/this._options.hz),this._options.ratio=i.ratio||16,this._options.lineWidth=2/this._options.ratio,this._world=t;var s=1/this._options.hz,n=0;this.tick(function(i){for(n+=i=.001*i*e.speed;n>s;)t.step(s),n-=s;return this.renderWorld(),!0},!0),t.on("remove-fixture",function(t){t.ui&&t.ui.remove()}),t.on("remove-joint",function(t){t.ui&&t.ui.remove()})}var s=t("../lib/"),n=t("stage-js/platform/web");i.exports=s,s.testbed=function(t,i){"function"==typeof t&&(i=t,t=null),n(function(t,e){function r(t,i){"function"!=typeof i&&"object"!=typeof i&&(_[t]=i)}function a(t,i){var e=String.fromCharCode(t);/\w/.test(e)&&(w[e]=i),w.right=B[39]||w.D,w.left=B[37]||w.A,w.up=B[38]||w.W,w.down=B[40]||w.S,w.fire=B[32]||B[13]}t.on(n.Mouse.START,function(){window.focus(),document.activeElement&&document.activeElement.blur(),e.focus()}),t.MAX_ELAPSE=1e3/30;var m=s.Vec2,h={},c=!1;t.on("resume",function(){c=!1,h._resume&&h._resume()}),t.on("pause",function(){c=!0,h._pause&&h._pause()}),h.isPaused=function(){return c},h.togglePause=function(){c?h.resume():h.pause()},h.pause=function(){t.pause()},h.resume=function(){t.resume(),h.focus()},h.focus=function(){document.activeElement&&document.activeElement.blur(),e.focus()},h.debug=!1,h.width=80,h.height=60,h.x=0,h.y=-10,h.ratio=16,h.hz=60,h.speed=1,h.activeKeys={},h.background="#222222";var l="",_={};h.status=function(t,i){void 0!==i?r(t,i):t&&"object"==typeof t?function(t){for(var i in t)r(i,t[i])}(t):"string"==typeof t&&(l=t),h._status&&h._status(l,_)},h.info=function(t){h._info&&h._info(t)};var u="",p="";!function(){var i=new n.Texture;t.append(n.image(i));var e=[];t.tick(function(){e.length=0},!0),i.draw=function(t){t.save(),t.transform(1,0,0,-1,-h.x,-h.y),t.lineWidth=2/h.ratio,t.lineCap="round";for(var i=e.shift();i;i=e.shift())i(t,h.ratio);t.restore()},h.drawPoint=function(t,i,o){e.push(function(i,e){i.beginPath(),i.arc(t.x,t.y,5/e,0,2*Math.PI),i.strokeStyle=o,i.stroke()}),p+="point"+t.x+","+t.y+","+i+","+o},h.drawCircle=function(t,i,o){e.push(function(e){e.beginPath(),e.arc(t.x,t.y,i,0,2*Math.PI),e.strokeStyle=o,e.stroke()}),p+="circle"+t.x+","+t.y+","+i+","+o},h.drawSegment=function(t,i,o){e.push(function(e){e.beginPath(),e.moveTo(t.x,t.y),e.lineTo(i.x,i.y),e.strokeStyle=o,e.stroke()}),p+="segment"+t.x+","+t.y+","+i.x+","+i.y+","+o},h.drawPolygon=function(t,i){if(t&&t.length){e.push(function(e){e.beginPath(),e.moveTo(t[0].x,t[0].y);for(var o=1;o<t.length;o++)e.lineTo(t[o].x,t[o].y);e.strokeStyle=i,e.closePath(),e.stroke()}),p+="segment";for(var o=1;o<t.length;o++)p+=t[o].x+","+t[o].y+",";p+=i}},h.drawAABB=function(t,i){e.push(function(e){e.beginPath(),e.moveTo(t.lowerBound.x,t.lowerBound.y),e.lineTo(t.upperBound.x,t.lowerBound.y),e.lineTo(t.upperBound.x,t.upperBound.y),e.lineTo(t.lowerBound.x,t.upperBound.y),e.strokeStyle=i,e.closePath(),e.stroke()}),p+="aabb",p+=t.lowerBound.x+","+t.lowerBound.y+",",p+=t.upperBound.x+","+t.upperBound.y+",",p+=i},h.color=function(t,i,e){return t=256*t|0,i=256*i|0,e=256*e|0,"rgb("+t+", "+i+", "+e+")"}}();var d=i(h),y=new o(d,h),f=0,v=0;t.tick(function(t,i){f===h.x&&v===h.y||(y.offset(-h.x,-h.y),f=h.x,v=h.y)}),y.tick(function(i,e){return"function"==typeof h.step&&h.step(i,e),g&&h.drawSegment(g.getPosition(),A,"rgba(255,255,255,0.2)"),u!==p&&(u=p,t.touch()),p="",!0}),t.background(h.background),t.viewbox(h.width,h.height),t.pin("alignX",-.5),t.pin("alignY",-.5),t.prepend(y);var x,g,b=d.createBody(),A={x:0,y:0};y.attr("spy",!0).on(n.Mouse.START,function(t){if(t={x:t.x,y:-t.y},!g){var i=function(t){var i,e=s.AABB(t,t);return d.queryAABB(e,function(e){if(!i&&e.getBody().isDynamic()&&e.testPoint(t))return i=e.getBody(),!0}),i}(t);i&&(h.mouseForce?g=i:(x=s.MouseJoint({maxForce:1e3},b,i,m(t)),d.createJoint(x)))}}).on(n.Mouse.MOVE,function(t){t={x:t.x,y:-t.y},x&&x.setTarget(t),A.x=t.x,A.y=t.y}).on(n.Mouse.END,function(t){if(t={x:t.x,y:-t.y},x&&(d.destroyJoint(x),x=null),g){var i=m.sub(t,g.getPosition());g.applyForceToCenter(i.mul(h.mouseForce),!0),g=null}}).on(n.Mouse.CANCEL,function(t){t={x:t.x,y:-t.y},x&&(d.destroyJoint(x),x=null),g&&(g=null)}),window.addEventListener("keydown",function(t){switch(t.keyCode){case"P".charCodeAt(0):h.togglePause()}},!1);var B={};window.addEventListener("keydown",function(t){var i=t.keyCode;B[i]=!0,a(i,!0),h.keydown&&h.keydown(i,String.fromCharCode(i))}),window.addEventListener("keyup",function(t){var i=t.keyCode;B[i]=!1,a(i,!1),h.keyup&&h.keyup(i,String.fromCharCode(i))});var w=h.activeKeys})},o._super=n,(o.prototype=n._create(o._super.prototype)).renderWorld=function(t){for(var i=(t=this._world).getBodyList();i;i=i.getNext())for(var e=i.getFixtureList();e;e=e.getNext()){if(!e.ui){e.render&&e.render.stroke?this._options.strokeStyle=e.render.stroke:i.render&&i.render.stroke?this._options.strokeStyle=i.render.stroke:i.isDynamic()?this._options.strokeStyle="rgba(255,255,255,0.9)":i.isKinematic()?this._options.strokeStyle="rgba(255,255,255,0.7)":i.isStatic()&&(this._options.strokeStyle="rgba(255,255,255,0.5)"),e.render&&e.render.fill?this._options.fillStyle=e.render.fill:i.render&&i.render.fill?this._options.fillStyle=i.render.fill:this._options.fillStyle="";var o=e.getType(),s=e.getShape();"circle"==o&&(e.ui=this.drawCircle(s,this._options)),"edge"==o&&(e.ui=this.drawEdge(s,this._options)),"polygon"==o&&(e.ui=this.drawPolygon(s,this._options)),"chain"==o&&(e.ui=this.drawChain(s,this._options)),e.ui&&e.ui.appendTo(this)}if(e.ui){var n=i.getPosition(),r=i.getAngle();e.ui.__lastX===n.x&&e.ui.__lastY===n.y&&e.ui.__lastR===r||(e.ui.__lastX=n.x,e.ui.__lastY=n.y,e.ui.__lastR=r,e.ui.offset(n.x,-n.y),e.ui.rotate(-r))}}for(var a=t.getJointList();a;a=a.getNext()){o=a.getType();var m=a.getAnchorA();i=a.getAnchorB();if(a.ui||(this._options.strokeStyle="rgba(255,255,255,0.2)",a.ui=this.drawJoint(a,this._options),a.ui.pin("handle",.5),a.ui&&a.ui.appendTo(this)),a.ui){var h=.5*(m.x+i.x),c=.5*(-m.y-i.y),l=m.x-i.x,_=-m.y- -i.y,u=Math.sqrt(l*l+_*_);a.ui.width(u),a.ui.rotate(Math.atan2(_,l)),a.ui.offset(h,c)}}},o.prototype.drawJoint=function(t,i){var e=i.lineWidth,o=i.ratio,s=n.canvas(function(t){this.size(10+2*e,2*e,o),t.scale(o,o),t.beginPath(),t.moveTo(e,e),t.lineTo(e+10,e),t.lineCap="round",t.lineWidth=i.lineWidth,t.strokeStyle=i.strokeStyle,t.stroke()});return n.image(s).stretch()},o.prototype.drawCircle=function(t,i){var e=i.lineWidth,o=i.ratio,s=t.m_radius,r=s+e,a=s+e,m=2*s+2*e,h=2*s+2*e,c=n.canvas(function(t){this.size(m,h,o),t.scale(o,o),t.arc(r,a,s,0,2*Math.PI),i.fillStyle&&(t.fillStyle=i.fillStyle,t.fill()),t.lineTo(r,a),t.lineWidth=i.lineWidth,t.strokeStyle=i.strokeStyle,t.stroke()}),l=n.image(c).offset(t.m_p.x-r,-t.m_p.y-a);return n.create().append(l)},o.prototype.drawEdge=function(t,i){var e=i.lineWidth,o=i.ratio,s=t.m_vertex1,r=t.m_vertex2,a=r.x-s.x,m=r.y-s.y,h=Math.sqrt(a*a+m*m),c=n.canvas(function(t){this.size(h+2*e,2*e,o),t.scale(o,o),t.beginPath(),t.moveTo(e,e),t.lineTo(e+h,e),t.lineCap="round",t.lineWidth=i.lineWidth,t.strokeStyle=i.strokeStyle,t.stroke()}),l=Math.min(s.x,r.x),_=Math.min(-s.y,-r.y),u=n.image(c);u.rotate(-Math.atan2(m,a)),u.offset(l-e,_-e);return n.create().append(u)},o.prototype.drawPolygon=function(t,i){var e=i.lineWidth,o=i.ratio,s=t.m_vertices;if(s.length){for(var r=1/0,a=1/0,m=-1/0,h=-1/0,c=0;c<s.length;++c){var l=s[c];r=Math.min(r,l.x),m=Math.max(m,l.x),a=Math.min(a,-l.y),h=Math.max(h,-l.y)}var _=m-r,u=h-a,p=n.canvas(function(t){this.size(_+2*e,u+2*e,o),t.scale(o,o),t.beginPath();for(var n=0;n<s.length;++n){var m=s[n],h=m.x-r+e,c=-m.y-a+e;0==n?t.moveTo(h,c):t.lineTo(h,c)}s.length>2&&t.closePath(),i.fillStyle&&(t.fillStyle=i.fillStyle,t.fill(),t.closePath()),t.lineCap="round",t.lineWidth=i.lineWidth,t.strokeStyle=i.strokeStyle,t.stroke()}),d=n.image(p);d.offset(r-e,a-e);return n.create().append(d)}},o.prototype.drawChain=function(t,i){var e=i.lineWidth,o=i.ratio,s=t.m_vertices;if(s.length){for(var r=1/0,a=1/0,m=-1/0,h=-1/0,c=0;c<s.length;++c){var l=s[c];r=Math.min(r,l.x),m=Math.max(m,l.x),a=Math.min(a,-l.y),h=Math.max(h,-l.y)}var _=m-r,u=h-a,p=n.canvas(function(t){this.size(_+2*e,u+2*e,o),t.scale(o,o),t.beginPath();for(var n=0;n<s.length;++n){var m=s[n],h=m.x-r+e,c=-m.y-a+e;0==n?t.moveTo(h,c):t.lineTo(h,c)}s.length,i.fillStyle&&(t.fillStyle=i.fillStyle,t.fill(),t.closePath()),t.lineCap="round",t.lineWidth=i.lineWidth,t.strokeStyle=i.strokeStyle,t.stroke()}),d=n.image(p);d.offset(r-e,a-e);return n.create().append(d)}}},{"../lib/":27,"stage-js/platform/web":82}],2:[function(t,i,e){function o(t,i){i=a(i,x),n&&r.assert(m.isValid(i.position)),n&&r.assert(m.isValid(i.linearVelocity)),n&&r.assert(c.isFinite(i.angle)),n&&r.assert(c.isFinite(i.angularVelocity)),n&&r.assert(c.isFinite(i.angularDamping)&&i.angularDamping>=0),n&&r.assert(c.isFinite(i.linearDamping)&&i.linearDamping>=0),this.m_world=t,this.m_awakeFlag=i.awake,this.m_autoSleepFlag=i.allowSleep,this.m_bulletFlag=i.bullet,this.m_fixedRotationFlag=i.fixedRotation,this.m_activeFlag=i.active,this.m_islandFlag=!1,this.m_toiFlag=!1,this.m_userData=i.userData,this.m_type=i.type,this.m_type==v?(this.m_mass=1,this.m_invMass=1):(this.m_mass=0,this.m_invMass=0),this.m_I=0,this.m_invI=0,this.m_xf=_.identity(),this.m_xf.p=m.clone(i.position),this.m_xf.q.setAngle(i.angle),this.m_sweep=new l,this.m_sweep.setTransform(this.m_xf),this.c_velocity=new u,this.c_position=new p,this.m_force=m.zero(),this.m_torque=0,this.m_linearVelocity=m.clone(i.linearVelocity),this.m_angularVelocity=i.angularVelocity,this.m_linearDamping=i.linearDamping,this.m_angularDamping=i.angularDamping,this.m_gravityScale=i.gravityScale,this.m_sleepTime=0,this.m_jointList=null,this.m_contactList=null,this.m_fixtureList=null,this.m_prev=null,this.m_next=null,this.m_destroyed=!1}function s(){this.mass=0,this.center=m.zero(),this.I=0}var n=!0;i.exports=o;var r=t("./util/common"),a=t("./util/options"),m=t("./common/Vec2"),h=t("./common/Rot"),c=t("./common/Math"),l=t("./common/Sweep"),_=t("./common/Transform"),u=t("./common/Velocity"),p=t("./common/Position"),d=t("./Fixture"),y=(t("./Shape"),t("./World"),o.STATIC="static"),f=o.KINEMATIC="kinematic",v=o.DYNAMIC="dynamic",x={type:y,position:m.zero(),angle:0,linearVelocity:m.zero(),angularVelocity:0,linearDamping:0,angularDamping:0,fixedRotation:!1,bullet:!1,gravityScale:1,allowSleep:!0,awake:!0,active:!0,userData:null};o.prototype.isWorldLocked=function(){return!(!this.m_world||!this.m_world.isLocked())},o.prototype.getWorld=function(){return this.m_world},o.prototype.getNext=function(){return this.m_next},o.prototype.setUserData=function(t){this.m_userData=t},o.prototype.getUserData=function(){return this.m_userData},o.prototype.getFixtureList=function(){return this.m_fixtureList},o.prototype.getJointList=function(){return this.m_jointList},o.prototype.getContactList=function(){return this.m_contactList},o.prototype.isStatic=function(){return this.m_type==y},o.prototype.isDynamic=function(){return this.m_type==v},o.prototype.isKinematic=function(){return this.m_type==f},o.prototype.setStatic=function(){return this.setType(y),this},o.prototype.setDynamic=function(){return this.setType(v),this},o.prototype.setKinematic=function(){return this.setType(f),this},o.prototype.getType=function(){return this.m_type},o.prototype.setType=function(t){if(n&&r.assert(t===y||t===f||t===v),n&&r.assert(0==this.isWorldLocked()),1!=this.isWorldLocked()&&this.m_type!=t){this.m_type=t,this.resetMassData(),this.m_type==y&&(this.m_linearVelocity.setZero(),this.m_angularVelocity=0,this.m_sweep.forward(),this.synchronizeFixtures()),this.setAwake(!0),this.m_force.setZero(),this.m_torque=0;for(var i=this.m_contactList;i;){var e=i;i=i.next,this.m_world.destroyContact(e.contact)}this.m_contactList=null;for(var o=this.m_world.m_broadPhase,s=this.m_fixtureList;s;s=s.m_next)for(var a=s.m_proxyCount,m=0;m<a;++m)o.touchProxy(s.m_proxies[m].proxyId)}},o.prototype.isBullet=function(){return this.m_bulletFlag},o.prototype.setBullet=function(t){this.m_bulletFlag=!!t},o.prototype.isSleepingAllowed=function(){return this.m_autoSleepFlag},o.prototype.setSleepingAllowed=function(t){this.m_autoSleepFlag=!!t,0==this.m_autoSleepFlag&&this.setAwake(!0)},o.prototype.isAwake=function(){return this.m_awakeFlag},o.prototype.setAwake=function(t){t?0==this.m_awakeFlag&&(this.m_awakeFlag=!0,this.m_sleepTime=0):(this.m_awakeFlag=!1,this.m_sleepTime=0,this.m_linearVelocity.setZero(),this.m_angularVelocity=0,this.m_force.setZero(),this.m_torque=0)},o.prototype.isActive=function(){return this.m_activeFlag},o.prototype.setActive=function(t){if(n&&r.assert(0==this.isWorldLocked()),t!=this.m_activeFlag)if(this.m_activeFlag=!!t,this.m_activeFlag)for(var i=this.m_world.m_broadPhase,e=this.m_fixtureList;e;e=e.m_next)e.createProxies(i,this.m_xf);else{for(i=this.m_world.m_broadPhase,e=this.m_fixtureList;e;e=e.m_next)e.destroyProxies(i);for(var o=this.m_contactList;o;){var s=o;o=o.next,this.m_world.destroyContact(s.contact)}this.m_contactList=null}},o.prototype.isFixedRotation=function(){return this.m_fixedRotationFlag},o.prototype.setFixedRotation=function(t){this.m_fixedRotationFlag!=t&&(this.m_fixedRotationFlag=!!t,this.m_angularVelocity=0,this.resetMassData())},o.prototype.getTransform=function(){return this.m_xf},o.prototype.setTransform=function(t,i){if(n&&r.assert(0==this.isWorldLocked()),1!=this.isWorldLocked()){this.m_xf.set(t,i),this.m_sweep.setTransform(this.m_xf);for(var e=this.m_world.m_broadPhase,o=this.m_fixtureList;o;o=o.m_next)o.synchronize(e,this.m_xf,this.m_xf)}},o.prototype.synchronizeTransform=function(){this.m_sweep.getTransform(this.m_xf,1)},o.prototype.synchronizeFixtures=function(){var t=_.identity();this.m_sweep.getTransform(t,0);for(var i=this.m_world.m_broadPhase,e=this.m_fixtureList;e;e=e.m_next)e.synchronize(i,t,this.m_xf)},o.prototype.advance=function(t){this.m_sweep.advance(t),this.m_sweep.c.set(this.m_sweep.c0),this.m_sweep.a=this.m_sweep.a0,this.m_sweep.getTransform(this.m_xf,1)},o.prototype.getPosition=function(){return this.m_xf.p},o.prototype.setPosition=function(t){this.setTransform(t,this.m_sweep.a)},o.prototype.getAngle=function(){return this.m_sweep.a},o.prototype.setAngle=function(t){this.setTransform(this.m_xf.p,t)},o.prototype.getWorldCenter=function(){return this.m_sweep.c},o.prototype.getLocalCenter=function(){return this.m_sweep.localCenter},o.prototype.getLinearVelocity=function(){return this.m_linearVelocity},o.prototype.getLinearVelocityFromWorldPoint=function(t){var i=m.sub(t,this.m_sweep.c);return m.add(this.m_linearVelocity,m.cross(this.m_angularVelocity,i))},o.prototype.getLinearVelocityFromLocalPoint=function(t){return this.getLinearVelocityFromWorldPoint(this.getWorldPoint(t))},o.prototype.setLinearVelocity=function(t){this.m_type!=y&&(m.dot(t,t)>0&&this.setAwake(!0),this.m_linearVelocity.set(t))},o.prototype.getAngularVelocity=function(){return this.m_angularVelocity},o.prototype.setAngularVelocity=function(t){this.m_type!=y&&(t*t>0&&this.setAwake(!0),this.m_angularVelocity=t)},o.prototype.getLinearDamping=function(){return this.m_linearDamping},o.prototype.setLinearDamping=function(t){this.m_linearDamping=t},o.prototype.getAngularDamping=function(){return this.m_angularDamping},o.prototype.setAngularDamping=function(t){this.m_angularDamping=t},o.prototype.getGravityScale=function(){return this.m_gravityScale},o.prototype.setGravityScale=function(t){this.m_gravityScale=t},o.prototype.getMass=function(){return this.m_mass},o.prototype.getInertia=function(){return this.m_I+this.m_mass*m.dot(this.m_sweep.localCenter,this.m_sweep.localCenter)},o.prototype.getMassData=function(t){t.mass=this.m_mass,t.I=this.getInertia(),t.center.set(this.m_sweep.localCenter)},o.prototype.resetMassData=function(){if(this.m_mass=0,this.m_invMass=0,this.m_I=0,this.m_invI=0,this.m_sweep.localCenter.setZero(),this.isStatic()||this.isKinematic())return this.m_sweep.c0.set(this.m_xf.p),this.m_sweep.c.set(this.m_xf.p),void(this.m_sweep.a0=this.m_sweep.a);n&&r.assert(this.isDynamic());for(var t=m.zero(),i=this.m_fixtureList;i;i=i.m_next)if(0!=i.m_density){var e=new s;i.getMassData(e),this.m_mass+=e.mass,t.addMul(e.mass,e.center),this.m_I+=e.I}this.m_mass>0?(this.m_invMass=1/this.m_mass,t.mul(this.m_invMass)):(this.m_mass=1,this.m_invMass=1),this.m_I>0&&0==this.m_fixedRotationFlag?(this.m_I-=this.m_mass*m.dot(t,t),n&&r.assert(this.m_I>0),this.m_invI=1/this.m_I):(this.m_I=0,this.m_invI=0);var o=m.clone(this.m_sweep.c);this.m_sweep.setLocalCenter(t,this.m_xf),this.m_linearVelocity.add(m.cross(this.m_angularVelocity,m.sub(this.m_sweep.c,o)))},o.prototype.setMassData=function(t){if(n&&r.assert(0==this.isWorldLocked()),1!=this.isWorldLocked()&&this.m_type==v){this.m_invMass=0,this.m_I=0,this.m_invI=0,this.m_mass=t.mass,this.m_mass<=0&&(this.m_mass=1),this.m_invMass=1/this.m_mass,t.I>0&&0==this.m_fixedRotationFlag&&(this.m_I=t.I-this.m_mass*m.dot(t.center,t.center),n&&r.assert(this.m_I>0),this.m_invI=1/this.m_I);var i=m.clone(this.m_sweep.c);this.m_sweep.setLocalCenter(t.center,this.m_xf),this.m_linearVelocity.add(m.cross(this.m_angularVelocity,m.sub(this.m_sweep.c,i)))}},o.prototype.applyForce=function(t,i,e){this.m_type==v&&(e&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_force.add(t),this.m_torque+=m.cross(m.sub(i,this.m_sweep.c),t)))},o.prototype.applyForceToCenter=function(t,i){this.m_type==v&&(i&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&this.m_force.add(t))},o.prototype.applyTorque=function(t,i){this.m_type==v&&(i&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_torque+=t))},o.prototype.applyLinearImpulse=function(t,i,e){this.m_type==v&&(e&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_linearVelocity.addMul(this.m_invMass,t),this.m_angularVelocity+=this.m_invI*m.cross(m.sub(i,this.m_sweep.c),t)))},o.prototype.applyAngularImpulse=function(t,i){this.m_type==v&&(i&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_angularVelocity+=this.m_invI*t))},o.prototype.shouldCollide=function(t){if(this.m_type!=v&&t.m_type!=v)return!1;for(var i=this.m_jointList;i;i=i.next)if(i.other==t&&0==i.joint.m_collideConnected)return!1;return!0},o.prototype.createFixture=function(t,i){if(n&&r.assert(0==this.isWorldLocked()),1==this.isWorldLocked())return null;var e=new d(this,t,i);if(this.m_activeFlag){var o=this.m_world.m_broadPhase;e.createProxies(o,this.m_xf)}return e.m_next=this.m_fixtureList,this.m_fixtureList=e,e.m_density>0&&this.resetMassData(),this.m_world.m_newFixture=!0,e},o.prototype.destroyFixture=function(t){if(n&&r.assert(0==this.isWorldLocked()),1!=this.isWorldLocked()){n&&r.assert(t.m_body==this);var i=!1;if(this.m_fixtureList===t)this.m_fixtureList=t.m_next,i=!0;else for(var e=this.m_fixtureList;null!=e;){if(e.m_next===t){e.m_next=t.m_next,i=!0;break}e=e.m_next}n&&r.assert(i);for(var o=this.m_contactList;o;){var s=o.contact;o=o.next;var a=s.getFixtureA(),m=s.getFixtureB();t!=a&&t!=m||this.m_world.destroyContact(s)}if(this.m_activeFlag){var h=this.m_world.m_broadPhase;t.destroyProxies(h)}t.m_body=null,t.m_next=null,this.m_world.publish("remove-fixture",t),this.resetMassData()}},o.prototype.getWorldPoint=function(t){return _.mulVec2(this.m_xf,t)},o.prototype.getWorldVector=function(t){return h.mulVec2(this.m_xf.q,t)},o.prototype.getLocalPoint=function(t){return _.mulTVec2(this.m_xf,t)},o.prototype.getLocalVector=function(t){return h.mulTVec2(this.m_xf.q,t)}},{"./Fixture":4,"./Shape":8,"./World":10,"./common/Math":18,"./common/Position":19,"./common/Rot":20,"./common/Sweep":21,"./common/Transform":22,"./common/Vec2":23,"./common/Velocity":25,"./util/common":51,"./util/options":53}],3:[function(t,i,e){function o(t){this.contact=t,this.prev=null,this.next=null,this.other=null}function s(){this.m_nodeA=new o(this),this.m_nodeB=new o(this),this.m_manifold=new y,this.v_points_cache=[new n,new n],this.v_points=[],this.v_normal=l.zero(),this.v_normalMass=new u,this.v_K=new u,this.p_localPoints_cache=[l.zero(),l.zero()],this.p_localPoints=[],this.p_localNormal=l.zero(),this.p_localPoint=l.zero(),this.p_localCenterA=l.zero(),this.p_localCenterB=l.zero()}function n(){this.rA=l.zero(),this.rB=l.zero(),this.normalImpulse=0,this.tangentImpulse=0,this.normalMass=0,this.tangentMass=0,this.velocityBias=0}function r(t,i){return c.sqrt(t*i)}function a(t,i){return t>i?t:i}var m=t("./util/common"),h=t("./util/Pool"),c=t("./common/Math"),l=t("./common/Vec2"),_=t("./common/Transform"),u=t("./common/Mat22"),p=t("./common/Rot"),d=t("./Settings"),y=t("./Manifold"),f=t("./collision/Distance");i.exports=s,s.prototype.init=function(t,i,e,o,s){this.m_fixtureA=t,this.m_fixtureB=e,this.m_indexA=i,this.m_indexB=o,this.m_evaluateFcn=s,this.m_manifold.init(),this.m_prev=null,this.m_next=null,this.m_toi=1,this.m_toiCount=0,this.m_toiFlag=!1,this.m_friction=r(this.m_fixtureA.m_friction,this.m_fixtureB.m_friction),this.m_restitution=a(this.m_fixtureA.m_restitution,this.m_fixtureB.m_restitution),this.m_tangentSpeed=0,this.m_enabledFlag=!0,this.m_islandFlag=!1,this.m_touchingFlag=!1,this.m_filterFlag=!1,this.m_bulletHitFlag=!1,this.v_points.length=0,this.v_normal.setZero(),this.v_normalMass.setZero(),this.v_K.setZero(),this.v_pointCount=null,this.v_tangentSpeed=null,this.v_friction=null,this.v_restitution=null,this.v_invMassA=null,this.v_invMassB=null,this.v_invIA=null,this.v_invIB=null,this.p_localPoints.length=0,this.p_localNormal.setZero(),this.p_localPoint.setZero(),this.p_localCenterA.setZero(),this.p_localCenterB.setZero(),this.p_type=null,this.p_radiusA=null,this.p_radiusB=null,this.p_pointCount=null,this.p_invMassA=null,this.p_invMassB=null,this.p_invIA=null,this.p_invIB=null},s.prototype.initConstraint=function(t){var i=this.m_fixtureA,e=this.m_fixtureB,o=i.getShape(),s=e.getShape(),n=i.getBody(),r=e.getBody(),a=this.m_manifold,h=a.pointCount;m.assert(h>0),this.v_invMassA=n.m_invMass,this.v_invMassB=r.m_invMass,this.v_invIA=n.m_invI,this.v_invIB=r.m_invI,this.v_friction=this.m_friction,this.v_restitution=this.m_restitution,this.v_tangentSpeed=this.m_tangentSpeed,this.v_pointCount=h,this.v_K.setZero(),this.v_normalMass.setZero(),this.p_invMassA=n.m_invMass,this.p_invMassB=r.m_invMass,this.p_invIA=n.m_invI,this.p_invIB=r.m_invI,this.p_localCenterA.setVec2(n.m_sweep.localCenter),this.p_localCenterB.setVec2(r.m_sweep.localCenter),this.p_radiusA=o.m_radius,this.p_radiusB=s.m_radius,this.p_type=a.type,this.p_localNormal.setVec2(a.localNormal),this.p_localPoint.setVec2(a.localPoint),this.p_pointCount=h;for(var c=0;c<h;++c){var l=a.points[c],_=this.v_points[c]=this.v_points_cache[c].init();t.warmStarting?(_.normalImpulse=t.dtRatio*l.normalImpulse,_.tangentImpulse=t.dtRatio*l.tangentImpulse):(_.normalImpulse=0,_.tangentImpulse=0),_.rA.setZero(),_.rB.setZero(),_.normalMass=0,_.tangentMass=0,_.velocityBias=0,this.p_localPoints[c]=this.p_localPoints_cache[c].setVec2(l.localPoint)}},s.prototype.getManifold=function(){return this.m_manifold},s.prototype.getWorldManifold=function(t){var i=this.m_fixtureA.getBody(),e=this.m_fixtureB.getBody(),o=this.m_fixtureA.getShape(),s=this.m_fixtureB.getShape();return this.m_manifold.getWorldManifold(t,i.getTransform(),o.m_radius,e.getTransform(),s.m_radius)},s.prototype.setEnabled=function(t){this.m_enabledFlag=!!t},s.prototype.isEnabled=function(){return this.m_enabledFlag},s.prototype.isTouching=function(){return this.m_touchingFlag},s.prototype.getNext=function(){return this.m_next},s.prototype.getFixtureA=function(){return this.m_fixtureA},s.prototype.getFixtureB=function(){return this.m_fixtureB},s.prototype.getChildIndexA=function(){return this.m_indexA},s.prototype.getChildIndexB=function(){return this.m_indexB},s.prototype.flagForFiltering=function(){this.m_filterFlag=!0},s.prototype.setFriction=function(t){this.m_friction=t},s.prototype.getFriction=function(){return this.m_friction},s.prototype.resetFriction=function(){this.m_friction=r(this.m_fixtureA.m_friction,this.m_fixtureB.m_friction)},s.prototype.setRestitution=function(t){this.m_restitution=t},s.prototype.getRestitution=function(){return this.m_restitution},s.prototype.resetRestitution=function(){this.m_restitution=a(this.m_fixtureA.m_restitution,this.m_fixtureB.m_restitution)},s.prototype.setTangentSpeed=function(t){this.m_tangentSpeed=t},s.prototype.getTangentSpeed=function(){return this.m_tangentSpeed},s.prototype.evaluate=function(t,i,e){this.m_evaluateFcn(t,i,this.m_fixtureA,this.m_indexA,e,this.m_fixtureB,this.m_indexB)};var v=new y;s.prototype.update=function(t){this.m_enabledFlag=!0;var i=!1,e=this.m_touchingFlag,o=this.m_fixtureA.isSensor(),s=this.m_fixtureB.isSensor(),n=o||s,r=this.m_fixtureA.getBody(),a=this.m_fixtureB.getBody(),m=r.getTransform(),h=a.getTransform();if(n){var c=this.m_fixtureA.getShape(),l=this.m_fixtureB.getShape();i=f.testOverlap(c,this.m_indexA,l,this.m_indexB,m,h),this.m_manifold.pointCount=0}else{var _=this.m_manifold;this.m_manifold=v.init(),v=_,this.evaluate(this.m_manifold,m,h),i=this.m_manifold.pointCount>0;for(var u=0;u<this.m_manifold.pointCount;++u){var p=this.m_manifold.points[u];p.normalImpulse=0,p.tangentImpulse=0;for(var d=0;d<_.pointCount;++d){var y=_.points[d];if(y.id.key==p.id.key){p.normalImpulse=y.normalImpulse,p.tangentImpulse=y.tangentImpulse;break}}}i!==e&&(r.setAwake(!0),a.setAwake(!0))}this.m_touchingFlag=i,!e&&i&&t&&t.beginContact(this),e&&!i&&t&&t.endContact(this),!n&&i&&t&&t.preSolve(this,_)},s.prototype.solvePositionConstraint=function(t){return this._solvePositionConstraint(t,!1)},s.prototype.solvePositionConstraintTOI=function(t,i,e){return this._solvePositionConstraint(t,!0,i,e)};var x=l.zero(),g=l.zero(),b=l.zero(),A=l.zero(),B=_.identity(),w=_.identity(),M=l.zero(),C=l.zero(),V=l.zero(),S=l.zero(),I=l.zero(),P=l.zero(),T=l.zero(),z=l.zero(),k=l.zero(),L=l.zero(),q=l.zero();s.prototype._solvePositionConstraint=function(t,i,e,o){var s=this.m_fixtureA,n=this.m_fixtureB,r=s.getBody(),a=n.getBody(),m=(r.c_velocity,a.c_velocity,r.c_position),h=a.c_position,u=x.setVec2(this.p_localCenterA),f=g.setVec2(this.p_localCenterB),v=0,F=0;i&&r!==e&&r!==o||(v=this.p_invMassA,F=this.p_invIA);var R=0,E=0;i&&a!==e&&a!==o||(R=this.p_invMassB,E=this.p_invIB);for(var j=b.setVec2(m.c),D=m.a,Y=A.setVec2(h.c),J=h.a,N=0,O=0;O<this.p_pointCount;++O){var W=B.setIdentity(),X=w.setIdentity();W.q.set(D),X.q.set(J),W.p.setVec2(l.sub_(j,p.mulVec2_(W.q,u,M),C)),X.p.setVec2(l.sub_(Y,p.mulVec2_(X.q,f,M),C));var H,Z,K;switch(this.p_type){case y.e_circles:var G=_.mulVec2_(W,this.p_localPoint,I),U=_.mulVec2_(X,this.p_localPoints[0],P);(H=l.sub_(U,G,V)).normalize(),Z=l.combine_(.5,G,.5,U,S),K=l.dot(l.sub(U,G),H)-this.p_radiusA-this.p_radiusB;break;case y.e_faceA:H=p.mulVec2_(W.q,this.p_localNormal,V);var $=_.mulVec2_(W,this.p_localPoint,T),Q=_.mulVec2_(X,this.p_localPoints[O],z);K=l.dot(l.sub_(Q,$,M),H)-this.p_radiusA-this.p_radiusB,Z=S.setVec2(Q);break;case y.e_faceB:H=p.mulVec2_(X.q,this.p_localNormal,V);$=_.mulVec2_(X,this.p_localPoint,T),Q=_.mulVec2_(W,this.p_localPoints[O],z);K=l.dot(l.sub_(Q,$,M),H)-this.p_radiusA-this.p_radiusB,Z=S.setVec2(Q),H.mul(-1)}var tt=l.sub_(Z,j,k),it=l.sub_(Z,Y,L);N=c.min(N,K);var et=i?d.toiBaugarte:d.baumgarte,ot=d.linearSlop,st=d.maxLinearCorrection,nt=c.clamp(et*(K+ot),-st,0),rt=l.crossVec2Vec2(tt,H),at=l.crossVec2Vec2(it,H),mt=v+R+F*rt*rt+E*at*at,ht=mt>0?-nt/mt:0,ct=l.mulNumVec2_(ht,H,q);j.subMul(v,ct),D-=F*l.crossVec2Vec2(tt,ct),Y.addMul(R,ct),J+=E*l.crossVec2Vec2(it,ct)}return m.c.setVec2(j),m.a=D,h.c.setVec2(Y),h.a=J,N},n.prototype.init=function(){return this.rA.setZero(),this.rB.setZero(),this.normalImpulse=0,this.tangentImpulse=0,this.normalMass=0,this.tangentMass=0,this.velocityBias=0,this};var F=l.zero(),R=l.zero(),E=l.zero(),j=l.zero(),D=l.zero(),Y=l.zero(),J=l.zero(),N=l.zero(),O=l.zero(),W=_.identity(),X=_.identity();s.prototype.initVelocityConstraint=function(t){var i=this.m_fixtureA,e=this.m_fixtureB,o=i.getBody(),s=e.getBody(),n=o.c_velocity,r=s.c_velocity,a=o.c_position,h=s.c_position,c=this.p_radiusA,_=this.p_radiusB,u=this.m_manifold,y=this.v_invMassA,f=this.v_invMassB,v=this.v_invIA,x=this.v_invIB,g=F.setVec2(this.p_localCenterA),b=R.setVec2(this.p_localCenterB),A=j.setVec2(a.c),B=a.a,w=Y.setVec2(n.v),M=n.w,C=D.set(h.c),V=h.a,S=J.set(r.v),I=r.w;m.assert(u.pointCount>0);var P=W.setIdentity(),T=X.setIdentity();P.q.set(B),T.q.set(V),P.p.setCombine(1,A,-1,p.mulVec2(P.q,g)),T.p.setCombine(1,C,-1,p.mulVec2(T.q,b));var z=u.getWorldManifold(null,P,c,T,_);this.v_normal.set(z.normal);for(var k=0;k<this.v_pointCount;++k){var L=this.v_points[k];L.rA.setCombine(1,z.points[k],-1,A),L.rB.setCombine(1,z.points[k],-1,C);var q=l.crossVec2Vec2(L.rA,this.v_normal),H=l.crossVec2Vec2(L.rB,this.v_normal),Z=y+f+v*q*q+x*H*H;L.normalMass=Z>0?1/Z:0;var K=l.crossVec2Num_(this.v_normal,1,E),G=l.crossVec2Vec2(L.rA,K),U=l.crossVec2Vec2(L.rB,K),$=y+f+v*G*G+x*U*U;L.tangentMass=$>0?1/$:0,L.velocityBias=0;var Q=l.dot(this.v_normal,S)+l.dot(this.v_normal,l.crossNumVec2_(I,L.rB,N))-l.dot(this.v_normal,w)-l.dot(this.v_normal,l.crossNumVec2_(M,L.rA,O));Q<-d.velocityThreshold&&(L.velocityBias=-this.v_restitution*Q)}if(2===this.v_pointCount&&t.blockSolve){var tt=this.v_points[0],it=this.v_points[1],et=l.crossVec2Vec2(tt.rA,this.v_normal),ot=l.crossVec2Vec2(tt.rB,this.v_normal),st=l.crossVec2Vec2(it.rA,this.v_normal),nt=l.crossVec2Vec2(it.rB,this.v_normal),rt=y+f+v*et*et+x*ot*ot,at=y+f+v*st*st+x*nt*nt,mt=y+f+v*et*st+x*ot*nt;rt*rt<1e3*(rt*at-mt*mt)?(this.v_K.ex.set(rt,mt),this.v_K.ey.set(mt,at),this.v_normalMass.set(this.v_K.getInverse())):this.v_pointCount=1}a.c.set(A),a.a=B,n.v.set(w),n.w=M,h.c.set(C),h.a=V,r.v.set(S),r.w=I};var H=l.zero(),Z=l.zero(),K=l.zero(),G=l.zero();s.prototype.warmStartConstraint=function(t){for(var i=this.m_fixtureA,e=this.m_fixtureB,o=i.getBody(),s=e.getBody(),n=o.c_velocity,r=s.c_velocity,a=(o.c_position,s.c_position,this.v_invMassA),m=this.v_invIA,h=this.v_invMassB,c=this.v_invIB,_=H.set(n.v),u=n.w,p=Z.set(r.v),d=r.w,y=this.v_normal,f=l.crossVec2Num_(y,1,K),v=0;v<this.v_pointCount;++v){var x=this.v_points[v],g=G.setCombine(x.normalImpulse,y,x.tangentImpulse,f);u-=m*l.crossVec2Vec2(x.rA,g),_.subMul(a,g),d+=c*l.crossVec2Vec2(x.rB,g),p.addMul(h,g)}n.v.set(_),n.w=u,r.v.set(p),r.w=d},s.prototype.storeConstraintImpulses=function(t){for(var i=this.m_manifold,e=0;e<this.v_pointCount;++e)i.points[e].normalImpulse=this.v_points[e].normalImpulse,i.points[e].tangentImpulse=this.v_points[e].tangentImpulse};var U=l.zero(),$=l.zero(),Q=l.zero(),tt=l.zero(),it=l.zero(),et=l.zero(),ot=l.zero(),st=l.zero(),nt=l.zero(),rt=l.zero(),at=l.zero(),mt=l.zero(),ht=l.zero(),ct=l.zero(),lt=l.zero();s.prototype.solveVelocityConstraint=function(t){var i=this.m_fixtureA.m_body,e=this.m_fixtureB.m_body,o=i.c_velocity,s=(i.c_position,e.c_velocity),n=(e.c_position,this.v_invMassA),r=this.v_invIA,a=this.v_invMassB,h=this.v_invIB,_=U.setVec2(o.v),p=o.w,d=$.setVec2(s.v),y=s.w,f=this.v_normal,v=l.crossVec2Num_(f,1,it),x=this.v_friction;m.assert(1===this.v_pointCount||2===this.v_pointCount);for(var g=0;g<this.v_pointCount;++g){var b=this.v_points[g];(V=Q.setZero()).addCombine(1,d,1,l.crossNumVec2_(y,b.rB,ct)),V.subCombine(1,_,1,l.crossNumVec2_(p,b.rA,ct));var A=l.dot(V,v)-this.v_tangentSpeed,B=b.tangentMass*-A,w=x*b.normalImpulse;B=(S=c.clamp(b.tangentImpulse+B,-w,w))-b.tangentImpulse,b.tangentImpulse=S;var M=l.mulNumVec2_(B,v,tt);_.subMul(n,M),p-=r*l.crossVec2Vec2(b.rA,M),d.addMul(a,M),y+=h*l.crossVec2Vec2(b.rB,M)}if(1==this.v_pointCount||0==t.blockSolve)for(var C=0;C<this.v_pointCount;++C){var V;b=this.v_points[C];(V=Q.setZero()).addCombine(1,d,1,l.crossNumVec2_(y,b.rB,ct)),V.subCombine(1,_,1,l.crossNumVec2_(p,b.rA,ct));var S,I=l.dot(V,f);B=-b.normalMass*(I-b.velocityBias);B=(S=c.max(b.normalImpulse+B,0))-b.normalImpulse,b.normalImpulse=S;M=l.mulNumVec2_(B,f,tt);_.subMul(n,M),p-=r*l.crossVec2Vec2(b.rA,M),d.addMul(a,M),y+=h*l.crossVec2Vec2(b.rB,M)}else{var P=this.v_points[0],T=this.v_points[1],z=et.set(P.normalImpulse,T.normalImpulse);m.assert(z.x>=0&&z.y>=0);var k=rt.setZero().add(d).add(l.crossNumVec2_(y,P.rB,ct)).sub(_).sub(l.crossNumVec2_(p,P.rA,lt)),L=at.setZero().add(d).add(l.crossNumVec2_(y,T.rB,ct)).sub(_).sub(l.crossNumVec2_(p,T.rA,lt)),q=l.dot(k,f),F=l.dot(L,f),R=ot.set(q-P.velocityBias,F-T.velocityBias);R.sub(u.mulVec2_(this.v_K,z,ct));for(;;){var E=u.mulVec2_(this.v_normalMass,R,nt).neg();if(E.x>=0&&E.y>=0){var j=l.sub_(E,z,st),D=l.mulNumVec2_(j.x,f,mt),Y=l.mulNumVec2_(j.y,f,ht);_.subCombine(n,D,n,Y),p-=r*(l.crossVec2Vec2(P.rA,D)+l.crossVec2Vec2(T.rA,Y)),d.addCombine(a,D,a,Y),y+=h*(l.crossVec2Vec2(P.rB,D)+l.crossVec2Vec2(T.rB,Y)),P.normalImpulse=E.x,T.normalImpulse=E.y;break}if(E.x=-P.normalMass*R.x,E.y=0,q=0,F=this.v_K.ex.y*E.x+R.y,E.x>=0&&F>=0){j=l.sub_(E,z,st),D=l.mulNumVec2_(j.x,f,mt),Y=l.mulNumVec2_(j.y,f,ht);_.subCombine(n,D,n,Y),p-=r*(l.crossVec2Vec2(P.rA,D)+l.crossVec2Vec2(T.rA,Y)),d.addCombine(a,D,a,Y),y+=h*(l.crossVec2Vec2(P.rB,D)+l.crossVec2Vec2(T.rB,Y)),P.normalImpulse=E.x,T.normalImpulse=E.y;break}if(E.x=0,E.y=-T.normalMass*R.y,q=this.v_K.ey.x*E.y+R.x,F=0,E.y>=0&&q>=0){j=l.sub_(E,z,st),D=l.mulNumVec2_(j.x,f,mt),Y=l.mulNumVec2_(j.y,f,ht);_.subCombine(n,D,n,Y),p-=r*(l.crossVec2Vec2(P.rA,D)+l.crossVec2Vec2(T.rA,Y)),d.addCombine(a,D,a,Y),y+=h*(l.crossVec2Vec2(P.rB,D)+l.crossVec2Vec2(T.rB,Y)),P.normalImpulse=E.x,T.normalImpulse=E.y;break}if(E.x=0,E.y=0,q=R.x,F=R.y,q>=0&&F>=0){j=l.sub_(E,z,st),D=l.mulNumVec2_(j.x,f,mt),Y=l.mulNumVec2_(j.y,f,ht);_.subCombine(n,D,n,Y),p-=r*(l.crossVec2Vec2(P.rA,D)+l.crossVec2Vec2(T.rA,Y)),d.addCombine(a,D,a,Y),y+=h*(l.crossVec2Vec2(P.rB,D)+l.crossVec2Vec2(T.rB,Y)),P.normalImpulse=E.x,T.normalImpulse=E.y;break}break}}o.v.set(_),o.w=p,s.v.set(d),s.w=y};var _t=[],ut=new h({create:function(){return new s}});s.addType=function(t,i,e){_t[t]=_t[t]||{},_t[t][i]=e},s.create=function(t,i,e,o){var s,n,r=t.getType(),a=e.getType();if(n=_t[r]&&_t[r][a])(s=ut.allocate()).init(t,i,e,o,n);else{if(!(n=_t[a]&&_t[a][r]))return null;(s=ut.allocate()).init(e,o,t,i,n)}t=s.getFixtureA(),e=s.getFixtureB(),i=s.getChildIndexA(),o=s.getChildIndexB();var m=t.getBody(),h=e.getBody();return s.m_nodeA.contact=s,s.m_nodeA.other=h,s.m_nodeA.prev=null,s.m_nodeA.next=m.m_contactList,null!=m.m_contactList&&(m.m_contactList.prev=s.m_nodeA),m.m_contactList=s.m_nodeA,s.m_nodeB.contact=s,s.m_nodeB.other=m,s.m_nodeB.prev=null,s.m_nodeB.next=h.m_contactList,null!=h.m_contactList&&(h.m_contactList.prev=s.m_nodeB),h.m_contactList=s.m_nodeB,t.isSensor()||e.isSensor()||(m.setAwake(!0),h.setAwake(!0)),s},s.destroy=function(t,i){var e=t.m_fixtureA,o=t.m_fixtureB,s=e.getBody(),n=o.getBody();t.isTouching()&&i.endContact(t),t.m_nodeA.prev&&(t.m_nodeA.prev.next=t.m_nodeA.next),t.m_nodeA.next&&(t.m_nodeA.next.prev=t.m_nodeA.prev),t.m_nodeA===s.m_contactList&&(s.m_contactList=t.m_nodeA.next),t.m_nodeB.prev&&(t.m_nodeB.prev.next=t.m_nodeB.next),t.m_nodeB.next&&(t.m_nodeB.next.prev=t.m_nodeB.prev),t.m_nodeB===n.m_contactList&&(n.m_contactList=t.m_nodeB.next),t.m_manifold.pointCount>0&&!e.isSensor()&&!o.isSensor()&&(s.setAwake(!0),n.setAwake(!0));var r=e.getType(),a=o.getType(),m=_t[r][a].destroyFcn;"function"==typeof m&&m(t),ut.release(t)}},{"./Manifold":6,"./Settings":7,"./collision/Distance":13,"./common/Mat22":16,"./common/Math":18,"./common/Rot":20,"./common/Transform":22,"./common/Vec2":23,"./util/Pool":49,"./util/common":51}],4:[function(t,i,e){function o(t,i){this.aabb=new h,this.fixture=t,this.childIndex=i,this.proxyId}function s(t,i,e){i.shape?(e=i,i=i.shape):"number"==typeof e&&(e={density:e}),e=r(e,c),this.m_body=t,this.m_friction=e.friction,this.m_restitution=e.restitution,this.m_density=e.density,this.m_isSensor=e.isSensor,this.m_filterGroupIndex=e.filterGroupIndex,this.m_filterCategoryBits=e.filterCategoryBits,this.m_filterMaskBits=e.filterMaskBits,this.m_shape=i,this.m_next=null,this.m_proxies=[],this.m_proxyCount=0;for(var s=this.m_shape.getChildCount(),n=0;n<s;++n)this.m_proxies[n]=new o(this,n);this.m_userData=e.userData}i.exports=s;var n=t("./util/common"),r=t("./util/options"),a=t("./common/Math"),m=t("./common/Vec2"),h=t("./collision/AABB"),c={userData:null,friction:.2,restitution:0,density:0,isSensor:!1,filterGroupIndex:0,filterCategoryBits:1,filterMaskBits:65535};s.prototype.getType=function(){return this.m_shape.getType()},s.prototype.getShape=function(){return this.m_shape},s.prototype.isSensor=function(){return this.m_isSensor},s.prototype.setSensor=function(t){t!=this.m_isSensor&&(this.m_body.setAwake(!0),this.m_isSensor=t)},s.prototype.getUserData=function(){return this.m_userData},s.prototype.setUserData=function(t){this.m_userData=t},s.prototype.getBody=function(){return this.m_body},s.prototype.getNext=function(){return this.m_next},s.prototype.getDensity=function(){return this.m_density},s.prototype.setDensity=function(t){n.assert(a.isFinite(t)&&t>=0),this.m_density=t},s.prototype.getFriction=function(){return this.m_friction},s.prototype.setFriction=function(t){this.m_friction=t},s.prototype.getRestitution=function(){return this.m_restitution},s.prototype.setRestitution=function(t){this.m_restitution=t},s.prototype.testPoint=function(t){return this.m_shape.testPoint(this.m_body.getTransform(),t)},s.prototype.rayCast=function(t,i,e){return this.m_shape.rayCast(t,i,this.m_body.getTransform(),e)},s.prototype.getMassData=function(t){this.m_shape.computeMass(t,this.m_density)},s.prototype.getAABB=function(t){return n.assert(0<=t&&t<this.m_proxyCount),this.m_proxies[t].aabb},s.prototype.createProxies=function(t,i){n.assert(0==this.m_proxyCount),this.m_proxyCount=this.m_shape.getChildCount();for(var e=0;e<this.m_proxyCount;++e){var o=this.m_proxies[e];this.m_shape.computeAABB(o.aabb,i,e),o.proxyId=t.createProxy(o.aabb,o)}},s.prototype.destroyProxies=function(t){for(var i=0;i<this.m_proxyCount;++i){var e=this.m_proxies[i];t.destroyProxy(e.proxyId),e.proxyId=null}this.m_proxyCount=0},s.prototype.synchronize=function(t,i,e){for(var o=0;o<this.m_proxyCount;++o){var s=this.m_proxies[o],n=new h,r=new h;this.m_shape.computeAABB(n,i,s.childIndex),this.m_shape.computeAABB(r,e,s.childIndex),s.aabb.combine(n,r);var a=m.sub(e.p,i.p);t.moveProxy(s.proxyId,s.aabb,a)}},s.prototype.setFilterData=function(t){this.m_filterGroupIndex=t.groupIndex,this.m_filterCategoryBits=t.categoryBits,this.m_filterMaskBits=t.maskBits,this.refilter()},s.prototype.getFilterGroupIndex=function(){return this.m_filterGroupIndex},s.prototype.getFilterCategoryBits=function(){return this.m_filterCategoryBits},s.prototype.getFilterMaskBits=function(){return this.m_filterMaskBits},s.prototype.refilter=function(){if(null!=this.m_body){for(var t=this.m_body.getContactList();t;){var i=t.contact,e=i.getFixtureA(),o=i.getFixtureB();e!=this&&o!=this||i.flagForFiltering(),t=t.next}var s=this.m_body.getWorld();if(null!=s)for(var n=s.m_broadPhase,r=0;r<this.m_proxyCount;++r)n.touchProxy(this.m_proxies[r].proxyId)}},s.prototype.shouldCollide=function(t){if(t.m_filterGroupIndex==this.m_filterGroupIndex&&0!=t.m_filterGroupIndex)return t.m_filterGroupIndex>0;return 0!=(t.m_filterMaskBits&this.m_filterCategoryBits)&&0!=(t.m_filterCategoryBits&this.m_filterMaskBits)}},{"./collision/AABB":11,"./common/Math":18,"./common/Vec2":23,"./util/common":51,"./util/options":53}],5:[function(t,i,e){function o(){this.other=null,this.joint=null,this.prev=null,this.next=null}function s(t,i,e){i=t.bodyA||i,e=t.bodyB||e,n&&r.assert(i),n&&r.assert(e),n&&r.assert(i!=e),this.m_type="unknown-joint",this.m_bodyA=i,this.m_bodyB=e,this.m_index=0,this.m_collideConnected=!!t.collideConnected,this.m_prev=null,this.m_next=null,this.m_edgeA=new o,this.m_edgeB=new o,this.m_islandFlag=!1,this.m_userData=t.userData}var n=!0;i.exports=s;var r=t("./util/common");s.prototype.isActive=function(){return this.m_bodyA.isActive()&&this.m_bodyB.isActive()},s.prototype.getType=function(){return this.m_type},s.prototype.getBodyA=function(){return this.m_bodyA},s.prototype.getBodyB=function(){return this.m_bodyB},s.prototype.getNext=function(){return this.m_next},s.prototype.getUserData=function(){return this.m_userData},s.prototype.setUserData=function(t){this.m_userData=t},s.prototype.getCollideConnected=function(){return this.m_collideConnected},s.prototype.getAnchorA=function(){},s.prototype.getAnchorB=function(){},s.prototype.getReactionForce=function(t){},s.prototype.getReactionTorque=function(t){},s.prototype.shiftOrigin=function(t){},s.prototype.initVelocityConstraints=function(t){},s.prototype.solveVelocityConstraints=function(t){},s.prototype.solvePositionConstraints=function(t){}},{"./util/common":51}],6:[function(t,i,e){function o(){this.type=-1,this.localNormal=m.zero(),this.localPoint=m.zero(),this.points=[new s,new s],this.pointCount=0}function s(){this.localPoint=m.zero(),this.normalImpulse=0,this.tangentImpulse=0,this.id=new n}function n(){this.cf=new r}function r(){this.indexA,this.indexB,this.typeA,this.typeB}function a(){this.v=m.zero(),this.id=new n}t("./util/common");var m=t("./common/Vec2"),h=t("./common/Transform"),c=t("./common/Math"),l=t("./common/Rot");i.exports=o,i.exports.clipSegmentToLine=function(t,i,e,s,n){var r=0,a=m.dot(e,i[0].v)-s,h=m.dot(e,i[1].v)-s;if(a<=0&&t[r++].set(i[0]),h<=0&&t[r++].set(i[1]),a*h<0){var c=a/(a-h);t[r].v.setCombine(1-c,i[0].v,c,i[1].v),t[r].id.cf.indexA=n,t[r].id.cf.indexB=i[0].id.cf.indexB,t[r].id.cf.typeA=o.e_vertex,t[r].id.cf.typeB=o.e_face,++r}return r},i.exports.clipVertex=a,i.exports.getPointStates=function(t,i,e,o){for(var s=0;s<e.pointCount;++s){var n=e.points[s].id;t[s]=_.removeState;for(var r=0;r<o.pointCount;++r)if(o.points[r].id.key==n.key){t[s]=_.persistState;break}}for(s=0;s<o.pointCount;++s)for(n=o.points[s].id,i[s]=_.addState,r=0;r<e.pointCount;++r)if(e.points[r].id.key==n.key){i[s]=_.persistState;break}},i.exports.PointState=_,o.e_circles=0,o.e_faceA=1,o.e_faceB=2,o.e_vertex=0,o.e_face=1,o.prototype.init=function(){return this.type=-1,this.localNormal.setZero(),this.localPoint.setZero(),this.points[0].init(),this.points[1].init(),this.pointCount=0,this},s.prototype.init=function(){this.localPoint.setZero(),this.normalImpulse=0,this.tangentImpulse=0,this.id.init()},n.prototype.init=function(){this.cf.init()},Object.defineProperty(n.prototype,"key",{get:function(){return this.cf.indexA+4*this.cf.indexB+16*this.cf.typeA+64*this.cf.typeB},enumerable:!0,configurable:!0}),n.prototype.set=function(t){this.cf.set(t.cf)},r.prototype.init=function(){this.indexA=0,this.indexB=0,this.typeA=0,this.typeB=0},r.prototype.set=function(t){this.indexA=t.indexA,this.indexB=t.indexB,this.typeA=t.typeA,this.typeB=t.typeB},o.prototype.getWorldManifold=function(t,i,e,s,n){if(0!=this.pointCount){var r=(t=t||new function(){this.normal,this.points=[],this.separations=[]}).normal,a=t.points,_=t.separations;switch(this.type){case o.e_circles:r=m.neo(1,0);var u=h.mulVec2(i,this.localPoint),p=h.mulVec2(s,this.points[0].localPoint),d=m.sub(p,u);m.lengthSquared(d)>c.EPSILON*c.EPSILON&&(r.set(d),r.normalize()),a[0]=m.mid(u,p),_[0]=-n-e,a.length=1,_.length=1;break;case o.e_faceA:r=l.mulVec2(i.q,this.localNormal);for(var y=h.mulVec2(i,this.localPoint),f=0;f<this.pointCount;++f){var v=h.mulVec2(s,this.points[f].localPoint),x=m.clone(v).addMul(e-m.dot(m.sub(v,y),r),r),g=m.clone(v).subMul(n,r);a[f]=m.mid(x,g),_[f]=m.dot(m.sub(g,x),r)}a.length=this.pointCount,_.length=this.pointCount;break;case o.e_faceB:r=l.mulVec2(s.q,this.localNormal);for(y=h.mulVec2(s,this.localPoint),f=0;f<this.pointCount;++f){v=h.mulVec2(i,this.points[f].localPoint),g=m.combine(1,v,n-m.dot(m.sub(v,y),r),r),x=m.combine(1,v,-e,r);a[f]=m.mid(x,g),_[f]=m.dot(m.sub(x,g),r)}a.length=this.pointCount,_.length=this.pointCount,r.mul(-1)}return t.normal=r,t.points=a,t.separations=_,t}};var _={nullState:0,addState:1,persistState:2,removeState:3};a.prototype.set=function(t){this.v.set(t.v),this.id.set(t.id)},a.prototype.init=function(){this.v.setZero(),this.id.init()}},{"./common/Math":18,"./common/Rot":20,"./common/Transform":22,"./common/Vec2":23,"./util/common":51}],7:[function(t,i,e){var o=e;o.maxManifoldPoints=2,o.maxPolygonVertices=12,o.aabbExtension=.1,o.aabbMultiplier=2,o.linearSlop=.005,o.linearSlopSquared=o.linearSlop*o.linearSlop,o.angularSlop=2/180*Math.PI,o.polygonRadius=2*o.linearSlop,o.maxSubSteps=8,o.maxTOIContacts=32,o.maxTOIIterations=20,o.maxDistnceIterations=20,o.velocityThreshold=1,o.maxLinearCorrection=.2,o.maxAngularCorrection=8/180*Math.PI,o.maxTranslation=2,o.maxTranslationSquared=o.maxTranslation*o.maxTranslation,o.maxRotation=.5*Math.PI,o.maxRotationSquared=o.maxRotation*o.maxRotation,o.baumgarte=.2,o.toiBaugarte=.75,o.timeToSleep=.5,o.linearSleepTolerance=.01,o.linearSleepToleranceSqr=Math.pow(o.linearSleepTolerance,2),o.angularSleepTolerance=2/180*Math.PI,o.angularSleepToleranceSqr=Math.pow(o.angularSleepTolerance,2)},{}],8:[function(t,i,e){function o(){this.m_type,this.m_radius}i.exports=o;t("./common/Math");o.isValid=function(t){return!!t},o.prototype.getRadius=function(){return this.m_radius},o.prototype.getType=function(){return this.m_type},o.prototype._clone=function(){},o.prototype.getChildCount=function(){},o.prototype.testPoint=function(t,i){},o.prototype.rayCast=function(t,i,e,o){},o.prototype.computeAABB=function(t,i,e){},o.prototype.computeMass=function(t,i){},o.prototype.computeDistanceProxy=function(t){}},{"./common/Math":18}],9:[function(t,i,e){function o(t){this.dt=0,this.inv_dt=0,this.velocityIterations=0,this.positionIterations=0,this.warmStarting=!1,this.blockSolve=!0,this.inv_dt0=0,this.dtRatio=1}function s(t){this.m_world=t,this.m_stack=[],this.m_bodies=[],this.m_contacts=[],this.m_joints=[]}i.exports=s,i.exports.TimeStep=o;var n=t("./Settings"),r=t("./util/common"),a=t("./common/Vec2"),m=t("./common/Math"),h=t("./Body"),c=t("./Contact"),l=t("./Joint"),_=t("./collision/TimeOfImpact"),u=_.Input,p=_.Output,d=t("./collision/Distance");d.Input,d.Output,d.Proxy,d.Cache;o.prototype.reset=function(t){this.dt>0&&(this.inv_dt0=this.inv_dt),this.dt=t,this.inv_dt=0==t?0:1/t,this.dtRatio=t*this.inv_dt0},s.prototype.clear=function(){this.m_stack.length=0,this.m_bodies.length=0,this.m_contacts.length=0,this.m_joints.length=0},s.prototype.addBody=function(t){r.assert(t instanceof h,"Not a Body!",t),this.m_bodies.push(t)},s.prototype.addContact=function(t){r.assert(t instanceof c,"Not a Contact!",t),this.m_contacts.push(t)},s.prototype.addJoint=function(t){r.assert(t instanceof l,"Not a Joint!",t),this.m_joints.push(t)},s.prototype.solveWorld=function(t){for(var i=this.m_world,e=i.m_bodyList;e;e=e.m_next)e.m_islandFlag=!1;for(var o=i.m_contactList;o;o=o.m_next)o.m_islandFlag=!1;for(var s=i.m_jointList;s;s=s.m_next)s.m_islandFlag=!1;for(var n=this.m_stack,a=i.m_bodyList;a;a=a.m_next)if(0,!a.m_islandFlag&&0!=a.isAwake()&&0!=a.isActive()&&!a.isStatic()){for(this.clear(),n.push(a),a.m_islandFlag=!0;n.length>0;){e=n.pop();if(r.assert(1==e.isActive()),this.addBody(e),e.setAwake(!0),!e.isStatic()){for(var m=e.m_contactList;m;m=m.next){var h=m.contact;if(!h.m_islandFlag&&(0!=h.isEnabled()&&0!=h.isTouching())){var c=h.m_fixtureA.m_isSensor,l=h.m_fixtureB.m_isSensor;if(!c&&!l){this.addContact(h),h.m_islandFlag=!0;(u=m.other).m_islandFlag||(n.push(u),u.m_islandFlag=!0)}}}for(var _=e.m_jointList;_;_=_.next)if(1!=_.joint.m_islandFlag){var u;0!=(u=_.other).isActive()&&(this.addJoint(_.joint),_.joint.m_islandFlag=!0,u.m_islandFlag||(n.push(u),u.m_islandFlag=!0))}}}this.solveIsland(t);for(var p=0;p<this.m_bodies.length;++p){(e=this.m_bodies[p]).isStatic()&&(e.m_islandFlag=!1)}}},s.prototype.solveIsland=function(t){for(var i=this.m_world,e=i.m_gravity,o=i.m_allowSleep,s=t.dt,r=0;r<this.m_bodies.length;++r){var h=this.m_bodies[r],c=a.clone(h.m_sweep.c),l=h.m_sweep.a,_=a.clone(h.m_linearVelocity),u=h.m_angularVelocity;h.m_sweep.c0.set(h.m_sweep.c),h.m_sweep.a0=h.m_sweep.a,h.isDynamic()&&(_.addMul(s*h.m_gravityScale,e),_.addMul(s*h.m_invMass,h.m_force),u+=s*h.m_invI*h.m_torque,_.mul(1/(1+s*h.m_linearDamping)),u*=1/(1+s*h.m_angularDamping)),h.c_position.c=c,h.c_position.a=l,h.c_velocity.v=_,h.c_velocity.w=u}for(r=0;r<this.m_contacts.length;++r){this.m_contacts[r].initConstraint(t)}for(r=0;r<this.m_contacts.length;++r){this.m_contacts[r].initVelocityConstraint(t)}if(t.warmStarting)for(r=0;r<this.m_contacts.length;++r){this.m_contacts[r].warmStartConstraint(t)}for(r=0;r<this.m_joints.length;++r){this.m_joints[r].initVelocityConstraints(t)}for(r=0;r<t.velocityIterations;++r){for(var p=0;p<this.m_joints.length;++p){this.m_joints[p].solveVelocityConstraints(t)}for(p=0;p<this.m_contacts.length;++p){this.m_contacts[p].solveVelocityConstraint(t)}}for(r=0;r<this.m_contacts.length;++r){this.m_contacts[r].storeConstraintImpulses(t)}for(r=0;r<this.m_bodies.length;++r){h=this.m_bodies[r],c=a.clone(h.c_position.c),l=h.c_position.a,_=a.clone(h.c_velocity.v),u=h.c_velocity.w;var d=a.mul(s,_);if(a.lengthSquared(d)>n.maxTranslationSquared){var y=n.maxTranslation/d.length();_.mul(y)}var f=s*u;if(f*f>n.maxRotationSquared){u*=y=n.maxRotation/m.abs(f)}c.addMul(s,_),l+=s*u,h.c_position.c.set(c),h.c_position.a=l,h.c_velocity.v.set(_),h.c_velocity.w=u}var v=!1;for(r=0;r<t.positionIterations;++r){var x=0;for(p=0;p<this.m_contacts.length;++p){var g=this.m_contacts[p].solvePositionConstraint(t);x=m.min(x,g)}var b=x>=-3*n.linearSlop,A=!0;for(p=0;p<this.m_joints.length;++p){var B=this.m_joints[p].solvePositionConstraints(t);A=A&&B}if(b&&A){v=!0;break}}for(r=0;r<this.m_bodies.length;++r){(h=this.m_bodies[r]).m_sweep.c.set(h.c_position.c),h.m_sweep.a=h.c_position.a,h.m_linearVelocity.set(h.c_velocity.v),h.m_angularVelocity=h.c_velocity.w,h.synchronizeTransform()}if(this.postSolveIsland(),o){var w=1/0,M=n.linearSleepToleranceSqr,C=n.angularSleepToleranceSqr;for(r=0;r<this.m_bodies.length;++r){(h=this.m_bodies[r]).isStatic()||(0==h.m_autoSleepFlag||h.m_angularVelocity*h.m_angularVelocity>C||a.lengthSquared(h.m_linearVelocity)>M?(h.m_sleepTime=0,w=0):(h.m_sleepTime+=s,w=m.min(w,h.m_sleepTime)))}if(w>=n.timeToSleep&&v)for(r=0;r<this.m_bodies.length;++r){(h=this.m_bodies[r]).setAwake(!1)}}},s.prototype.printBodies=function(t){for(var i=0;i<this.m_bodies.length;++i){var e=this.m_bodies[i];r.debug(t,e.c_position.a,e.c_position.c.x,e.c_position.c.y,e.c_velocity.w,e.c_velocity.v.x,e.c_velocity.v.y)}};var y=new o;s.prototype.solveWorldTOI=function(t){var i=this.m_world;if(i.m_stepComplete){for(var e=i.m_bodyList;e;e=e.m_next)e.m_islandFlag=!1,e.m_sweep.alpha0=0;for(var o=i.m_contactList;o;o=o.m_next)o.m_toiFlag=!1,o.m_islandFlag=!1,o.m_toiCount=0,o.m_toi=1}for(;;){var s=null,a=1;for(o=i.m_contactList;o;o=o.m_next)if(0!=o.isEnabled()&&!(o.m_toiCount>n.maxSubSteps)){var h=1;if(o.m_toiFlag)h=o.m_toi;else{var c=o.getFixtureA(),l=o.getFixtureB();if(c.isSensor()||l.isSensor())continue;var d=c.getBody(),f=l.getBody();r.assert(d.isDynamic()||f.isDynamic());var v=d.isAwake()&&!d.isStatic(),x=f.isAwake()&&!f.isStatic();if(0==v&&0==x)continue;var g=d.isBullet()||!d.isDynamic(),b=f.isBullet()||!f.isDynamic();if(0==g&&0==b)continue;var A=d.m_sweep.alpha0;d.m_sweep.alpha0<f.m_sweep.alpha0?(A=f.m_sweep.alpha0,d.m_sweep.advance(A)):f.m_sweep.alpha0<d.m_sweep.alpha0&&(A=d.m_sweep.alpha0,f.m_sweep.advance(A)),r.assert(A<1);var B=o.getChildIndexA(),w=o.getChildIndexB(),M=(d.m_sweep,f.m_sweep,new u);M.proxyA.set(c.getShape(),B),M.proxyB.set(l.getShape(),w),M.sweepA.set(d.m_sweep),M.sweepB.set(f.m_sweep),M.tMax=1;var C=new p;_(C,M);var V=C.t;h=C.state==p.e_touching?m.min(A+(1-A)*V,1):1,o.m_toi=h,o.m_toiFlag=!0}h<a&&(s=o,a=h)}if(null==s||1-10*m.EPSILON<a){i.m_stepComplete=!0;break}c=s.getFixtureA(),l=s.getFixtureB(),d=c.getBody(),f=l.getBody();var S=d.m_sweep.clone(),I=f.m_sweep.clone();if(d.advance(a),f.advance(a),s.update(i),s.m_toiFlag=!1,++s.m_toiCount,0!=s.isEnabled()&&0!=s.isTouching()){d.setAwake(!0),f.setAwake(!0),this.clear(),this.addBody(d),this.addBody(f),this.addContact(s),d.m_islandFlag=!0,f.m_islandFlag=!0,s.m_islandFlag=!0;for(var P=[d,f],T=0;T<P.length;++T){if((E=P[T]).isDynamic())for(var z=E.m_contactList;z;z=z.next){var k=z.contact;if(!k.m_islandFlag){var L=z.other;if(!L.isDynamic()||E.isBullet()||L.isBullet()){var q=k.m_fixtureA.m_isSensor,F=k.m_fixtureB.m_isSensor;if(!q&&!F){var R=L.m_sweep.clone();0==L.m_islandFlag&&L.advance(a),k.update(i),0!=k.isEnabled()&&0!=k.isTouching()?(k.m_islandFlag=!0,this.addContact(k),L.m_islandFlag||(L.m_islandFlag=!0,L.isStatic()||L.setAwake(!0),this.addBody(L))):(L.m_sweep.set(R),L.synchronizeTransform())}}}}}y.reset((1-a)*t.dt),y.dtRatio=1,y.positionIterations=20,y.velocityIterations=t.velocityIterations,y.warmStarting=!1,this.solveIslandTOI(y,d,f);for(T=0;T<this.m_bodies.length;++T){var E;if((E=this.m_bodies[T]).m_islandFlag=!1,E.isDynamic()){E.synchronizeFixtures();for(z=E.m_contactList;z;z=z.next)z.contact.m_toiFlag=!1,z.contact.m_islandFlag=!1}}if(i.findNewContacts(),i.m_subStepping){i.m_stepComplete=!1;break}}else s.setEnabled(!1),d.m_sweep.set(S),f.m_sweep.set(I),d.synchronizeTransform(),f.synchronizeTransform()}},s.prototype.solveIslandTOI=function(t,i,e){this.m_world;for(var o=0;o<this.m_bodies.length;++o){(l=this.m_bodies[o]).c_position.c.set(l.m_sweep.c),l.c_position.a=l.m_sweep.a,l.c_velocity.v.set(l.m_linearVelocity),l.c_velocity.w=l.m_angularVelocity}for(o=0;o<this.m_contacts.length;++o){this.m_contacts[o].initConstraint(t)}for(o=0;o<t.positionIterations;++o){for(var s=0,r=0;r<this.m_contacts.length;++r){var h=this.m_contacts[r].solvePositionConstraintTOI(t,i,e);s=m.min(s,h)}if(s>=-1.5*n.linearSlop)break}i.m_sweep.c0.set(i.c_position.c),i.m_sweep.a0=i.c_position.a,e.m_sweep.c0.set(e.c_position.c),e.m_sweep.a0=e.c_position.a;for(o=0;o<this.m_contacts.length;++o){this.m_contacts[o].initVelocityConstraint(t)}for(o=0;o<t.velocityIterations;++o)for(r=0;r<this.m_contacts.length;++r){this.m_contacts[r].solveVelocityConstraint(t)}var c=t.dt;for(o=0;o<this.m_bodies.length;++o){var l=this.m_bodies[o],_=a.clone(l.c_position.c),u=l.c_position.a,p=a.clone(l.c_velocity.v),d=l.c_velocity.w,y=a.mul(c,p);if(a.dot(y,y)>n.maxTranslationSquared){var f=n.maxTranslation/y.length();p.mul(f)}var v=c*d;if(v*v>n.maxRotationSquared){d*=f=n.maxRotation/m.abs(v)}_.addMul(c,p),u+=c*d,l.c_position.c=_,l.c_position.a=u,l.c_velocity.v=p,l.c_velocity.w=d,l.m_sweep.c=_,l.m_sweep.a=u,l.m_linearVelocity=p,l.m_angularVelocity=d,l.synchronizeTransform()}this.postSolveIsland()},s.prototype.postSolveIsland=function(){for(var t=new function(){this.normalImpulses=[],this.tangentImpulses=[]},i=0;i<this.m_contacts.length;++i){for(var e=this.m_contacts[i],o=0;o<e.v_points.length;++o)t.normalImpulses.push(e.v_points[o].normalImpulse),t.tangentImpulses.push(e.v_points[o].tangentImpulse);this.m_world.postSolve(e,t)}}},{"./Body":2,"./Contact":3,"./Joint":5,"./Settings":7,"./collision/Distance":13,"./collision/TimeOfImpact":15,"./common/Math":18,"./common/Vec2":23,"./util/common":51}],10:[function(t,i,e){function o(t){if(!(this instanceof o))return new o(t);t&&r.isValid(t)&&(t={gravity:t}),t=s(t,l),this.m_solver=new m(this),this.m_broadPhase=new a,this.m_contactList=null,this.m_contactCount=0,this.m_bodyList=null,this.m_bodyCount=0,this.m_jointList=null,this.m_jointCount=0,this.m_stepComplete=!0,this.m_allowSleep=t.allowSleep,this.m_gravity=r.clone(t.gravity),this.m_clearForces=!0,this.m_newFixture=!1,this.m_locked=!1,this.m_warmStarting=t.warmStarting,this.m_continuousPhysics=t.continuousPhysics,this.m_subStepping=t.subStepping,this.m_blockSolve=t.blockSolve,this.m_velocityIterations=t.velocityIterations,this.m_positionIterations=t.positionIterations,this.m_t=0,this.m_stepCount=0,this.addPair=this.createContact.bind(this)}i.exports=o;var s=t("./util/options"),n=t("./util/common"),r=t("./common/Vec2"),a=t("./collision/BroadPhase"),m=t("./Solver"),h=t("./Body"),c=t("./Contact"),l={gravity:r.zero(),allowSleep:!0,warmStarting:!0,continuousPhysics:!0,subStepping:!1,blockSolve:!0,velocityIterations:8,positionIterations:3};o.prototype.getBodyList=function(){return this.m_bodyList},o.prototype.getJointList=function(){return this.m_jointList},o.prototype.getContactList=function(){return this.m_contactList},o.prototype.getBodyCount=function(){return this.m_bodyCount},o.prototype.getJointCount=function(){return this.m_jointCount},o.prototype.getContactCount=function(){return this.m_contactCount},o.prototype.setGravity=function(t){this.m_gravity=t},o.prototype.getGravity=function(){return this.m_gravity},o.prototype.isLocked=function(){return this.m_locked},o.prototype.setAllowSleeping=function(t){if(t!=this.m_allowSleep&&(this.m_allowSleep=t,0==this.m_allowSleep))for(var i=this.m_bodyList;i;i=i.m_next)i.setAwake(!0)},o.prototype.getAllowSleeping=function(){return this.m_allowSleep},o.prototype.setWarmStarting=function(t){this.m_warmStarting=t},o.prototype.getWarmStarting=function(){return this.m_warmStarting},o.prototype.setContinuousPhysics=function(t){this.m_continuousPhysics=t},o.prototype.getContinuousPhysics=function(){return this.m_continuousPhysics},o.prototype.setSubStepping=function(t){this.m_subStepping=t},o.prototype.getSubStepping=function(){return this.m_subStepping},o.prototype.setAutoClearForces=function(t){this.m_clearForces=t},o.prototype.getAutoClearForces=function(){return this.m_clearForces},o.prototype.clearForces=function(){for(var t=this.m_bodyList;t;t=t.getNext())t.m_force.setZero(),t.m_torque=0},o.prototype.queryAABB=function(t,i){n.assert("function"==typeof i);var e=this.m_broadPhase;this.m_broadPhase.query(t,function(t){var o=e.getUserData(t);return i(o.fixture)})},o.prototype.rayCast=function(t,i,e){n.assert("function"==typeof e);var o=this.m_broadPhase;this.m_broadPhase.rayCast({maxFraction:1,p1:t,p2:i},function(t,i){var s=o.getUserData(i),n=s.fixture,a=s.childIndex,m={};if(n.rayCast(m,t,a)){var h=m.fraction,c=r.add(r.mul(1-h,t.p1),r.mul(h,t.p2));return e(n,c,m.normal,h)}return t.maxFraction})},o.prototype.getProxyCount=function(){return this.m_broadPhase.getProxyCount()},o.prototype.getTreeHeight=function(){return this.m_broadPhase.getTreeHeight()},o.prototype.getTreeBalance=function(){return this.m_broadPhase.getTreeBalance()},o.prototype.getTreeQuality=function(){return this.m_broadPhase.getTreeQuality()},o.prototype.shiftOrigin=function(t){if(n.assert(0==this.m_locked),!this.m_locked){for(var i=this.m_bodyList;i;i=i.m_next)i.m_xf.p.sub(t),i.m_sweep.c0.sub(t),i.m_sweep.c.sub(t);for(var e=this.m_jointList;e;e=e.m_next)e.shiftOrigin(t);this.m_broadPhase.shiftOrigin(t)}},o.prototype.createBody=function(t,i){if(n.assert(0==this.isLocked()),this.isLocked())return null;t&&r.isValid(t)&&(t={position:t,angle:i});var e=new h(this,t);return e.m_prev=null,e.m_next=this.m_bodyList,this.m_bodyList&&(this.m_bodyList.m_prev=e),this.m_bodyList=e,++this.m_bodyCount,e},o.prototype.createDynamicBody=function(t,i){return t?r.isValid(t)&&(t={position:t,angle:i}):t={},t.type="dynamic",this.createBody(t)},o.prototype.createKinematicBody=function(t,i){return t?r.isValid(t)&&(t={position:t,angle:i}):t={},t.type="kinematic",this.createBody(t)},o.prototype.destroyBody=function(t){if(n.assert(this.m_bodyCount>0),n.assert(0==this.isLocked()),!this.isLocked()){if(t.m_destroyed)return!1;for(var i=t.m_jointList;i;){var e=i;i=i.next,this.publish("remove-joint",e.joint),this.destroyJoint(e.joint),t.m_jointList=i}t.m_jointList=null;for(var o=t.m_contactList;o;){var s=o;o=o.next,this.destroyContact(s.contact),t.m_contactList=o}t.m_contactList=null;for(var r=t.m_fixtureList;r;){var a=r;r=r.m_next,this.publish("remove-fixture",a),a.destroyProxies(this.m_broadPhase),t.m_fixtureList=r}return t.m_fixtureList=null,t.m_prev&&(t.m_prev.m_next=t.m_next),t.m_next&&(t.m_next.m_prev=t.m_prev),t==this.m_bodyList&&(this.m_bodyList=t.m_next),t.m_destroyed=!0,--this.m_bodyCount,this.publish("remove-body",t),!0}},o.prototype.createJoint=function(t){if(n.assert(!!t.m_bodyA),n.assert(!!t.m_bodyB),n.assert(0==this.isLocked()),this.isLocked())return null;if(t.m_prev=null,t.m_next=this.m_jointList,this.m_jointList&&(this.m_jointList.m_prev=t),this.m_jointList=t,++this.m_jointCount,t.m_edgeA.joint=t,t.m_edgeA.other=t.m_bodyB,t.m_edgeA.prev=null,t.m_edgeA.next=t.m_bodyA.m_jointList,t.m_bodyA.m_jointList&&(t.m_bodyA.m_jointList.prev=t.m_edgeA),t.m_bodyA.m_jointList=t.m_edgeA,t.m_edgeB.joint=t,t.m_edgeB.other=t.m_bodyA,t.m_edgeB.prev=null,t.m_edgeB.next=t.m_bodyB.m_jointList,t.m_bodyB.m_jointList&&(t.m_bodyB.m_jointList.prev=t.m_edgeB),t.m_bodyB.m_jointList=t.m_edgeB,0==t.m_collideConnected)for(var i=t.m_bodyB.getContactList();i;i=i.next)i.other==t.m_bodyA&&i.contact.flagForFiltering();return t},o.prototype.destroyJoint=function(t){if(n.assert(0==this.isLocked()),!this.isLocked()){t.m_prev&&(t.m_prev.m_next=t.m_next),t.m_next&&(t.m_next.m_prev=t.m_prev),t==this.m_jointList&&(this.m_jointList=t.m_next);var i=t.m_bodyA,e=t.m_bodyB;if(i.setAwake(!0),e.setAwake(!0),t.m_edgeA.prev&&(t.m_edgeA.prev.next=t.m_edgeA.next),t.m_edgeA.next&&(t.m_edgeA.next.prev=t.m_edgeA.prev),t.m_edgeA==i.m_jointList&&(i.m_jointList=t.m_edgeA.next),t.m_edgeA.prev=null,t.m_edgeA.next=null,t.m_edgeB.prev&&(t.m_edgeB.prev.next=t.m_edgeB.next),t.m_edgeB.next&&(t.m_edgeB.next.prev=t.m_edgeB.prev),t.m_edgeB==e.m_jointList&&(e.m_jointList=t.m_edgeB.next),t.m_edgeB.prev=null,t.m_edgeB.next=null,n.assert(this.m_jointCount>0),--this.m_jointCount,0==t.m_collideConnected)for(var o=e.getContactList();o;)o.other==i&&o.contact.flagForFiltering(),o=o.next;this.publish("remove-joint",t)}};var _=new m.TimeStep;o.prototype.step=function(t,i,e){if((0|i)!==i&&(i=0),i=i||this.m_velocityIterations,e=e||this.m_positionIterations,this.m_stepCount++,this.m_newFixture&&(this.findNewContacts(),this.m_newFixture=!1),this.m_locked=!0,_.reset(t),_.velocityIterations=i,_.positionIterations=e,_.warmStarting=this.m_warmStarting,_.blockSolve=this.m_blockSolve,this.updateContacts(),this.m_stepComplete&&t>0){this.m_solver.solveWorld(_);for(var o=this.m_bodyList;o;o=o.getNext())0!=o.m_islandFlag&&(o.isStatic()||o.synchronizeFixtures());this.findNewContacts()}this.m_continuousPhysics&&t>0&&this.m_solver.solveWorldTOI(_),this.m_clearForces&&this.clearForces(),this.m_locked=!1},o.prototype.findNewContacts=function(){this.m_broadPhase.updatePairs(this.addPair)},o.prototype.createContact=function(t,i){var e=t.fixture,o=i.fixture,s=t.childIndex,n=i.childIndex,r=e.getBody(),a=o.getBody();if(r!==a){for(var m=a.getContactList();m;){if(m.other===r){var h=m.contact.getFixtureA(),l=m.contact.getFixtureB(),_=m.contact.getChildIndexA(),u=m.contact.getChildIndexB();if(h===e&&l===o&&_===s&&u===n)return;if(h===o&&l===e&&_===n&&u===s)return}m=m.next}if(!1!==a.shouldCollide(r)&&!1!==o.shouldCollide(e)){var p=c.create(e,s,o,n);null!=p&&(p.m_prev=null,null!=this.m_contactList&&(p.m_next=this.m_contactList,this.m_contactList.m_prev=p),this.m_contactList=p,++this.m_contactCount)}}},o.prototype.updateContacts=function(){for(var t,i=this.m_contactList;t=i;){i=t.getNext();var e=t.getFixtureA(),o=t.getFixtureB(),s=t.getChildIndexA(),n=t.getChildIndexB(),r=e.getBody(),a=o.getBody();if(t.m_filterFlag){if(0==a.shouldCollide(r)){this.destroyContact(t);continue}if(0==o.shouldCollide(e)){this.destroyContact(t);continue}t.m_filterFlag=!1}var m=r.isAwake()&&!r.isStatic(),h=a.isAwake()&&!a.isStatic();if(0!=m||0!=h){var c=e.m_proxies[s].proxyId,l=o.m_proxies[n].proxyId;0!=this.m_broadPhase.testOverlap(c,l)?t.update(this):this.destroyContact(t)}}},o.prototype.destroyContact=function(t){c.destroy(t,this),t.m_prev&&(t.m_prev.m_next=t.m_next),t.m_next&&(t.m_next.m_prev=t.m_prev),t==this.m_contactList&&(this.m_contactList=t.m_next),--this.m_contactCount},o.prototype._listeners=null,o.prototype.on=function(t,i){return"string"!=typeof t||"function"!=typeof i?this:(this._listeners||(this._listeners={}),this._listeners[t]||(this._listeners[t]=[]),this._listeners[t].push(i),this)},o.prototype.off=function(t,i){if("string"!=typeof t||"function"!=typeof i)return this;var e=this._listeners&&this._listeners[t];if(!e||!e.length)return this;var o=e.indexOf(i);return o>=0&&e.splice(o,1),this},o.prototype.publish=function(t,i,e,o){var s=this._listeners&&this._listeners[t];if(!s||!s.length)return 0;for(var n=0;n<s.length;n++)s[n].call(this,i,e,o);return s.length},o.prototype.beginContact=function(t){this.publish("begin-contact",t)},o.prototype.endContact=function(t){this.publish("end-contact",t)},o.prototype.preSolve=function(t,i){this.publish("pre-solve",t,i)},o.prototype.postSolve=function(t,i){this.publish("post-solve",t,i)}},{"./Body":2,"./Contact":3,"./Solver":9,"./collision/BroadPhase":12,"./common/Vec2":23,"./util/common":51,"./util/options":53}],11:[function(t,i,e){function o(t,i){if(!(this instanceof o))return new o(t,i);this.lowerBound=n.zero(),this.upperBound=n.zero(),"object"==typeof t&&this.lowerBound.set(t),"object"==typeof i&&this.upperBound.set(i)}t("../Settings");var s=t("../common/Math"),n=t("../common/Vec2");i.exports=o,o.prototype.isValid=function(){return o.isValid(this)},o.isValid=function(t){var i=n.sub(t.upperBound,t.lowerBound);return i.x>=0&&i.y>=0&&n.isValid(t.lowerBound)&&n.isValid(t.upperBound)},o.assert=function(t){if(!o.isValid(t))throw new Error("Invalid AABB!")},o.prototype.getCenter=function(){return n.neo(.5*(this.lowerBound.x+this.upperBound.x),.5*(this.lowerBound.y+this.upperBound.y))},o.prototype.getExtents=function(){return n.neo(.5*(this.upperBound.x-this.lowerBound.x),.5*(this.upperBound.y-this.lowerBound.y))},o.prototype.getPerimeter=function(){return 2*(this.upperBound.x-this.lowerBound.x+this.upperBound.y-this.lowerBound.y)},o.prototype.combine=function(t,i){var e=t.lowerBound,o=t.upperBound,n=i.lowerBound,r=i.upperBound,a=s.min(e.x,n.x),m=s.min(e.y,n.y),h=s.max(r.x,o.x),c=s.max(r.y,o.y);this.lowerBound.set(a,m),this.upperBound.set(h,c)},o.prototype.combinePoints=function(t,i){this.lowerBound.set(s.min(t.x,i.x),s.min(t.y,i.y)),this.upperBound.set(s.max(t.x,i.x),s.max(t.y,i.y))},o.prototype.set=function(t){this.lowerBound.set(t.lowerBound.x,t.lowerBound.y),this.upperBound.set(t.upperBound.x,t.upperBound.y)},o.prototype.contains=function(t){var i=!0;return i=i&&this.lowerBound.x<=t.lowerBound.x,i=i&&this.lowerBound.y<=t.lowerBound.y,i=i&&t.upperBound.x<=this.upperBound.x,i=i&&t.upperBound.y<=this.upperBound.y},o.prototype.extend=function(t){o.extend(this,t)},o.extend=function(t,i){t.lowerBound.x-=i,t.lowerBound.y-=i,t.upperBound.x+=i,t.upperBound.y+=i},o.testOverlap=function(t,i){var e=i.lowerBound.x-t.upperBound.x,o=t.lowerBound.x-i.upperBound.x,s=i.lowerBound.y-t.upperBound.y,n=t.lowerBound.y-i.upperBound.y;return!(e>0||s>0||o>0||n>0)},o.areEqual=function(t,i){return n.areEqual(t.lowerBound,i.lowerBound)&&n.areEqual(t.upperBound,i.upperBound)},o.diff=function(t,i){var e=s.max(0,s.min(t.upperBound.x,i.upperBound.x)-s.max(i.lowerBound.x,t.lowerBound.x)),o=s.max(0,s.min(t.upperBound.y,i.upperBound.y)-s.max(i.lowerBound.y,t.lowerBound.y));return(t.upperBound.x-t.lowerBound.x)*(t.upperBound.y-t.lowerBound.y)+(i.upperBound.x-i.lowerBound.x)*(i.upperBound.y-i.lowerBound.y)-e*o},o.prototype.rayCast=function(t,i){for(var e=-1/0,o=1/0,r=i.p1,a=n.sub(i.p2,i.p1),m=n.abs(a),h=n.zero(),c="x";null!==c;c="x"===c?"y":null)if(m.x<s.EPSILON){if(r[c]<this.lowerBound[c]||this.upperBound[c]<r[c])return!1}else{var l=1/a[c],_=(this.lowerBound[c]-r[c])*l,u=(this.upperBound[c]-r[c])*l,p=-1;if(_>u){var d=_;_=u,u=d,p=1}if(_>e&&(h.setZero(),h[c]=p,e=_),o=s.min(o,u),e>o)return!1}return!(e<0||i.maxFraction<e)&&(t.fraction=e,t.normal=h,!0)},o.prototype.toString=function(){return JSON.stringify(this)}},{"../Settings":7,"../common/Math":18,"../common/Vec2":23}],12:[function(t,i,e){function o(){this.m_tree=new a,this.m_proxyCount=0,this.m_moveBuffer=[],this.queryCallback=this.queryCallback.bind(this)}t("../Settings");var s=t("../util/common"),n=t("../common/Math"),r=t("./AABB"),a=t("./DynamicTree");i.exports=o,o.prototype.getUserData=function(t){return this.m_tree.getUserData(t)},o.prototype.testOverlap=function(t,i){var e=this.m_tree.getFatAABB(t),o=this.m_tree.getFatAABB(i);return r.testOverlap(e,o)},o.prototype.getFatAABB=function(t){return this.m_tree.getFatAABB(t)},o.prototype.getProxyCount=function(){return this.m_proxyCount},o.prototype.getTreeHeight=function(){return this.m_tree.getHeight()},o.prototype.getTreeBalance=function(){return this.m_tree.getMaxBalance()},o.prototype.getTreeQuality=function(){return this.m_tree.getAreaRatio()},o.prototype.query=function(t,i){this.m_tree.query(t,i)},o.prototype.rayCast=function(t,i){this.m_tree.rayCast(t,i)},o.prototype.shiftOrigin=function(t){this.m_tree.shiftOrigin(t)},o.prototype.createProxy=function(t,i){s.assert(r.isValid(t));var e=this.m_tree.createProxy(t,i);return this.m_proxyCount++,this.bufferMove(e),e},o.prototype.destroyProxy=function(t){this.unbufferMove(t),this.m_proxyCount--,this.m_tree.destroyProxy(t)},o.prototype.moveProxy=function(t,i,e){s.assert(r.isValid(i));this.m_tree.moveProxy(t,i,e)&&this.bufferMove(t)},o.prototype.touchProxy=function(t){this.bufferMove(t)},o.prototype.bufferMove=function(t){this.m_moveBuffer.push(t)},o.prototype.unbufferMove=function(t){for(var i=0;i<this.m_moveBuffer.length;++i)this.m_moveBuffer[i]==t&&(this.m_moveBuffer[i]=null)},o.prototype.updatePairs=function(t){for(s.assert("function"==typeof t),this.m_callback=t;this.m_moveBuffer.length>0;)if(this.m_queryProxyId=this.m_moveBuffer.pop(),null!==this.m_queryProxyId){var i=this.m_tree.getFatAABB(this.m_queryProxyId);this.m_tree.query(i,this.queryCallback)}},o.prototype.queryCallback=function(t){if(t==this.m_queryProxyId)return!0;var i=n.min(t,this.m_queryProxyId),e=n.max(t,this.m_queryProxyId),o=this.m_tree.getUserData(i),s=this.m_tree.getUserData(e);return this.m_callback(o,s),!0}},{"../Settings":7,"../common/Math":18,"../util/common":51,"./AABB":11,"./DynamicTree":14}],13:[function(t,i,e){function o(){this.proxyA=new a,this.proxyB=new a,this.transformA=null,this.transformB=null,this.useRadii=!1}function s(){this.pointA=p.zero(),this.pointB=p.zero(),this.distance,this.iterations}function n(){this.metric=0,this.indexA=[],this.indexB=[],this.count=0}function r(t,i,e){++_.gjkCalls;var o=e.proxyA,s=e.proxyB,n=e.transformA,r=e.transformB,a=new h;a.readCache(i,o,n,s,r);for(var m=a.m_v,l=c.maxDistnceIterations,f=[],v=[],x=0,g=0;g<l;){x=a.m_count;for(var b=0;b<x;++b)f[b]=m[b].indexA,v[b]=m[b].indexB;if(a.solve(),3==a.m_count)break;(S=a.getClosestPoint()).lengthSquared();var A=a.getSearchDirection();if(A.lengthSquared()<u.EPSILON*u.EPSILON)break;var B=m[a.m_count];B.indexA=o.getSupport(d.mulTVec2(n.q,p.neg(A))),B.wA=y.mulVec2(n,o.getVertex(B.indexA)),B.indexB=s.getSupport(d.mulTVec2(r.q,A)),B.wB=y.mulVec2(r,s.getVertex(B.indexB)),B.w=p.sub(B.wB,B.wA),++g,++_.gjkIters;var w=!1;for(b=0;b<x;++b)if(B.indexA==f[b]&&B.indexB==v[b]){w=!0;break}if(w)break;++a.m_count}if(_.gjkMaxIters=u.max(_.gjkMaxIters,g),a.getWitnessPoints(t.pointA,t.pointB),t.distance=p.distance(t.pointA,t.pointB),t.iterations=g,a.writeCache(i),e.useRadii){var M=o.m_radius,C=s.m_radius;if(t.distance>M+C&&t.distance>u.EPSILON){t.distance-=M+C;var V=p.sub(t.pointB,t.pointA);V.normalize(),t.pointA.addMul(M,V),t.pointB.subMul(C,V)}else{var S=p.mid(t.pointA,t.pointB);t.pointA.set(S),t.pointB.set(S),t.distance=0}}}function a(){this.m_buffer=[],this.m_vertices=[],this.m_count=0,this.m_radius=0}function m(){this.indexA,this.indexB,this.wA=p.zero(),this.wB=p.zero(),this.w=p.zero(),this.a}function h(){this.m_v1=new m,this.m_v2=new m,this.m_v3=new m,this.m_v=[this.m_v1,this.m_v2,this.m_v3],this.m_count}i.exports=r,i.exports.Input=o,i.exports.Output=s,i.exports.Proxy=a,i.exports.Cache=n;var c=t("../Settings"),l=t("../util/common"),_=t("../common/stats"),u=t("../common/Math"),p=t("../common/Vec2"),d=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),y=(t("../common/Sweep"),t("../common/Transform"));t("../common/Velocity"),t("../common/Position");_.gjkCalls=0,_.gjkIters=0,_.gjkMaxIters=0,a.prototype.getVertexCount=function(){return this.m_count},a.prototype.getVertex=function(t){return l.assert(0<=t&&t<this.m_count),this.m_vertices[t]},a.prototype.getSupport=function(t){for(var i=0,e=p.dot(this.m_vertices[0],t),o=0;o<this.m_count;++o){var s=p.dot(this.m_vertices[o],t);s>e&&(i=o,e=s)}return i},a.prototype.getSupportVertex=function(t){return this.m_vertices[this.getSupport(t)]},a.prototype.set=function(t,i){l.assert("function"==typeof t.computeDistanceProxy),t.computeDistanceProxy(this,i)},m.prototype.set=function(t){this.indexA=t.indexA,this.indexB=t.indexB,this.wA=p.clone(t.wA),this.wB=p.clone(t.wB),this.w=p.clone(t.w),this.a=t.a},h.prototype.print=function(){return 3==this.m_count?["+"+this.m_count,this.m_v1.a,this.m_v1.wA.x,this.m_v1.wA.y,this.m_v1.wB.x,this.m_v1.wB.y,this.m_v2.a,this.m_v2.wA.x,this.m_v2.wA.y,this.m_v2.wB.x,this.m_v2.wB.y,this.m_v3.a,this.m_v3.wA.x,this.m_v3.wA.y,this.m_v3.wB.x,this.m_v3.wB.y].toString():2==this.m_count?["+"+this.m_count,this.m_v1.a,this.m_v1.wA.x,this.m_v1.wA.y,this.m_v1.wB.x,this.m_v1.wB.y,this.m_v2.a,this.m_v2.wA.x,this.m_v2.wA.y,this.m_v2.wB.x,this.m_v2.wB.y].toString():1==this.m_count?["+"+this.m_count,this.m_v1.a,this.m_v1.wA.x,this.m_v1.wA.y,this.m_v1.wB.x,this.m_v1.wB.y].toString():"+"+this.m_count},h.prototype.readCache=function(t,i,e,o,s){l.assert(t.count<=3),this.m_count=t.count;for(var n=0;n<this.m_count;++n){(c=this.m_v[n]).indexA=t.indexA[n],c.indexB=t.indexB[n];var r=i.getVertex(c.indexA),a=o.getVertex(c.indexB);c.wA=y.mulVec2(e,r),c.wB=y.mulVec2(s,a),c.w=p.sub(c.wB,c.wA),c.a=0}if(this.m_count>1){var m=t.metric,h=this.getMetric();(h<.5*m||2*m<h||h<u.EPSILON)&&(this.m_count=0)}if(0==this.m_count){var c;(c=this.m_v[0]).indexA=0,c.indexB=0;r=i.getVertex(0),a=o.getVertex(0);c.wA=y.mulVec2(e,r),c.wB=y.mulVec2(s,a),c.w=p.sub(c.wB,c.wA),c.a=1,this.m_count=1}},h.prototype.writeCache=function(t){t.metric=this.getMetric(),t.count=this.m_count;for(var i=0;i<this.m_count;++i)t.indexA[i]=this.m_v[i].indexA,t.indexB[i]=this.m_v[i].indexB},h.prototype.getSearchDirection=function(){switch(this.m_count){case 1:return p.neg(this.m_v1.w);case 2:var t=p.sub(this.m_v2.w,this.m_v1.w);return p.cross(t,p.neg(this.m_v1.w))>0?p.cross(1,t):p.cross(t,1);default:return l.assert(!1),p.zero()}},h.prototype.getClosestPoint=function(){switch(this.m_count){case 0:return l.assert(!1),p.zero();case 1:return p.clone(this.m_v1.w);case 2:return p.combine(this.m_v1.a,this.m_v1.w,this.m_v2.a,this.m_v2.w);case 3:return p.zero();default:return l.assert(!1),p.zero()}},h.prototype.getWitnessPoints=function(t,i){switch(this.m_count){case 0:l.assert(!1);break;case 1:t.set(this.m_v1.wA),i.set(this.m_v1.wB);break;case 2:t.setCombine(this.m_v1.a,this.m_v1.wA,this.m_v2.a,this.m_v2.wA),i.setCombine(this.m_v1.a,this.m_v1.wB,this.m_v2.a,this.m_v2.wB);break;case 3:t.setCombine(this.m_v1.a,this.m_v1.wA,this.m_v2.a,this.m_v2.wA),t.addMul(this.m_v3.a,this.m_v3.wA),i.set(t);break;default:l.assert(!1)}},h.prototype.getMetric=function(){switch(this.m_count){case 0:return l.assert(!1),0;case 1:return 0;case 2:return p.distance(this.m_v1.w,this.m_v2.w);case 3:return p.cross(p.sub(this.m_v2.w,this.m_v1.w),p.sub(this.m_v3.w,this.m_v1.w));default:return l.assert(!1),0}},h.prototype.solve=function(){switch(this.m_count){case 1:break;case 2:this.solve2();break;case 3:this.solve3();break;default:l.assert(!1)}},h.prototype.solve2=function(){var t=this.m_v1.w,i=this.m_v2.w,e=p.sub(i,t),o=-p.dot(t,e);if(o<=0)return this.m_v1.a=1,void(this.m_count=1);var s=p.dot(i,e);if(s<=0)return this.m_v2.a=1,this.m_count=1,void this.m_v1.set(this.m_v2);var n=1/(s+o);this.m_v1.a=s*n,this.m_v2.a=o*n,this.m_count=2},h.prototype.solve3=function(){var t=this.m_v1.w,i=this.m_v2.w,e=this.m_v3.w,o=p.sub(i,t),s=p.dot(t,o),n=p.dot(i,o),r=-s,a=p.sub(e,t),m=p.dot(t,a),h=p.dot(e,a),c=-m,l=p.sub(e,i),_=p.dot(i,l),u=p.dot(e,l),d=-_,y=p.cross(o,a),f=y*p.cross(i,e),v=y*p.cross(e,t),x=y*p.cross(t,i);if(r<=0&&c<=0)return this.m_v1.a=1,void(this.m_count=1);if(n>0&&r>0&&x<=0){var g=1/(n+r);return this.m_v1.a=n*g,this.m_v2.a=r*g,void(this.m_count=2)}if(h>0&&c>0&&v<=0){var b=1/(h+c);return this.m_v1.a=h*b,this.m_v3.a=c*b,this.m_count=2,void this.m_v2.set(this.m_v3)}if(n<=0&&d<=0)return this.m_v2.a=1,this.m_count=1,void this.m_v1.set(this.m_v2);if(h<=0&&u<=0)return this.m_v3.a=1,this.m_count=1,void this.m_v1.set(this.m_v3);if(u>0&&d>0&&f<=0){var A=1/(u+d);return this.m_v2.a=u*A,this.m_v3.a=d*A,this.m_count=2,void this.m_v1.set(this.m_v3)}var B=1/(f+v+x);this.m_v1.a=f*B,this.m_v2.a=v*B,this.m_v3.a=x*B,this.m_count=3},r.testOverlap=function(t,i,e,a,m,h){var c=new o;c.proxyA.set(t,i),c.proxyB.set(e,a),c.transformA=m,c.transformB=h,c.useRadii=!0;var l=new n,_=new s;return r(_,l,c),_.distance<10*u.EPSILON}},{"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../common/stats":26,"../util/common":51}],14:[function(t,i,e){function o(t){this.id=t,this.aabb=new c,this.userData=null,this.parent=null,this.child1=null,this.child2=null,this.height=-1,this.toString=function(){return this.id+": "+this.userData}}function s(){this.m_root=null,this.m_nodes={},this.m_lastProxyId=0}var n=t("../Settings"),r=t("../util/common"),a=t("../util/Pool"),m=t("../common/Vec2"),h=t("../common/Math"),c=t("./AABB");i.exports=s;var l=new a({create:function(){return new c},release:function(t){t.lowerBound.setZero(),t.upperBound.setZero()}}),_=new a({create:function(){return new o}});o.prototype.isLeaf=function(){return null==this.child1},s.prototype.getUserData=function(t){var i=this.m_nodes[t];return r.assert(!!i),i.userData},s.prototype.getFatAABB=function(t){var i=this.m_nodes[t];return r.assert(!!i),i.aabb},s.prototype.allocateNode=function(){var t=_.allocate();return t.id=++this.m_lastProxyId,t.userData=null,t.parent=null,t.child1=null,t.child2=null,t.height=-1,this.m_nodes[t.id]=t,t},s.prototype.freeNode=function(t){_.release(t),t.height=-1,delete this.m_nodes[t.id]},s.prototype.createProxy=function(t,i){r.assert(c.isValid(t));var e=this.allocateNode();return e.aabb.set(t),e.aabb.extend(n.aabbExtension),e.userData=i,e.height=0,this.insertLeaf(e),e.id},s.prototype.destroyProxy=function(t){var i=this.m_nodes[t];r.assert(!!i),r.assert(i.isLeaf()),this.removeLeaf(i),this.freeNode(i)},s.prototype.moveProxy=function(t,i,e){r.assert(c.isValid(i)),r.assert(!e||m.isValid(e));var o=this.m_nodes[t];return r.assert(!!o),r.assert(o.isLeaf()),!o.aabb.contains(i)&&(this.removeLeaf(o),o.aabb.set(i),i=o.aabb,c.extend(i,n.aabbExtension),e.x<0?i.lowerBound.x+=e.x*n.aabbMultiplier:i.upperBound.x+=e.x*n.aabbMultiplier,e.y<0?i.lowerBound.y+=e.y*n.aabbMultiplier:i.upperBound.y+=e.y*n.aabbMultiplier,this.insertLeaf(o),!0)},s.prototype.insertLeaf=function(t){if(r.assert(c.isValid(t.aabb)),null==this.m_root)return this.m_root=t,void(this.m_root.parent=null);for(var i=t.aabb,e=this.m_root;0==e.isLeaf();){var o=e.child1,s=e.child2,n=e.aabb.getPerimeter(),a=l.allocate();a.combine(e.aabb,i);var m=a.getPerimeter();l.release(a);var _,u=2*m,p=2*(m-n);if(o.isLeaf()){(f=l.allocate()).combine(i,o.aabb),_=f.getPerimeter()+p,l.release(f)}else{(f=l.allocate()).combine(i,o.aabb);var d=o.aabb.getPerimeter();_=f.getPerimeter()-d+p,l.release(f)}var y;if(s.isLeaf()){(f=l.allocate()).combine(i,s.aabb),y=f.getPerimeter()+p,l.release(f)}else{var f;(f=l.allocate()).combine(i,s.aabb);d=s.aabb.getPerimeter();y=f.getPerimeter()-d+p,l.release(f)}if(u<_&&u<y)break;e=_<y?o:s}var v=e,x=v.parent,g=this.allocateNode();for(g.parent=x,g.userData=null,g.aabb.combine(i,v.aabb),g.height=v.height+1,null!=x?(x.child1==v?x.child1=g:x.child2=g,g.child1=v,g.child2=t,v.parent=g,t.parent=g):(g.child1=v,g.child2=t,v.parent=g,t.parent=g,this.m_root=g),e=t.parent;null!=e;){o=(e=this.balance(e)).child1,s=e.child2;r.assert(null!=o),r.assert(null!=s),e.height=1+h.max(o.height,s.height),e.aabb.combine(o.aabb,s.aabb),e=e.parent}},s.prototype.removeLeaf=function(t){if(t!=this.m_root){var i,e=t.parent,o=e.parent;if(i=e.child1==t?e.child2:e.child1,null!=o){o.child1==e?o.child1=i:o.child2=i,i.parent=o,this.freeNode(e);for(var s=o;null!=s;){var n=(s=this.balance(s)).child1,r=s.child2;s.aabb.combine(n.aabb,r.aabb),s.height=1+h.max(n.height,r.height),s=s.parent}}else this.m_root=i,i.parent=null,this.freeNode(e)}else this.m_root=null},s.prototype.balance=function(t){r.assert(null!=t);var i=t;if(i.isLeaf()||i.height<2)return t;var e=i.child1,o=i.child2,s=o.height-e.height;if(s>1){var n=o.child1,a=o.child2;return o.child1=i,o.parent=i.parent,i.parent=o,null!=o.parent?o.parent.child1==t?o.parent.child1=o:o.parent.child2=o:this.m_root=o,n.height>a.height?(o.child2=n,i.child2=a,a.parent=i,i.aabb.combine(e.aabb,a.aabb),o.aabb.combine(i.aabb,n.aabb),i.height=1+h.max(e.height,a.height),o.height=1+h.max(i.height,n.height)):(o.child2=a,i.child2=n,n.parent=i,i.aabb.combine(e.aabb,n.aabb),o.aabb.combine(i.aabb,a.aabb),i.height=1+h.max(e.height,n.height),o.height=1+h.max(i.height,a.height)),o}if(s<-1){var m=e.child1,c=e.child2;return e.child1=i,e.parent=i.parent,i.parent=e,null!=e.parent?e.parent.child1==i?e.parent.child1=e:e.parent.child2=e:this.m_root=e,m.height>c.height?(e.child2=m,i.child1=c,c.parent=i,i.aabb.combine(o.aabb,c.aabb),e.aabb.combine(i.aabb,m.aabb),i.height=1+h.max(o.height,c.height),e.height=1+h.max(i.height,m.height)):(e.child2=c,i.child1=m,m.parent=i,i.aabb.combine(o.aabb,m.aabb),e.aabb.combine(i.aabb,c.aabb),i.height=1+h.max(o.height,m.height),e.height=1+h.max(i.height,c.height)),e}return i},s.prototype.getHeight=function(){return null==this.m_root?0:this.m_root.height},s.prototype.getAreaRatio=function(){if(null==this.m_root)return 0;for(var t,i=this.m_root.aabb.getPerimeter(),e=0,o=d.allocate().preorder();t=o.next();)t.height<0||(e+=t.aabb.getPerimeter());return d.release(o),e/i},s.prototype.computeHeight=function(t){var i;if((i=void 0!==t?this.m_nodes[t]:this.m_root).isLeaf())return 0;var e=ComputeHeight(i.child1),o=ComputeHeight(i.child2);return 1+h.max(e,o)},s.prototype.validateStructure=function(t){if(null!=t){t==this.m_root&&r.assert(null==t.parent);var i=t.child1,e=t.child2;if(t.isLeaf())return r.assert(null==i),r.assert(null==e),void r.assert(0==t.height);r.assert(i.parent==t),r.assert(e.parent==t),this.validateStructure(i),this.validateStructure(e)}},s.prototype.validateMetrics=function(t){if(null!=t){var i=t.child1,e=t.child2;if(t.isLeaf())return r.assert(null==i),r.assert(null==e),void r.assert(0==t.height);var o=this.m_nodes[i].height,s=this.m_nodes[e].height,n=1+h.max(o,s);r.assert(t.height==n),r.assert(c.areEqual((new c).combine(i.aabb,e.aabb),t.aabb)),this.validateMetrics(i),this.validateMetrics(e)}},s.prototype.validate=function(){ValidateStructure(this.m_root),ValidateMetrics(this.m_root),r.assert(this.getHeight()==this.computeHeight())},s.prototype.getMaxBalance=function(){for(var t,i=0,e=d.allocate().preorder();t=e.next();)if(!(t.height<=1)){r.assert(0==t.isLeaf());var o=h.abs(t.child2.height-t.child1.height);i=h.max(i,o)}return d.release(e),i},s.prototype.rebuildBottomUp=function(){for(var t,i=[],e=0,o=d.allocate().preorder();t=o.next();)t.height<0||(t.isLeaf()?(t.parent=null,i[e]=t,++e):this.freeNode(t));for(d.release(o);e>1;){for(var s=1/0,n=-1,r=-1,a=0;a<e;++a)for(var m=i[a].aabb,c=a+1;c<e;++c){var _=i[c].aabb,u=l.allocate();u.combine(m,_);var p=u.getPerimeter();p<s&&(n=a,r=c,s=p),l.release(u)}var y=i[n],f=i[r],v=this.allocateNode();v.child1=y,v.child2=f,v.height=1+h.max(y.height,f.height),v.aabb.combine(y.aabb,f.aabb),v.parent=null,y.parent=v,f.parent=v,i[r]=i[e-1],i[n]=v,--e}this.m_root=i[0],this.validate()},s.prototype.shiftOrigin=function(t){for(var i,e=d.allocate().preorder();i=e.next();){var o=i.aabb;o.lowerBound.x-=t.x,o.lowerBound.y-=t.y,o.upperBound.x-=t.x,o.upperBound.y-=t.y}d.release(e)},s.prototype.query=function(t,i){r.assert("function"==typeof i);var e=p.allocate();for(e.push(this.m_root);e.length>0;){var o=e.pop();if(null!=o&&c.testOverlap(o.aabb,t))if(o.isLeaf()){if(0==i(o.id))return}else e.push(o.child1),e.push(o.child2)}p.release(e)},s.prototype.rayCast=function(t,i){r.assert("function"==typeof i);var e=t.p1,o=t.p2,s=m.sub(o,e);r.assert(s.lengthSquared()>0),s.normalize();var n=m.cross(1,s),a=m.abs(n),l=t.maxFraction,_=new c,d=m.combine(1-l,e,l,o);_.combinePoints(e,d);var y=p.allocate(),f=u.allocate();for(y.push(this.m_root);y.length>0;){var v=y.pop();if(null!=v&&0!=c.testOverlap(v.aabb,_)){var x=v.aabb.getCenter(),g=v.aabb.getExtents();if(!(h.abs(m.dot(n,m.sub(e,x)))-m.dot(a,g)>0))if(v.isLeaf()){f.p1=m.clone(t.p1),f.p2=m.clone(t.p2),f.maxFraction=l;var b=i(f,v.id);if(0==b)return;b>0&&(l=b,d=m.combine(1-l,e,l,o),_.combinePoints(e,d))}else y.push(v.child1),y.push(v.child2)}}p.release(y),u.release(f)};var u=new a({create:function(){return{}},release:function(t){}}),p=new a({create:function(){return[]},release:function(t){t.length=0}}),d=new a({create:function(){return new function(){var t=[],i=[];return{preorder:function(e){return t.length=0,t.push(e),i.length=0,i.push(0),this},next:function(){for(;t.length>0;){var e=t.length-1,o=t[e];if(0===i[e])return i[e]=1,o;if(1===i[e]&&(i[e]=2,o.child1))return t.push(o.child1),i.push(1),o.child1;if(2===i[e]&&(i[e]=3,o.child2))return t.push(o.child2),i.push(1),o.child2;t.pop(),i.pop()}},close:function(){t.length=0}}}},release:function(t){t.close()}})},{"../Settings":7,"../common/Math":18,"../common/Vec2":23,"../util/Pool":49,"../util/common":51,"./AABB":11}],15:[function(t,i,e){function o(){this.state,this.t}function s(){this.m_proxyA=new v,this.m_proxyB=new v,this.m_sweepA,this.m_sweepB,this.m_type,this.m_localPoint=l.zero(),this.m_axis=l.zero()}var n=!0;i.exports=function(t,i){var e=m.now();++h.toiCalls,t.state=o.e_unknown,t.t=i.tMax;var l=i.proxyA,_=i.proxyB,u=i.sweepA,v=i.sweepB;u.normalize(),v.normalize();var g=i.tMax,b=l.m_radius+_.m_radius,A=c.max(r.linearSlop,b-3*r.linearSlop),B=.25*r.linearSlop;n&&a.assert(A>B);var w=0,M=r.maxTOIIterations,C=0,V=new x,S=new y;for(S.proxyA=i.proxyA,S.proxyB=i.proxyB,S.useRadii=!1;;){var I=p.identity(),P=p.identity();u.getTransform(I,w),v.getTransform(P,w),S.transformA=I,S.transformB=P;var T=new f;if(d(T,V,S),T.distance<=0){t.state=o.e_overlapped,t.t=0;break}if(T.distance<A+B){t.state=o.e_touching,t.t=w;break}var z=new s;z.initialize(V,l,u,_,v,w);for(var k=!1,L=g,q=0;;){var F=z.findMinSeparation(L);if(z.indexA,z.indexB,F>A+B){t.state=o.e_separated,t.t=g,k=!0;break}if(F>A-B){w=L;break}var R=z.evaluate(w);if(z.indexA,z.indexB,R<A-B){t.state=o.e_failed,t.t=w,k=!0;break}if(R<=A+B){t.state=o.e_touching,t.t=w,k=!0;break}for(var E=0,j=w,D=L;;){var Y;Y=1&E?j+(A-R)*(D-j)/(F-R):.5*(j+D),++E,++h.toiRootIters;var J=z.evaluate(Y);if(z.indexA,z.indexB,c.abs(J-A)<B){L=Y;break}if(J>A?(j=Y,R=J):(D=Y,F=J),50==E)break}if(h.toiMaxRootIters=c.max(h.toiMaxRootIters,E),++q==r.maxPolygonVertices)break}if(++C,++h.toiIters,k)break;if(C==M){t.state=o.e_failed,t.t=w;break}}h.toiMaxIters=c.max(h.toiMaxIters,C);var N=m.diff(e);h.toiMaxTime=c.max(h.toiMaxTime,N),h.toiTime+=N},i.exports.Input=function(){this.proxyA=new v,this.proxyB=new v,this.sweepA=new u,this.sweepB=new u,this.tMax},i.exports.Output=o;var r=t("../Settings"),a=t("../util/common"),m=t("../util/Timer"),h=t("../common/stats"),c=t("../common/Math"),l=t("../common/Vec2"),_=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),u=t("../common/Sweep"),p=t("../common/Transform"),d=(t("../common/Velocity"),t("../common/Position"),t("./Distance")),y=d.Input,f=d.Output,v=d.Proxy,x=d.Cache;o.e_unknown=0,o.e_failed=1,o.e_overlapped=2,o.e_touching=3,o.e_separated=4,h.toiTime=0,h.toiMaxTime=0,h.toiCalls=0,h.toiIters=0,h.toiMaxIters=0,h.toiRootIters=0,h.toiMaxRootIters=0;s.prototype.initialize=function(t,i,e,o,s,r){this.m_proxyA=i,this.m_proxyB=o;var m=t.count;n&&a.assert(0<m&&m<3),this.m_sweepA=e,this.m_sweepB=s;var h=p.identity(),c=p.identity();if(this.m_sweepA.getTransform(h,r),this.m_sweepB.getTransform(c,r),1==m){this.m_type=1;var u=this.m_proxyA.getVertex(t.indexA[0]),d=this.m_proxyB.getVertex(t.indexB[0]),y=p.mulVec2(h,u),f=p.mulVec2(c,d);this.m_axis.setCombine(1,f,-1,y);return B=this.m_axis.normalize()}if(t.indexA[0]==t.indexA[1]){this.m_type=3;var v=o.getVertex(t.indexB[0]),x=o.getVertex(t.indexB[1]);this.m_axis=l.cross(l.sub(x,v),1),this.m_axis.normalize();var g=_.mulVec2(c.q,this.m_axis);this.m_localPoint=l.mid(v,x);f=p.mulVec2(c,this.m_localPoint),u=i.getVertex(t.indexA[0]),y=p.mulVec2(h,u);return(B=l.dot(y,g)-l.dot(f,g))<0&&(this.m_axis=l.neg(this.m_axis),B=-B),B}this.m_type=2;var b=this.m_proxyA.getVertex(t.indexA[0]),A=this.m_proxyA.getVertex(t.indexA[1]);this.m_axis=l.cross(l.sub(A,b),1),this.m_axis.normalize();g=_.mulVec2(h.q,this.m_axis);this.m_localPoint=l.mid(b,A);var B;y=p.mulVec2(h,this.m_localPoint),d=this.m_proxyB.getVertex(t.indexB[0]),f=p.mulVec2(c,d);return(B=l.dot(f,g)-l.dot(y,g))<0&&(this.m_axis=l.neg(this.m_axis),B=-B),B},s.prototype.compute=function(t,i){var e=p.identity(),o=p.identity();switch(this.m_sweepA.getTransform(e,i),this.m_sweepB.getTransform(o,i),this.m_type){case 1:if(t){var s=_.mulTVec2(e.q,this.m_axis),r=_.mulTVec2(o.q,l.neg(this.m_axis));this.indexA=this.m_proxyA.getSupport(s),this.indexB=this.m_proxyB.getSupport(r)}var m=this.m_proxyA.getVertex(this.indexA),h=this.m_proxyB.getVertex(this.indexB),c=p.mulVec2(e,m),u=p.mulVec2(o,h);return l.dot(u,this.m_axis)-l.dot(c,this.m_axis);case 2:var d=_.mulVec2(e.q,this.m_axis);c=p.mulVec2(e,this.m_localPoint);if(t){r=_.mulTVec2(o.q,l.neg(d));this.indexA=-1,this.indexB=this.m_proxyB.getSupport(r)}h=this.m_proxyB.getVertex(this.indexB),u=p.mulVec2(o,h);return l.dot(u,d)-l.dot(c,d);case 3:d=_.mulVec2(o.q,this.m_axis),u=p.mulVec2(o,this.m_localPoint);if(t){s=_.mulTVec2(e.q,l.neg(d));this.indexB=-1,this.indexA=this.m_proxyA.getSupport(s)}m=this.m_proxyA.getVertex(this.indexA),c=p.mulVec2(e,m);return l.dot(c,d)-l.dot(u,d);default:return n&&a.assert(!1),t&&(this.indexA=-1,this.indexB=-1),0}},s.prototype.findMinSeparation=function(t){return this.compute(!0,t)},s.prototype.evaluate=function(t){return this.compute(!1,t)}},{"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../common/stats":26,"../util/Timer":50,"../util/common":51,"./Distance":13}],16:[function(t,i,e){function o(t,i,e,o){"object"==typeof t&&null!==t?(this.ex=n.clone(t),this.ey=n.clone(i)):"number"==typeof t?(this.ex=n.neo(t,e),this.ey=n.neo(i,o)):(this.ex=n.zero(),this.ey=n.zero())}i.exports=o;var s=t("../util/common"),n=(t("./Math"),t("./Vec2"));o.prototype.toString=function(){return JSON.stringify(this)},o.isValid=function(t){return t&&n.isValid(t.ex)&&n.isValid(t.ey)},o.assert=function(t){if(!o.isValid(t))throw new Error("Invalid Mat22!")},o.prototype.set=function(t,i,e,n){"number"==typeof t&&"number"==typeof i&&"number"==typeof e&&"number"==typeof n?(this.ex.set(t,e),this.ey.set(i,n)):"object"==typeof t&&"object"==typeof i?(this.ex.set(t),this.ey.set(i)):"object"==typeof t?(o.assert(t),this.ex.set(t.ex),this.ey.set(t.ey)):s.assert(!1)},o.prototype.setIdentity=function(){this.ex.x=1,this.ey.x=0,this.ex.y=0,this.ey.y=1},o.prototype.setZero=function(){this.ex.x=0,this.ey.x=0,this.ex.y=0,this.ey.y=0},o.prototype.getInverse=function(){var t=this.ex.x,i=this.ey.x,e=this.ex.y,s=this.ey.y,n=t*s-i*e;0!=n&&(n=1/n);var r=new o;return r.ex.x=n*s,r.ey.x=-n*i,r.ex.y=-n*e,r.ey.y=n*t,r},o.prototype.solve=function(t){n.assert(t);var i=this.ex.x,e=this.ey.x,o=this.ex.y,s=this.ey.y,r=i*s-e*o;0!=r&&(r=1/r);var a=n.zero();return a.x=r*(s*t.x-e*t.y),a.y=r*(i*t.y-o*t.x),a},o.mul=function(t,i){if(i&&"x"in i&&"y"in i){n.assert(i);var e=t.ex.x*i.x+t.ey.x*i.y,r=t.ex.y*i.x+t.ey.y*i.y;return n.neo(e,r)}if(i&&"ex"in i&&"ey"in i)return o.assert(i),new o(n.mul(t,i.ex),n.mul(t,i.ey));s.assert(!1)},o.mulVec2=function(t,i){n.assert(i);var e=t.ex.x*i.x+t.ey.x*i.y,o=t.ex.y*i.x+t.ey.y*i.y;return n.neo(e,o)},o.mulVec2_=function(t,i,e){n.assert(i);var o=t.ex.x*i.x+t.ey.x*i.y,s=t.ex.y*i.x+t.ey.y*i.y;return e.set(o,s)},o.mulMat22=function(t,i){return o.assert(i),new o(n.mul(t,i.ex),n.mul(t,i.ey))},o.mulT=function(t,i){if(i&&"x"in i&&"y"in i)return n.assert(i),n.neo(n.dot(i,t.ex),n.dot(i,t.ey));if(i&&"ex"in i&&"ey"in i){o.assert(i);return new o(n.neo(n.dot(t.ex,i.ex),n.dot(t.ey,i.ex)),n.neo(n.dot(t.ex,i.ey),n.dot(t.ey,i.ey)))}s.assert(!1)},o.mulTVec2=function(t,i){return o.assert(t),n.assert(i),n.neo(n.dot(i,t.ex),n.dot(i,t.ey))},o.mulTMat22=function(t,i){o.assert(t),o.assert(i);return new o(n.neo(n.dot(t.ex,i.ex),n.dot(t.ey,i.ex)),n.neo(n.dot(t.ex,i.ey),n.dot(t.ey,i.ey)))},o.abs=function(t){return o.assert(t),new o(n.abs(t.ex),n.abs(t.ey))},o.add=function(t,i){return o.assert(t),o.assert(i),new o(n.add(t.ex+i.ex),n.add(t.ey+i.ey))}},{"../util/common":51,"./Math":18,"./Vec2":23}],17:[function(t,i,e){function o(t,i,e){"object"==typeof t&&null!==t?(this.ex=r.clone(t),this.ey=r.clone(i),this.ez=r.clone(e)):(this.ex=r(),this.ey=r(),this.ez=r())}i.exports=o;var s=t("../util/common"),n=(t("./Math"),t("./Vec2")),r=t("./Vec3");o.prototype.toString=function(){return JSON.stringify(this)},o.isValid=function(t){return t&&r.isValid(t.ex)&&r.isValid(t.ey)&&r.isValid(t.ez)},o.assert=function(t){if(!o.isValid(t))throw new Error("Invalid Mat33!")},o.prototype.setZero=function(){return this.ex.setZero(),this.ey.setZero(),this.ez.setZero(),this},o.prototype.solve33=function(t){var i=r.dot(this.ex,r.cross(this.ey,this.ez));0!=i&&(i=1/i);var e=new r;return e.x=i*r.dot(t,r.cross(this.ey,this.ez)),e.y=i*r.dot(this.ex,r.cross(t,this.ez)),e.z=i*r.dot(this.ex,r.cross(this.ey,t)),e},o.prototype.solve22=function(t){var i=this.ex.x,e=this.ey.x,o=this.ex.y,s=this.ey.y,r=i*s-e*o;0!=r&&(r=1/r);var a=n.zero();return a.x=r*(s*t.x-e*t.y),a.y=r*(i*t.y-o*t.x),a},o.prototype.getInverse22=function(t){var i=this.ex.x,e=this.ey.x,o=this.ex.y,s=this.ey.y,n=i*s-e*o;0!=n&&(n=1/n),t.ex.x=n*s,t.ey.x=-n*e,t.ex.z=0,t.ex.y=-n*o,t.ey.y=n*i,t.ey.z=0,t.ez.x=0,t.ez.y=0,t.ez.z=0},o.prototype.getSymInverse33=function(t){var i=r.dot(this.ex,r.cross(this.ey,this.ez));0!=i&&(i=1/i);var e=this.ex.x,o=this.ey.x,s=this.ez.x,n=this.ey.y,a=this.ez.y,m=this.ez.z;t.ex.x=i*(n*m-a*a),t.ex.y=i*(s*a-o*m),t.ex.z=i*(o*a-s*n),t.ey.x=t.ex.y,t.ey.y=i*(e*m-s*s),t.ey.z=i*(s*o-e*a),t.ez.x=t.ex.z,t.ez.y=t.ey.z,t.ez.z=i*(e*n-o*o)},o.mul=function(t,i){if(o.assert(t),i&&"z"in i&&"y"in i&&"x"in i){r.assert(i);var e=t.ex.x*i.x+t.ey.x*i.y+t.ez.x*i.z,a=t.ex.y*i.x+t.ey.y*i.y+t.ez.y*i.z,m=t.ex.z*i.x+t.ey.z*i.y+t.ez.z*i.z;return new r(e,a,m)}if(i&&"y"in i&&"x"in i){n.assert(i);e=t.ex.x*i.x+t.ey.x*i.y,a=t.ex.y*i.x+t.ey.y*i.y;return n.neo(e,a)}s.assert(!1)},o.mulVec3=function(t,i){o.assert(t),r.assert(i);var e=t.ex.x*i.x+t.ey.x*i.y+t.ez.x*i.z,s=t.ex.y*i.x+t.ey.y*i.y+t.ez.y*i.z,n=t.ex.z*i.x+t.ey.z*i.y+t.ez.z*i.z;return new r(e,s,n)},o.mulVec2=function(t,i){o.assert(t),n.assert(i);var e=t.ex.x*i.x+t.ey.x*i.y,s=t.ex.y*i.x+t.ey.y*i.y;return n.neo(e,s)},o.add=function(t,i){return o.assert(t),o.assert(i),new o(r.add(t.ex+i.ex),r.add(t.ey+i.ey),r.add(t.ez+i.ez))}},{"../util/common":51,"./Math":18,"./Vec2":23,"./Vec3":24}],18:[function(t,i,e){t("../util/common");var o=t("../util/create"),s=Math,n=i.exports=o(s);n.EPSILON=1e-9,n.isFinite=function(t){return"number"==typeof t&&isFinite(t)&&!isNaN(t)},n.assert=function(t){if(!n.isFinite(t))throw new Error("Invalid Number!")},n.invSqrt=function(t){return 1/s.sqrt(t)},n.nextPowerOfTwo=function(t){return t|=t>>1,t|=t>>2,t|=t>>4,t|=t>>8,(t|=t>>16)+1},n.isPowerOfTwo=function(t){return t>0&&0==(t&t-1)},n.mod=function(t,i,e){return void 0===i?(e=1,i=0):void 0===e&&(e=i,i=0),e>i?(t=(t-i)%(e-i))+(t<0?e:i):(t=(t-e)%(i-e))+(t<=0?i:e)},n.clamp=function(t,i,e){return t<i?i:t>e?e:t},n.random=function(t,i){return void 0===t?(i=1,t=0):void 0===i&&(i=t,t=0),t==i?t:s.random()*(i-t)+t}},{"../util/common":51,"../util/create":52}],19:[function(t,i,e){function o(){this.c=s.zero(),this.a=0}i.exports=o;var s=t("./Vec2"),n=t("./Rot");o.prototype.getTransform=function(t,i){return t.q.set(this.a),t.p.set(s.sub(this.c,n.mulVec2(t.q,i))),t}},{"./Rot":20,"./Vec2":23}],20:[function(t,i,e){function o(t){if(!(this instanceof o))return new o(t);"number"==typeof t?this.setAngle(t):"object"==typeof t?this.set(t):this.setIdentity()}i.exports=o;t("../util/common");var s=t("./Vec2"),n=t("./Math");o.neo=function(t){var i=Object.create(o.prototype);return i.setAngle(t),i},o.clone=function(t){o.assert(t);var i=Object.create(o.prototype);return i.s=t.s,i.c=t.c,i},o.identity=function(){var t=Object.create(o.prototype);return t.s=0,t.c=1,t},o.isValid=function(t){return t&&n.isFinite(t.s)&&n.isFinite(t.c)},o.assert=function(t){if(!o.isValid(t))throw new Error("Invalid Rot!")},o.prototype.setIdentity=function(){return this.s=0,this.c=1,this},o.prototype.set=function(t){"object"==typeof t?(o.assert(t),this.s=t.s,this.c=t.c):(n.assert(t),this.s=n.sin(t),this.c=n.cos(t))},o.prototype.setAngle=function(t){n.assert(t),this.s=n.sin(t),this.c=n.cos(t)},o.prototype.getAngle=function(){return n.atan2(this.s,this.c)},o.prototype.getXAxis=function(){return s.neo(this.c,this.s)},o.prototype.getYAxis=function(){return s.neo(-this.s,this.c)},o.mul=function(t,i){if(o.assert(t),"c"in i&&"s"in i){o.assert(i);var e=o.identity();return e.s=t.s*i.c+t.c*i.s,e.c=t.c*i.c-t.s*i.s,e}if("x"in i&&"y"in i)return s.assert(i),s.neo(t.c*i.x-t.s*i.y,t.s*i.x+t.c*i.y)},o.mulRot=function(t,i){o.assert(t),o.assert(i);var e=o.identity();return e.s=t.s*i.c+t.c*i.s,e.c=t.c*i.c-t.s*i.s,e},o.mulVec2=function(t,i){return o.assert(t),s.assert(i),s.neo(t.c*i.x-t.s*i.y,t.s*i.x+t.c*i.y)},o.mulVec2_=function(t,i,e){return o.assert(t),s.assert(i),e.set(t.c*i.x-t.s*i.y,t.s*i.x+t.c*i.y)},o.mulSub=function(t,i,e){var o=t.c*(i.x-e.x)-t.s*(i.y-e.y),n=t.s*(i.x-e.y)+t.c*(i.y-e.y);return s.neo(o,n)},o.mulT=function(t,i){if("c"in i&&"s"in i){o.assert(i);var e=o.identity();return e.s=t.c*i.s-t.s*i.c,e.c=t.c*i.c+t.s*i.s,e}if("x"in i&&"y"in i)return s.assert(i),s.neo(t.c*i.x+t.s*i.y,-t.s*i.x+t.c*i.y)},o.mulTRot=function(t,i){o.assert(i);var e=o.identity();return e.s=t.c*i.s-t.s*i.c,e.c=t.c*i.c+t.s*i.s,e},o.mulTRot_=function(t,i,e){o.assert(i);var s=e.setIdentity();return s.s=t.c*i.s-t.s*i.c,s.c=t.c*i.c+t.s*i.s,s},o.mulTVec2=function(t,i){return s.assert(i),s.neo(t.c*i.x+t.s*i.y,-t.s*i.x+t.c*i.y)},o.mulTVec2_=function(t,i,e){return s.assert(i),e.set(t.c*i.x+t.s*i.y,-t.s*i.x+t.c*i.y)}},{"../util/common":51,"./Math":18,"./Vec2":23}],21:[function(t,i,e){function o(t,i){s&&n.assert(void 0===t),s&&n.assert(void 0===i),this.localCenter=a.zero(),this.c=a.zero(),this.a=0,this.alpha0=0,this.c0=a.zero(),this.a0=0}var s=!0;i.exports=o;var n=t("../util/common"),r=t("./Math"),a=t("./Vec2"),m=t("./Rot"),h=t("./Transform");o.prototype.setTransform=function(t){var i=h.mulVec2(t,this.localCenter);this.c.set(i),this.c0.set(i),this.a=t.q.getAngle(),this.a0=t.q.getAngle()},o.prototype.setLocalCenter=function(t,i){this.localCenter.set(t);var e=h.mulVec2(i,this.localCenter);this.c.set(e),this.c0.set(e)},o.prototype.getTransform=function(t,i){i=void 0===i?0:i,t.q.setAngle((1-i)*this.a0+i*this.a),t.p.setCombine(1-i,this.c0,i,this.c),t.p.sub(m.mulVec2(t.q,this.localCenter))},o.prototype.advance=function(t){s&&n.assert(this.alpha0<1);var i=(t-this.alpha0)/(1-this.alpha0);this.c0.setCombine(i,this.c,1-i,this.c0),this.a0=i*this.a+(1-i)*this.a0,this.alpha0=t},o.prototype.forward=function(){this.a0=this.a,this.c0.set(this.c)},o.prototype.normalize=function(){var t=r.mod(this.a0,-r.PI,+r.PI);this.a-=this.a0-t,this.a0=t},o.prototype.clone=function(){var t=new o;return t.localCenter.set(this.localCenter),t.alpha0=this.alpha0,t.a0=this.a0,t.a=this.a,t.c0.set(this.c0),t.c.set(this.c),t},o.prototype.set=function(t){this.localCenter.set(t.localCenter),this.alpha0=t.alpha0,this.a0=t.a0,this.a=t.a,this.c0.set(t.c0),this.c.set(t.c)}},{"../util/common":51,"./Math":18,"./Rot":20,"./Transform":22,"./Vec2":23}],22:[function(t,i,e){function o(t,i){if(!(this instanceof o))return new o(t,i);this.p=s.zero(),this.q=n.identity(),void 0!==t&&this.p.set(t),void 0!==i&&this.q.set(i)}i.exports=o;t("../util/common");var s=t("./Vec2"),n=t("./Rot");o.clone=function(t){var i=Object.create(o.prototype);return i.p=s.clone(t.p),i.q=n.clone(t.q),i},o.neo=function(t,i){var e=Object.create(o.prototype);return e.p=s.clone(t),e.q=n.clone(i),e},o.identity=function(){var t=Object.create(o.prototype);return t.p=s.zero(),t.q=n.identity(),t},o.prototype.setIdentity=function(){return this.p.setZero(),this.q.setIdentity(),this},o.prototype.set=function(t,i){void 0===i?(this.p.set(t.p),this.q.set(t.q)):(this.p.set(t),this.q.set(i))},o.isValid=function(t){return t&&s.isValid(t.p)&&n.isValid(t.q)},o.assert=function(t){if(!o.isValid(t))throw new Error("Invalid Transform!")},o.mul=function(t,i){if(o.assert(t),Array.isArray(i)){for(var e=[],r=0;r<i.length;r++)e[r]=o.mul(t,i[r]);return e}if("x"in i&&"y"in i){s.assert(i);var a=t.q.c*i.x-t.q.s*i.y+t.p.x,m=t.q.s*i.x+t.q.c*i.y+t.p.y;return s.neo(a,m)}if("p"in i&&"q"in i){o.assert(i);var h=o.identity();return h.q=n.mulRot(t.q,i.q),h.p=s.add(n.mulVec2(t.q,i.p),t.p),h}},o.mulAll=function(t,i){o.assert(t);for(var e=[],s=0;s<i.length;s++)e[s]=o.mul(t,i[s]);return e},o.mulFn=function(t){return o.assert(t),function(i){return o.mul(t,i)}},o.mulVec2=function(t,i){o.assert(t),s.assert(i);var e=t.q.c*i.x-t.q.s*i.y+t.p.x,n=t.q.s*i.x+t.q.c*i.y+t.p.y;return s.neo(e,n)},o.mulVec2_=function(t,i,e){o.assert(t),s.assert(i);var n=t.q.c*i.x-t.q.s*i.y+t.p.x,r=t.q.s*i.x+t.q.c*i.y+t.p.y;return e.set(n,r)},o.mulXf=function(t,i){o.assert(t),o.assert(i);var e=o.identity();return e.q=n.mulRot(t.q,i.q),e.p=s.add(n.mulVec2(t.q,i.p),t.p),e},o.mulT=function(t,i){if(o.assert(t),"x"in i&&"y"in i){s.assert(i);var e=i.x-t.p.x,r=i.y-t.p.y,a=t.q.c*e+t.q.s*r,m=-t.q.s*e+t.q.c*r;return s.neo(a,m)}if("p"in i&&"q"in i){o.assert(i);var h=o.identity();return h.q.set(n.mulTRot(t.q,i.q)),h.p.set(n.mulTVec2(t.q,s.sub(i.p,t.p))),h}},o.mulTVec2=function(t,i){o.assert(t),s.assert(i);var e=i.x-t.p.x,n=i.y-t.p.y,r=t.q.c*e+t.q.s*n,a=-t.q.s*e+t.q.c*n;return s.neo(r,a)},o.mulTVec2_=function(t,i,e){o.assert(t),s.assert(i);var n=i.x-t.p.x,r=i.y-t.p.y,a=t.q.c*n+t.q.s*r,m=-t.q.s*n+t.q.c*r;return e.set(a,m)},o.mulTXf=function(t,i){o.assert(t),o.assert(i);var e=o.identity();return e.q.set(n.mulTRot(t.q,i.q)),e.p.set(n.mulTVec2(t.q,s.sub(i.p,t.p))),e};var r=s.zero();o.mulTXf_=function(t,i,e){return o.assert(t),o.assert(i),n.mulTRot_(t.q,i.q,e.q),n.mulTVec2_(t.q,s.sub(i.p,t.p,r),e.p),e}},{"../util/common":51,"./Rot":20,"./Vec2":23}],23:[function(t,i,e){function o(t,i){if(!(this instanceof o))return new o(t,i);void 0===t?(this.x=0,this.y=0):"object"==typeof t?(this.x=t.x,this.y=t.y):(this.x=t,this.y=i),s&&o.assert(this)}var s=!0;i.exports=o;var n=t("../util/common"),r=t("./Math");o.zero=function(){var t=Object.create(o.prototype);return t.x=0,t.y=0,t},o.neo=function(t,i){var e=Object.create(o.prototype);return e.x=t,e.y=i,e},o.clone=function(t){return s&&o.assert(t),o.neo(t.x,t.y)},o.prototype.toString=function(){return JSON.stringify(this)},o.isValid=function(t){return t&&r.isFinite(t.x)&&r.isFinite(t.y)},o.assert=function(t){if(s&&!o.isValid(t))throw new Error("Invalid Vec2!")},o.prototype.clone=function(){return o.clone(this)},o.prototype.setZero=function(){return this.x=0,this.y=0,this},o.prototype.set=function(t,i){return"object"==typeof t?(s&&o.assert(t),this.x=t.x,this.y=t.y):(s&&r.assert(t),s&&r.assert(i),this.x=t,this.y=i),this},o.prototype.setXY=function(t,i){return this.x=t,this.y=i,this},o.prototype.setVec2=function(t){return this.x=t.x,this.y=t.y,this},o.prototype.wSet=function(t,i,e,o){return void 0!==e||void 0!==o?this.setCombine(t,i,e,o):this.setMul(t,i)},o.prototype.setCombine=function(t,i,e,n){s&&r.assert(t),s&&o.assert(i),s&&r.assert(e),s&&o.assert(n);var a=t*i.x+e*n.x,m=t*i.y+e*n.y;return this.x=a,this.y=m,this},o.prototype.setMul=function(t,i){s&&r.assert(t),s&&o.assert(i);var e=t*i.x,n=t*i.y;return this.x=e,this.y=n,this},o.prototype.add=function(t){return s&&o.assert(t),this.x+=t.x,this.y+=t.y,this},o.prototype.wAdd=function(t,i,e,o){return void 0!==e||void 0!==o?this.addCombine(t,i,e,o):this.addMul(t,i)},o.prototype.addCombine=function(t,i,e,n){s&&r.assert(t),s&&o.assert(i),s&&r.assert(e),s&&o.assert(n);var a=t*i.x+e*n.x,m=t*i.y+e*n.y;return this.x+=a,this.y+=m,this},o.prototype.addMul=function(t,i){s&&r.assert(t),s&&o.assert(i);var e=t*i.x,n=t*i.y;return this.x+=e,this.y+=n,this},o.prototype.wSub=function(t,i,e,o){return void 0!==e||void 0!==o?this.subCombine(t,i,e,o):this.subMul(t,i)},o.prototype.subCombine=function(t,i,e,n){s&&r.assert(t),s&&o.assert(i),s&&r.assert(e),s&&o.assert(n);var a=t*i.x+e*n.x,m=t*i.y+e*n.y;return this.x-=a,this.y-=m,this},o.prototype.subMul=function(t,i){s&&r.assert(t),s&&o.assert(i);var e=t*i.x,n=t*i.y;return this.x-=e,this.y-=n,this},o.prototype.sub=function(t){return s&&o.assert(t),this.x-=t.x,this.y-=t.y,this},o.prototype.mul=function(t){return s&&r.assert(t),this.x*=t,this.y*=t,this},o.prototype.length=function(){return o.lengthOf(this)},o.prototype.lengthSquared=function(){return o.lengthSquared(this)},o.prototype.normalize=function(){var t=this.length();if(t<r.EPSILON)return 0;var i=1/t;return this.x*=i,this.y*=i,t},o.lengthOf=function(t){return s&&o.assert(t),r.sqrt(t.x*t.x+t.y*t.y)},o.lengthSquared=function(t){return s&&o.assert(t),t.x*t.x+t.y*t.y},o.distance=function(t,i){s&&o.assert(t),s&&o.assert(i);var e=t.x-i.x,n=t.y-i.y;return r.sqrt(e*e+n*n)},o.distanceSquared=function(t,i){s&&o.assert(t),s&&o.assert(i);var e=t.x-i.x,n=t.y-i.y;return e*e+n*n},o.areEqual=function(t,i){return s&&o.assert(t),s&&o.assert(i),t==i||"object"==typeof i&&null!==i&&t.x===i.x&&t.y===i.y},o.skew=function(t){return s&&o.assert(t),o.neo(-t.y,t.x)},o.dot=function(t,i){return s&&o.assert(t),s&&o.assert(i),t.x*i.x+t.y*i.y},o.cross=function(t,i){return"number"==typeof i?(s&&o.assert(t),s&&r.assert(i),o.neo(i*t.y,-i*t.x)):"number"==typeof t?(s&&r.assert(t),s&&o.assert(i),o.neo(-t*i.y,t*i.x)):(s&&o.assert(t),s&&o.assert(i),t.x*i.y-t.y*i.x)},o.crossVec2Vec2=function(t,i){return t.x*i.y-t.y*i.x},o.crossNumVec2_=function(t,i,e){return e.setXY(-t*i.y,t*i.x)},o.crossVec2Num_=function(t,i,e){return e.setXY(i*t.y,-i*t.x)},o.addCross=function(t,i,e){return"number"==typeof e?(s&&o.assert(i),s&&r.assert(e),o.neo(e*i.y+t.x,-e*i.x+t.y)):"number"==typeof i?(s&&r.assert(i),s&&o.assert(e),o.neo(-i*e.y+t.x,i*e.x+t.y)):void(s&&n.assert(!1))},o.add=function(t,i){return s&&o.assert(t),s&&o.assert(i),o.neo(t.x+i.x,t.y+i.y)},o.wAdd=function(t,i,e,s){return void 0!==e||void 0!==s?o.combine(t,i,e,s):o.mul(t,i)},o.combine=function(t,i,e,s){return o.zero().setCombine(t,i,e,s)},o.combine_=function(t,i,e,o,s){return s.setCombine(t,i,e,o)},o.sub=function(t,i){return s&&o.assert(t),s&&o.assert(i),o.neo(t.x-i.x,t.y-i.y)},o.sub_=function(t,i,e){return s&&o.assert(t),s&&o.assert(i),e.setXY(t.x-i.x,t.y-i.y)},o.mul=function(t,i){return"object"==typeof t?(s&&o.assert(t),s&&r.assert(i),o.neo(t.x*i,t.y*i)):"object"==typeof i?(s&&r.assert(t),s&&o.assert(i),o.neo(t*i.x,t*i.y)):void 0},o.mulVec2Num_=function(t,i,e){return e.setXY(t.x*i,t.y*i)},o.mulNumVec2_=function(t,i,e){return e.setXY(t*i.x,t*i.y)},o.prototype.neg=function(){return this.x=-this.x,this.y=-this.y,this},o.neg=function(t){return s&&o.assert(t),o.neo(-t.x,-t.y)},o.neg_=function(t,i){return s&&o.assert(t),i.setXY(-t.x,-t.y)},o.abs=function(t){return s&&o.assert(t),o.neo(r.abs(t.x),r.abs(t.y))},o.mid=function(t,i){return s&&o.assert(t),s&&o.assert(i),o.neo(.5*(t.x+i.x),.5*(t.y+i.y))},o.upper=function(t,i){return s&&o.assert(t),s&&o.assert(i),o.neo(r.max(t.x,i.x),r.max(t.y,i.y))},o.lower=function(t,i){return s&&o.assert(t),s&&o.assert(i),o.neo(r.min(t.x,i.x),r.min(t.y,i.y))},o.prototype.clamp=function(t){var i=this.x*this.x+this.y*this.y;if(i>t*t){var e=r.invSqrt(i);this.x*=e*t,this.y*=e*t}return this},o.clamp=function(t,i){return(t=o.neo(t.x,t.y)).clamp(i),t},o.scaleFn=function(t,i){return function(e){return o.neo(e.x*t,e.y*i)}},o.translateFn=function(t,i){return function(e){return o.neo(e.x+t,e.y+i)}}},{"../util/common":51,"./Math":18}],24:[function(t,i,e){function o(t,i,e){if(!(this instanceof o))return new o(t,i,e);void 0===t?(this.x=0,this.y=0,this.z=0):"object"==typeof t?(this.x=t.x,this.y=t.y,this.z=t.z):(this.x=t,this.y=i,this.z=e),s&&o.assert(this)}var s=!0;i.exports=o;t("../util/common");var n=t("./Math");o.neo=function(t,i,e){var s=Object.create(o.prototype);return s.x=t,s.y=i,s.z=e,s},o.clone=function(t){return s&&o.assert(t),o.neo(t.x,t.y,t.z)},o.prototype.toString=function(){return JSON.stringify(this)},o.isValid=function(t){return t&&n.isFinite(t.x)&&n.isFinite(t.y)&&n.isFinite(t.z)},o.assert=function(t){if(s&&!o.isValid(t))throw new Error("Invalid Vec3!")},o.prototype.setZero=function(){return this.x=0,this.y=0,this.z=0,this},o.prototype.set=function(t,i,e){return this.x=t,this.y=i,this.z=e,this},o.prototype.add=function(t){return this.x+=t.x,this.y+=t.y,this.z+=t.z,this},o.prototype.sub=function(t){return this.x-=t.x,this.y-=t.y,this.z-=t.z,this},o.prototype.mul=function(t){return this.x*=t,this.y*=t,this.z*=t,this},o.areEqual=function(t,i){return s&&o.assert(t),s&&o.assert(i),t==i||"object"==typeof t&&null!==t&&"object"==typeof i&&null!==i&&t.x===i.x&&t.y===i.y&&t.z===i.z},o.dot=function(t,i){return t.x*i.x+t.y*i.y+t.z*i.z},o.cross=function(t,i){return new o(t.y*i.z-t.z*i.y,t.z*i.x-t.x*i.z,t.x*i.y-t.y*i.x)},o.add=function(t,i){return new o(t.x+i.x,t.y+i.y,t.z+i.z)},o.sub=function(t,i){return new o(t.x-i.x,t.y-i.y,t.z-i.z)},o.mul=function(t,i){return new o(i*t.x,i*t.y,i*t.z)},o.prototype.neg=function(){return this.x=-this.x,this.y=-this.y,this.z=-this.z,this},o.neg=function(t){return new o(-t.x,-t.y,-t.z)}},{"../util/common":51,"./Math":18}],25:[function(t,i,e){i.exports=function(){this.v=o.zero(),this.w=0};var o=t("./Vec2")},{"./Vec2":23}],26:[function(t,i,e){e.toString=function(t){t="string"==typeof t?t:"\n";var i="";for(var e in this)"function"!=typeof this[e]&&"object"!=typeof this[e]&&(i+=e+": "+this[e]+t);return i}},{}],27:[function(t,i,e){e.internal={},e.Math=t("./common/Math"),e.Vec2=t("./common/Vec2"),e.Vec3=t("./common/Vec3"),e.Mat22=t("./common/Mat22"),e.Mat33=t("./common/Mat33"),e.Transform=t("./common/Transform"),e.Rot=t("./common/Rot"),e.AABB=t("./collision/AABB"),e.Shape=t("./Shape"),e.Fixture=t("./Fixture"),e.Body=t("./Body"),e.Contact=t("./Contact"),e.Joint=t("./Joint"),e.World=t("./World"),e.Circle=t("./shape/CircleShape"),e.Edge=t("./shape/EdgeShape"),e.Polygon=t("./shape/PolygonShape"),e.Chain=t("./shape/ChainShape"),e.Box=t("./shape/BoxShape"),t("./shape/CollideCircle"),t("./shape/CollideEdgeCircle"),e.internal.CollidePolygons=t("./shape/CollidePolygon"),t("./shape/CollideCirclePolygone"),t("./shape/CollideEdgePolygon"),e.DistanceJoint=t("./joint/DistanceJoint"),e.FrictionJoint=t("./joint/FrictionJoint"),e.GearJoint=t("./joint/GearJoint"),e.MotorJoint=t("./joint/MotorJoint"),e.MouseJoint=t("./joint/MouseJoint"),e.PrismaticJoint=t("./joint/PrismaticJoint"),e.PulleyJoint=t("./joint/PulleyJoint"),e.RevoluteJoint=t("./joint/RevoluteJoint"),e.RopeJoint=t("./joint/RopeJoint"),e.WeldJoint=t("./joint/WeldJoint"),e.WheelJoint=t("./joint/WheelJoint"),e.internal.Sweep=t("./common/Sweep"),e.internal.stats=t("./common/stats"),e.internal.Manifold=t("./Manifold"),e.internal.Distance=t("./collision/Distance"),e.internal.TimeOfImpact=t("./collision/TimeOfImpact"),e.internal.DynamicTree=t("./collision/DynamicTree"),e.internal.Settings=t("./Settings")},{"./Body":2,"./Contact":3,"./Fixture":4,"./Joint":5,"./Manifold":6,"./Settings":7,"./Shape":8,"./World":10,"./collision/AABB":11,"./collision/Distance":13,"./collision/DynamicTree":14,"./collision/TimeOfImpact":15,"./common/Mat22":16,"./common/Mat33":17,"./common/Math":18,"./common/Rot":20,"./common/Sweep":21,"./common/Transform":22,"./common/Vec2":23,"./common/Vec3":24,"./common/stats":26,"./joint/DistanceJoint":28,"./joint/FrictionJoint":29,"./joint/GearJoint":30,"./joint/MotorJoint":31,"./joint/MouseJoint":32,"./joint/PrismaticJoint":33,"./joint/PulleyJoint":34,"./joint/RevoluteJoint":35,"./joint/RopeJoint":36,"./joint/WeldJoint":37,"./joint/WheelJoint":38,"./shape/BoxShape":39,"./shape/ChainShape":40,"./shape/CircleShape":41,"./shape/CollideCircle":42,"./shape/CollideCirclePolygone":43,"./shape/CollideEdgeCircle":44,"./shape/CollideEdgePolygon":45,"./shape/CollidePolygon":46,"./shape/EdgeShape":47,"./shape/PolygonShape":48}],28:[function(t,i,e){function o(t,i,e,n,r){if(!(this instanceof o))return new o(t,i,e,n,r);if(e&&n&&"m_type"in n&&"x"in e&&"y"in e){var h=e;e=n,n=h}t=s(t,l),c.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=o.TYPE,this.m_localAnchorA=n?i.getLocalPoint(n):t.localAnchorA||m.zero(),this.m_localAnchorB=r?e.getLocalPoint(r):t.localAnchorB||m.zero(),this.m_length=a.isFinite(t.length)?t.length:m.distance(i.getWorldPoint(this.m_localAnchorA),e.getWorldPoint(this.m_localAnchorB)),this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_impulse=0,this.m_gamma=0,this.m_bias=0,this.m_u,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass}i.exports=o;var s=t("../util/options"),n=t("../util/create"),r=t("../Settings"),a=t("../common/Math"),m=t("../common/Vec2"),h=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),c=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="distance-joint";var l={frequencyHz:0,dampingRatio:0};(o.prototype=n((o._super=c).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.setLength=function(t){this.m_length=t},o.prototype.getLength=function(){return this.m_length},o.prototype.setFrequency=function(t){this.m_frequencyHz=t},o.prototype.getFrequency=function(){return this.m_frequencyHz},o.prototype.setDampingRatio=function(t){this.m_dampingRatio=t},o.prototype.getDampingRatio=function(){return this.m_dampingRatio},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return m.mul(this.m_impulse,this.m_u).mul(t)},o.prototype.getReactionTorque=function(t){return 0},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,c=this.m_bodyB.c_position.a,l=this.m_bodyB.c_velocity.v,_=this.m_bodyB.c_velocity.w,u=h.neo(e),p=h.neo(c);this.m_rA=h.mulVec2(u,m.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=h.mulVec2(p,m.sub(this.m_localAnchorB,this.m_localCenterB)),this.m_u=m.sub(m.add(n,this.m_rB),m.add(i,this.m_rA));var d=this.m_u.length();d>r.linearSlop?this.m_u.mul(1/d):this.m_u.set(0,0);var y=m.cross(this.m_rA,this.m_u),f=m.cross(this.m_rB,this.m_u),v=this.m_invMassA+this.m_invIA*y*y+this.m_invMassB+this.m_invIB*f*f;if(this.m_mass=0!=v?1/v:0,this.m_frequencyHz>0){var x=d-this.m_length,g=2*a.PI*this.m_frequencyHz,b=2*this.m_mass*this.m_dampingRatio*g,A=this.m_mass*g*g,B=t.dt;this.m_gamma=B*(b+B*A),this.m_gamma=0!=this.m_gamma?1/this.m_gamma:0,this.m_bias=x*B*A*this.m_gamma,v+=this.m_gamma,this.m_mass=0!=v?1/v:0}else this.m_gamma=0,this.m_bias=0;if(t.warmStarting){this.m_impulse*=t.dtRatio;var w=m.mul(this.m_impulse,this.m_u);o.subMul(this.m_invMassA,w),s-=this.m_invIA*m.cross(this.m_rA,w),l.addMul(this.m_invMassB,w),_+=this.m_invIB*m.cross(this.m_rB,w)}else this.m_impulse=0;this.m_bodyA.c_velocity.v.set(o),this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v.set(l),this.m_bodyB.c_velocity.w=_},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=m.add(i,m.cross(e,this.m_rA)),r=m.add(o,m.cross(s,this.m_rB)),a=m.dot(this.m_u,r)-m.dot(this.m_u,n),h=-this.m_mass*(a+this.m_bias+this.m_gamma*this.m_impulse);this.m_impulse+=h;var c=m.mul(h,this.m_u);i.subMul(this.m_invMassA,c),e-=this.m_invIA*m.cross(this.m_rA,c),o.addMul(this.m_invMassB,c),s+=this.m_invIB*m.cross(this.m_rB,c),this.m_bodyA.c_velocity.v.set(i),this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v.set(o),this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){if(this.m_frequencyHz>0)return!0;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=h.neo(e),c=h.neo(s),l=h.mulSub(n,this.m_localAnchorA,this.m_localCenterA),_=h.mulSub(c,this.m_localAnchorB,this.m_localCenterB),u=m.sub(m.add(o,_),m.add(i,l)),p=u.normalize()-this.m_length;p=a.clamp(p,-r.maxLinearCorrection,r.maxLinearCorrection);var d=-this.m_mass*p,y=m.mul(d,u);return i.subMul(this.m_invMassA,y),e-=this.m_invIA*m.cross(l,y),o.addMul(this.m_invMassB,y),s+=this.m_invIB*m.cross(_,y),this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c.set(o),this.m_bodyB.c_position.a=s,a.abs(p)<r.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/create":52,"../util/options":53}],29:[function(t,i,e){function o(t,i,e,s){if(!(this instanceof o))return new o(t,i,e,s);t=n(t,_),l.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=o.TYPE,this.m_localAnchorA=s?i.getLocalPoint(s):t.localAnchorA||m.zero(),this.m_localAnchorB=s?e.getLocalPoint(s):t.localAnchorB||m.zero(),this.m_linearImpulse=m.zero(),this.m_angularImpulse=0,this.m_maxForce=t.maxForce,this.m_maxTorque=t.maxTorque,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_linearMass,this.m_angularMass}i.exports=o;var s=t("../util/common"),n=t("../util/options"),r=t("../util/create"),a=(t("../Settings"),t("../common/Math")),m=t("../common/Vec2"),h=(t("../common/Vec3"),t("../common/Mat22")),c=(t("../common/Mat33"),t("../common/Rot")),l=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="friction-joint";var _={maxForce:0,maxTorque:0};(o.prototype=r((o._super=l).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.setMaxForce=function(t){s.assert(a.isFinite(t)&&t>=0),this.m_maxForce=t},o.prototype.getMaxForce=function(){return this.m_maxForce},o.prototype.setMaxTorque=function(t){s.assert(a.isFinite(t)&&t>=0),this.m_maxTorque=t},o.prototype.getMaxTorque=function(){return this.m_maxTorque},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return m.mul(t,this.m_linearImpulse)},o.prototype.getReactionTorque=function(t){return t*this.m_angularImpulse},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,r=this.m_bodyB.c_velocity.w,a=c.neo(i),l=c.neo(s);this.m_rA=c.mulVec2(a,m.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=c.mulVec2(l,m.sub(this.m_localAnchorB,this.m_localCenterB));var _=this.m_invMassA,u=this.m_invMassB,p=this.m_invIA,d=this.m_invIB,y=new h;if(y.ex.x=_+u+p*this.m_rA.y*this.m_rA.y+d*this.m_rB.y*this.m_rB.y,y.ex.y=-p*this.m_rA.x*this.m_rA.y-d*this.m_rB.x*this.m_rB.y,y.ey.x=y.ex.y,y.ey.y=_+u+p*this.m_rA.x*this.m_rA.x+d*this.m_rB.x*this.m_rB.x,this.m_linearMass=y.getInverse(),this.m_angularMass=p+d,this.m_angularMass>0&&(this.m_angularMass=1/this.m_angularMass),t.warmStarting){this.m_linearImpulse.mul(t.dtRatio),this.m_angularImpulse*=t.dtRatio;var f=m.neo(this.m_linearImpulse.x,this.m_linearImpulse.y);e.subMul(_,f),o-=p*(m.cross(this.m_rA,f)+this.m_angularImpulse),n.addMul(u,f),r+=d*(m.cross(this.m_rB,f)+this.m_angularImpulse)}else this.m_linearImpulse.setZero(),this.m_angularImpulse=0;this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=n,this.m_bodyB.c_velocity.w=r},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,r=this.m_invMassB,c=this.m_invIA,l=this.m_invIB,_=t.dt,u=s-e,p=-this.m_angularMass*u,d=this.m_angularImpulse,y=_*this.m_maxTorque;this.m_angularImpulse=a.clamp(this.m_angularImpulse+p,-y,y),e-=c*(p=this.m_angularImpulse-d),s+=l*p;u=m.sub(m.add(o,m.cross(s,this.m_rB)),m.add(i,m.cross(e,this.m_rA))),p=m.neg(h.mulVec2(this.m_linearMass,u)),d=this.m_linearImpulse;this.m_linearImpulse.add(p);y=_*this.m_maxForce;this.m_linearImpulse.lengthSquared()>y*y&&(this.m_linearImpulse.normalize(),this.m_linearImpulse.mul(y)),p=m.sub(this.m_linearImpulse,d),i.subMul(n,p),e-=c*m.cross(this.m_rA,p),o.addMul(r,p),s+=l*m.cross(this.m_rB,p),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){return!0}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":51,"../util/create":52,"../util/options":53}],30:[function(t,i,e){function o(t,i,e,a,m,y){if(!(this instanceof o))return new o(t,i,e,a,m,y);t=r(t,d),_.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=o.TYPE,s&&n.assert(a.m_type===u.TYPE||a.m_type===p.TYPE),s&&n.assert(m.m_type===u.TYPE||m.m_type===p.TYPE),this.m_joint1=a||t.joint1,this.m_joint2=m||t.joint2,this.m_ratio=h.isFinite(y)?y:t.ratio,this.m_type1=this.m_joint1.getType(),this.m_type2=this.m_joint2.getType();var f,v;this.m_bodyC=this.m_joint1.getBodyA(),this.m_bodyA=this.m_joint1.getBodyB();var x=this.m_bodyA.m_xf,g=this.m_bodyA.m_sweep.a,b=this.m_bodyC.m_xf,A=this.m_bodyC.m_sweep.a;if(this.m_type1===u.TYPE){var B=this.m_joint1;this.m_localAnchorC=B.m_localAnchorA,this.m_localAnchorA=B.m_localAnchorB,this.m_referenceAngleA=B.m_referenceAngle,this.m_localAxisC=c.zero(),f=g-A-this.m_referenceAngleA}else{var w=this.m_joint1;this.m_localAnchorC=w.m_localAnchorA,this.m_localAnchorA=w.m_localAnchorB,this.m_referenceAngleA=w.m_referenceAngle,this.m_localAxisC=w.m_localXAxisA;var M=this.m_localAnchorC,C=l.mulTVec2(b.q,c.add(l.mul(x.q,this.m_localAnchorA),c.sub(x.p,b.p)));f=c.dot(C,this.m_localAxisC)-c.dot(M,this.m_localAxisC)}this.m_bodyD=this.m_joint2.getBodyA(),this.m_bodyB=this.m_joint2.getBodyB();var V=this.m_bodyB.m_xf,S=this.m_bodyB.m_sweep.a,I=this.m_bodyD.m_xf,P=this.m_bodyD.m_sweep.a;if(this.m_type2===u.TYPE){B=this.m_joint2;this.m_localAnchorD=B.m_localAnchorA,this.m_localAnchorB=B.m_localAnchorB,this.m_referenceAngleB=B.m_referenceAngle,this.m_localAxisD=c.zero(),v=S-P-this.m_referenceAngleB}else{w=this.m_joint2;this.m_localAnchorD=w.m_localAnchorA,this.m_localAnchorB=w.m_localAnchorB,this.m_referenceAngleB=w.m_referenceAngle,this.m_localAxisD=w.m_localXAxisA;var T=this.m_localAnchorD,z=l.mulTVec2(I.q,c.add(l.mul(V.q,this.m_localAnchorB),c.sub(V.p,I.p)));v=c.dot(z,this.m_localAxisD)-c.dot(T,this.m_localAxisD)}this.m_constant=f+this.m_ratio*v,this.m_impulse=0,this.m_lcA,this.m_lcB,this.m_lcC,this.m_lcD,this.m_mA,this.m_mB,this.m_mC,this.m_mD,this.m_iA,this.m_iB,this.m_iC,this.m_iD,this.m_JvAC,this.m_JvBD,this.m_JwA,this.m_JwB,this.m_JwC,this.m_JwD,this.m_mass}var s=!0;i.exports=o;var n=t("../util/common"),r=t("../util/options"),a=t("../util/create"),m=t("../Settings"),h=t("../common/Math"),c=t("../common/Vec2"),l=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),_=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint")),u=t("./RevoluteJoint"),p=t("./PrismaticJoint");o.TYPE="gear-joint";var d={ratio:1};(o.prototype=a((o._super=_).prototype)).getJoint1=function(){return this.m_joint1},o.prototype.getJoint2=function(){return this.m_joint2},o.prototype.setRatio=function(t){s&&n.assert(h.isFinite(t)),this.m_ratio=t},o.prototype.getRatio=function(){return this.m_ratio},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return c.mul(this.m_impulse,this.m_JvAC).mul(t)},o.prototype.getReactionTorque=function(t){return t*(this.m_impulse*this.m_JwA)},o.prototype.initVelocityConstraints=function(t){this.m_lcA=this.m_bodyA.m_sweep.localCenter,this.m_lcB=this.m_bodyB.m_sweep.localCenter,this.m_lcC=this.m_bodyC.m_sweep.localCenter,this.m_lcD=this.m_bodyD.m_sweep.localCenter,this.m_mA=this.m_bodyA.m_invMass,this.m_mB=this.m_bodyB.m_invMass,this.m_mC=this.m_bodyC.m_invMass,this.m_mD=this.m_bodyD.m_invMass,this.m_iA=this.m_bodyA.m_invI,this.m_iB=this.m_bodyB.m_invI,this.m_iC=this.m_bodyC.m_invI,this.m_iD=this.m_bodyD.m_invI;var i=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,r=this.m_bodyB.c_velocity.w,a=this.m_bodyC.c_position.a,m=this.m_bodyC.c_velocity.v,h=this.m_bodyC.c_velocity.w,_=this.m_bodyD.c_position.a,p=this.m_bodyD.c_velocity.v,d=this.m_bodyD.c_velocity.w,y=l.neo(i),f=l.neo(s),v=l.neo(a),x=l.neo(_);if(this.m_mass=0,this.m_type1==u.TYPE)this.m_JvAC=c.zero(),this.m_JwA=1,this.m_JwC=1,this.m_mass+=this.m_iA+this.m_iC;else{var g=l.mulVec2(v,this.m_localAxisC),b=l.mulSub(v,this.m_localAnchorC,this.m_lcC),A=l.mulSub(y,this.m_localAnchorA,this.m_lcA);this.m_JvAC=g,this.m_JwC=c.cross(b,g),this.m_JwA=c.cross(A,g),this.m_mass+=this.m_mC+this.m_mA+this.m_iC*this.m_JwC*this.m_JwC+this.m_iA*this.m_JwA*this.m_JwA}if(this.m_type2==u.TYPE)this.m_JvBD=c.zero(),this.m_JwB=this.m_ratio,this.m_JwD=this.m_ratio,this.m_mass+=this.m_ratio*this.m_ratio*(this.m_iB+this.m_iD);else{g=l.mulVec2(x,this.m_localAxisD);var B=l.mulSub(x,this.m_localAnchorD,this.m_lcD),w=l.mulSub(f,this.m_localAnchorB,this.m_lcB);this.m_JvBD=c.mul(this.m_ratio,g),this.m_JwD=this.m_ratio*c.cross(B,g),this.m_JwB=this.m_ratio*c.cross(w,g),this.m_mass+=this.m_ratio*this.m_ratio*(this.m_mD+this.m_mB)+this.m_iD*this.m_JwD*this.m_JwD+this.m_iB*this.m_JwB*this.m_JwB}this.m_mass=this.m_mass>0?1/this.m_mass:0,t.warmStarting?(e.addMul(this.m_mA*this.m_impulse,this.m_JvAC),o+=this.m_iA*this.m_impulse*this.m_JwA,n.addMul(this.m_mB*this.m_impulse,this.m_JvBD),r+=this.m_iB*this.m_impulse*this.m_JwB,m.subMul(this.m_mC*this.m_impulse,this.m_JvAC),h-=this.m_iC*this.m_impulse*this.m_JwC,p.subMul(this.m_mD*this.m_impulse,this.m_JvBD),d-=this.m_iD*this.m_impulse*this.m_JwD):this.m_impulse=0,this.m_bodyA.c_velocity.v.set(e),this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v.set(n),this.m_bodyB.c_velocity.w=r,this.m_bodyC.c_velocity.v.set(m),this.m_bodyC.c_velocity.w=h,this.m_bodyD.c_velocity.v.set(p),this.m_bodyD.c_velocity.w=d},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_bodyC.c_velocity.v,r=this.m_bodyC.c_velocity.w,a=this.m_bodyD.c_velocity.v,m=this.m_bodyD.c_velocity.w,h=c.dot(this.m_JvAC,i)-c.dot(this.m_JvAC,n)+c.dot(this.m_JvBD,o)-c.dot(this.m_JvBD,a);h+=this.m_JwA*e-this.m_JwC*r+(this.m_JwB*s-this.m_JwD*m);var l=-this.m_mass*h;this.m_impulse+=l,i.addMul(this.m_mA*l,this.m_JvAC),e+=this.m_iA*l*this.m_JwA,o.addMul(this.m_mB*l,this.m_JvBD),s+=this.m_iB*l*this.m_JwB,n.subMul(this.m_mC*l,this.m_JvAC),r-=this.m_iC*l*this.m_JwC,a.subMul(this.m_mD*l,this.m_JvBD),m-=this.m_iD*l*this.m_JwD,this.m_bodyA.c_velocity.v.set(i),this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v.set(o),this.m_bodyB.c_velocity.w=s,this.m_bodyC.c_velocity.v.set(n),this.m_bodyC.c_velocity.w=r,this.m_bodyD.c_velocity.v.set(a),this.m_bodyD.c_velocity.w=m},o.prototype.solvePositionConstraints=function(t){var i,e,o,s,n,r,a,h,_=this.m_bodyA.c_position.c,p=this.m_bodyA.c_position.a,d=this.m_bodyB.c_position.c,y=this.m_bodyB.c_position.a,f=this.m_bodyC.c_position.c,v=this.m_bodyC.c_position.a,x=this.m_bodyD.c_position.c,g=this.m_bodyD.c_position.a,b=l.neo(p),A=l.neo(y),B=l.neo(v),w=l.neo(g),M=0;if(this.m_type1==u.TYPE)o=c.zero(),n=1,a=1,M+=this.m_iA+this.m_iC,i=p-v-this.m_referenceAngleA;else{var C=l.mulVec2(B,this.m_localAxisC),V=l.mulSub(B,this.m_localAnchorC,this.m_lcC),S=l.mulSub(b,this.m_localAnchorA,this.m_lcA);o=C,a=c.cross(V,C),n=c.cross(S,C),M+=this.m_mC+this.m_mA+this.m_iC*a*a+this.m_iA*n*n;var I=c.sub(this.m_localAnchorC,this.m_lcC),P=l.mulTVec2(B,c.add(S,c.sub(_,f)));i=c.dot(c.sub(P,I),this.m_localAxisC)}if(this.m_type2==u.TYPE)s=c.zero(),r=this.m_ratio,h=this.m_ratio,M+=this.m_ratio*this.m_ratio*(this.m_iB+this.m_iD),e=y-g-this.m_referenceAngleB;else{C=l.mulVec2(w,this.m_localAxisD);var T=l.mulSub(w,this.m_localAnchorD,this.m_lcD),z=l.mulSub(A,this.m_localAnchorB,this.m_lcB);s=c.mul(this.m_ratio,C),h=this.m_ratio*c.cross(T,C),r=this.m_ratio*c.cross(z,C),M+=this.m_ratio*this.m_ratio*(this.m_mD+this.m_mB)+this.m_iD*h*h+this.m_iB*r*r;var k=c.sub(this.m_localAnchorD,this.m_lcD),L=l.mulTVec2(w,c.add(z,c.sub(d,x)));e=c.dot(L,this.m_localAxisD)-c.dot(k,this.m_localAxisD)}var q=i+this.m_ratio*e-this.m_constant,F=0;return M>0&&(F=-q/M),_.addMul(this.m_mA*F,o),p+=this.m_iA*F*n,d.addMul(this.m_mB*F,s),y+=this.m_iB*F*r,f.subMul(this.m_mC*F,o),v-=this.m_iC*F*a,x.subMul(this.m_mD*F,s),g-=this.m_iD*F*h,this.m_bodyA.c_position.c.set(_),this.m_bodyA.c_position.a=p,this.m_bodyB.c_position.c.set(d),this.m_bodyB.c_position.a=y,this.m_bodyC.c_position.c.set(f),this.m_bodyC.c_position.a=v,this.m_bodyD.c_position.c.set(x),this.m_bodyD.c_position.a=g,0<m.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":51,"../util/create":52,"../util/options":53,"./PrismaticJoint":33,"./RevoluteJoint":35}],31:[function(t,i,e){function o(t,i,e){if(!(this instanceof o))return new o(t,i,e);t=n(t,_),l.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=o.TYPE,this.m_linearOffset=t.linearOffset?t.linearOffset:i.getLocalPoint(e.getPosition());var s=i.getAngle(),r=e.getAngle();this.m_angularOffset=r-s,this.m_linearImpulse=m.zero(),this.m_angularImpulse=0,this.m_maxForce=t.maxForce,this.m_maxTorque=t.maxTorque,this.m_correctionFactor=t.correctionFactor,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_linearError,this.m_angularError,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_linearMass,this.m_angularMass}i.exports=o;var s=t("../util/common"),n=t("../util/options"),r=t("../util/create"),a=(t("../Settings"),t("../common/Math")),m=t("../common/Vec2"),h=(t("../common/Vec3"),t("../common/Mat22")),c=(t("../common/Mat33"),t("../common/Rot")),l=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="motor-joint";var _={maxForce:1,maxTorque:1,correctionFactor:.3};(o.prototype=r((o._super=l).prototype)).setMaxForce=function(t){s.assert(a.isFinite(t)&&t>=0),this.m_maxForce=t},o.prototype.getMaxForce=function(){return this.m_maxForce},o.prototype.setMaxTorque=function(t){s.assert(a.isFinite(t)&&t>=0),this.m_maxTorque=t},o.prototype.getMaxTorque=function(){return this.m_maxTorque},o.prototype.setCorrectionFactor=function(t){s.assert(a.isFinite(t)&&0<=t&&t<=1),this.m_correctionFactor=t},o.prototype.getCorrectionFactor=function(){return this.m_correctionFactor},o.prototype.setLinearOffset=function(t){t.x==this.m_linearOffset.x&&t.y==this.m_linearOffset.y||(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_linearOffset=t)},o.prototype.getLinearOffset=function(){return this.m_linearOffset},o.prototype.setAngularOffset=function(t){t!=this.m_angularOffset&&(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_angularOffset=t)},o.prototype.getAngularOffset=function(){return this.m_angularOffset},o.prototype.getAnchorA=function(){return this.m_bodyA.getPosition()},o.prototype.getAnchorB=function(){return this.m_bodyB.getPosition()},o.prototype.getReactionForce=function(t){return m.mul(t,this.m_linearImpulse)},o.prototype.getReactionTorque=function(t){return t*this.m_angularImpulse},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,r=this.m_bodyB.c_position.a,a=this.m_bodyB.c_velocity.v,l=this.m_bodyB.c_velocity.w,_=c.neo(e),u=c.neo(r);this.m_rA=c.mulVec2(_,m.neg(this.m_localCenterA)),this.m_rB=c.mulVec2(u,m.neg(this.m_localCenterB));var p=this.m_invMassA,d=this.m_invMassB,y=this.m_invIA,f=this.m_invIB,v=new h;if(v.ex.x=p+d+y*this.m_rA.y*this.m_rA.y+f*this.m_rB.y*this.m_rB.y,v.ex.y=-y*this.m_rA.x*this.m_rA.y-f*this.m_rB.x*this.m_rB.y,v.ey.x=v.ex.y,v.ey.y=p+d+y*this.m_rA.x*this.m_rA.x+f*this.m_rB.x*this.m_rB.x,this.m_linearMass=v.getInverse(),this.m_angularMass=y+f,this.m_angularMass>0&&(this.m_angularMass=1/this.m_angularMass),this.m_linearError=m.zero(),this.m_linearError.addCombine(1,n,1,this.m_rB),this.m_linearError.subCombine(1,i,1,this.m_rA),this.m_linearError.sub(c.mulVec2(_,this.m_linearOffset)),this.m_angularError=r-e-this.m_angularOffset,t.warmStarting){this.m_linearImpulse.mul(t.dtRatio),this.m_angularImpulse*=t.dtRatio;var x=m.neo(this.m_linearImpulse.x,this.m_linearImpulse.y);o.subMul(p,x),s-=y*(m.cross(this.m_rA,x)+this.m_angularImpulse),a.addMul(d,x),l+=f*(m.cross(this.m_rB,x)+this.m_angularImpulse)}else this.m_linearImpulse.setZero(),this.m_angularImpulse=0;this.m_bodyA.c_velocity.v=o,this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v=a,this.m_bodyB.c_velocity.w=l},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,r=this.m_invMassB,c=this.m_invIA,l=this.m_invIB,_=t.dt,u=t.inv_dt,p=s-e+u*this.m_correctionFactor*this.m_angularError,d=-this.m_angularMass*p,y=this.m_angularImpulse,f=_*this.m_maxTorque;this.m_angularImpulse=a.clamp(this.m_angularImpulse+d,-f,f),e-=c*(d=this.m_angularImpulse-y),s+=l*d;(p=m.zero()).addCombine(1,o,1,m.cross(s,this.m_rB)),p.subCombine(1,i,1,m.cross(e,this.m_rA)),p.addMul(u*this.m_correctionFactor,this.m_linearError);d=m.neg(h.mulVec2(this.m_linearMass,p)),y=m.clone(this.m_linearImpulse);this.m_linearImpulse.add(d);f=_*this.m_maxForce;this.m_linearImpulse.clamp(f),d=m.sub(this.m_linearImpulse,y),i.subMul(n,d),e-=c*m.cross(this.m_rA,d),o.addMul(r,d),s+=l*m.cross(this.m_rB,d),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){return!0}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":51,"../util/create":52,"../util/options":53}],32:[function(t,i,e){function o(t,i,e,a){if(!(this instanceof o))return new o(t,i,e,a);t=r(t,p),u.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=o.TYPE,s&&n.assert(m.isFinite(t.maxForce)&&t.maxForce>=0),s&&n.assert(m.isFinite(t.frequencyHz)&&t.frequencyHz>=0),s&&n.assert(m.isFinite(t.dampingRatio)&&t.dampingRatio>=0),this.m_targetA=a?h.clone(a):t.target||h.zero(),this.m_localAnchorB=_.mulTVec2(e.getTransform(),this.m_targetA),this.m_maxForce=t.maxForce,this.m_impulse=h.zero(),this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_beta=0,this.m_gamma=0,this.m_rB=h.zero(),this.m_localCenterB=h.zero(),this.m_invMassB=0,this.m_invIB=0,this.mass=new c,this.m_C=h.zero()}var s=!0;i.exports=o;var n=t("../util/common"),r=t("../util/options"),a=t("../util/create"),m=t("../common/Math"),h=t("../common/Vec2"),c=(t("../common/Vec3"),t("../common/Mat22")),l=(t("../common/Mat33"),t("../common/Rot")),_=(t("../common/Sweep"),t("../common/Transform")),u=(t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="mouse-joint";var p={maxForce:0,frequencyHz:5,dampingRatio:.7};(o.prototype=a((o._super=u).prototype)).setTarget=function(t){0==this.m_bodyB.isAwake()&&this.m_bodyB.setAwake(!0),this.m_targetA=h.clone(t)},o.prototype.getTarget=function(){return this.m_targetA},o.prototype.setMaxForce=function(t){this.m_maxForce=t},o.getMaxForce=function(){return this.m_maxForce},o.prototype.setFrequency=function(t){this.m_frequencyHz=t},o.prototype.getFrequency=function(){return this.m_frequencyHz},o.prototype.setDampingRatio=function(t){this.m_dampingRatio=t},o.prototype.getDampingRatio=function(){return this.m_dampingRatio},o.prototype.getAnchorA=function(){return h.clone(this.m_targetA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return h.mul(t,this.m_impulse)},o.prototype.getReactionTorque=function(t){return 0*t},o.prototype.shiftOrigin=function(t){this.m_targetA.sub(t)},o.prototype.initVelocityConstraints=function(t){this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyB.c_position,e=this.m_bodyB.c_velocity,o=i.c,r=i.a,a=e.v,_=e.w,u=l.neo(r),p=this.m_bodyB.getMass(),d=2*m.PI*this.m_frequencyHz,y=2*p*this.m_dampingRatio*d,f=p*(d*d),v=t.dt;s&&n.assert(y+v*f>m.EPSILON),this.m_gamma=v*(y+v*f),0!=this.m_gamma&&(this.m_gamma=1/this.m_gamma),this.m_beta=v*f*this.m_gamma,this.m_rB=l.mulVec2(u,h.sub(this.m_localAnchorB,this.m_localCenterB));var x=new c;x.ex.x=this.m_invMassB+this.m_invIB*this.m_rB.y*this.m_rB.y+this.m_gamma,x.ex.y=-this.m_invIB*this.m_rB.x*this.m_rB.y,x.ey.x=x.ex.y,x.ey.y=this.m_invMassB+this.m_invIB*this.m_rB.x*this.m_rB.x+this.m_gamma,this.m_mass=x.getInverse(),this.m_C.set(o),this.m_C.addCombine(1,this.m_rB,-1,this.m_targetA),this.m_C.mul(this.m_beta),_*=.98,t.warmStarting?(this.m_impulse.mul(t.dtRatio),a.addMul(this.m_invMassB,this.m_impulse),_+=this.m_invIB*h.cross(this.m_rB,this.m_impulse)):this.m_impulse.setZero(),e.v.set(a),e.w=_},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyB.c_velocity,e=h.clone(i.v),o=i.w,s=h.cross(o,this.m_rB);s.add(e),s.addCombine(1,this.m_C,this.m_gamma,this.m_impulse),s.neg();var n=c.mulVec2(this.m_mass,s),r=h.clone(this.m_impulse);this.m_impulse.add(n);var a=t.dt*this.m_maxForce;this.m_impulse.clamp(a),n=h.sub(this.m_impulse,r),e.addMul(this.m_invMassB,n),o+=this.m_invIB*h.cross(this.m_rB,n),i.v.set(e),i.w=o},o.prototype.solvePositionConstraints=function(t){return!0}},{"../Joint":5,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":51,"../util/create":52,"../util/options":53}],33:[function(t,i,e){function o(t,i,e,s,r){if(!(this instanceof o))return new o(t,i,e,s,r);t=n(t,y),p.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=o.TYPE,this.m_localAnchorA=s?i.getLocalPoint(s):t.localAnchorA||h.zero(),this.m_localAnchorB=s?e.getLocalPoint(s):t.localAnchorB||h.zero(),this.m_localXAxisA=r?i.getLocalVector(r):t.localAxisA||h.neo(1,0),this.m_localXAxisA.normalize(),this.m_localYAxisA=h.cross(1,this.m_localXAxisA),this.m_referenceAngle=m.isFinite(t.referenceAngle)?t.referenceAngle:e.getAngle()-i.getAngle(),this.m_impulse=c(),this.m_motorMass=0,this.m_motorImpulse=0,this.m_lowerTranslation=t.lowerTranslation,this.m_upperTranslation=t.upperTranslation,this.m_maxMotorForce=t.maxMotorForce,this.m_motorSpeed=t.motorSpeed,this.m_enableLimit=t.enableLimit,this.m_enableMotor=t.enableMotor,this.m_limitState=d,this.m_axis=h.zero(),this.m_perp=h.zero(),this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_axis,this.m_perp,this.m_s1,this.m_s2,this.m_a1,this.m_a2,this.m_K=new _,this.m_motorMass}i.exports=o;var s=t("../util/common"),n=t("../util/options"),r=t("../util/create"),a=t("../Settings"),m=t("../common/Math"),h=t("../common/Vec2"),c=t("../common/Vec3"),l=t("../common/Mat22"),_=t("../common/Mat33"),u=t("../common/Rot"),p=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint")),d=0;o.TYPE="prismatic-joint";var y={enableLimit:!1,lowerTranslation:0,upperTranslation:0,enableMotor:!1,maxMotorForce:0,motorSpeed:0};(o.prototype=r((o._super=p).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.getLocalAxisA=function(){return this.m_localXAxisA},o.prototype.getReferenceAngle=function(){return this.m_referenceAngle},o.prototype.getJointTranslation=function(){var t=this.m_bodyA.getWorldPoint(this.m_localAnchorA),i=this.m_bodyB.getWorldPoint(this.m_localAnchorB),e=h.sub(i,t),o=this.m_bodyA.getWorldVector(this.m_localXAxisA);return h.dot(e,o)},o.prototype.getJointSpeed=function(){var t=this.m_bodyA,i=this.m_bodyB,e=u.mulVec2(t.m_xf.q,h.sub(this.m_localAnchorA,t.m_sweep.localCenter)),o=u.mulVec2(i.m_xf.q,h.sub(this.m_localAnchorB,i.m_sweep.localCenter)),s=h.add(t.m_sweep.c,e),n=h.add(i.m_sweep.c,o),r=h.sub(n,s),a=u.mulVec2(t.m_xf.q,this.m_localXAxisA),m=t.m_linearVelocity,c=i.m_linearVelocity,l=t.m_angularVelocity,_=i.m_angularVelocity;return h.dot(r,h.cross(l,a))+h.dot(a,h.sub(h.addCross(c,_,o),h.addCross(m,l,e)))},o.prototype.isLimitEnabled=function(){return this.m_enableLimit},o.prototype.enableLimit=function(t){t!=this.m_enableLimit&&(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableLimit=t,this.m_impulse.z=0)},o.prototype.getLowerLimit=function(){return this.m_lowerTranslation},o.prototype.getUpperLimit=function(){return this.m_upperTranslation},o.prototype.setLimits=function(t,i){s.assert(t<=i),t==this.m_lowerTranslation&&i==this.m_upperTranslation||(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_lowerTranslation=t,this.m_upperTranslation=i,this.m_impulse.z=0)},o.prototype.isMotorEnabled=function(){return this.m_enableMotor},o.prototype.enableMotor=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableMotor=t},o.prototype.setMotorSpeed=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_motorSpeed=t},o.prototype.setMaxMotorForce=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_maxMotorForce=t},o.prototype.getMotorSpeed=function(){return this.m_motorSpeed},o.prototype.getMotorForce=function(t){return t*this.m_motorImpulse},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return h.combine(this.m_impulse.x,this.m_perp,this.m_motorImpulse+this.m_impulse.z,this.m_axis).mul(t)},o.prototype.getReactionTorque=function(t){return t*this.m_impulse.y},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,r=this.m_bodyB.c_position.a,c=this.m_bodyB.c_velocity.v,l=this.m_bodyB.c_velocity.w,_=u.neo(e),p=u.neo(r),y=u.mulVec2(_,h.sub(this.m_localAnchorA,this.m_localCenterA)),f=u.mulVec2(p,h.sub(this.m_localAnchorB,this.m_localCenterB)),v=h.zero();v.addCombine(1,n,1,f),v.subCombine(1,i,1,y);var x=this.m_invMassA,g=this.m_invMassB,b=this.m_invIA,A=this.m_invIB;this.m_axis=u.mulVec2(_,this.m_localXAxisA),this.m_a1=h.cross(h.add(v,y),this.m_axis),this.m_a2=h.cross(f,this.m_axis),this.m_motorMass=x+g+b*this.m_a1*this.m_a1+A*this.m_a2*this.m_a2,this.m_motorMass>0&&(this.m_motorMass=1/this.m_motorMass),this.m_perp=u.mulVec2(_,this.m_localYAxisA),this.m_s1=h.cross(h.add(v,y),this.m_perp),this.m_s2=h.cross(f,this.m_perp);h.cross(y,this.m_perp);var B=x+g+b*this.m_s1*this.m_s1+A*this.m_s2*this.m_s2,w=b*this.m_s1+A*this.m_s2,M=b*this.m_s1*this.m_a1+A*this.m_s2*this.m_a2,C=b+A;0==C&&(C=1);var V=b*this.m_a1+A*this.m_a2,S=x+g+b*this.m_a1*this.m_a1+A*this.m_a2*this.m_a2;if(this.m_K.ex.set(B,w,M),this.m_K.ey.set(w,C,V),this.m_K.ez.set(M,V,S),this.m_enableLimit){var I=h.dot(this.m_axis,v);m.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*a.linearSlop?this.m_limitState=3:I<=this.m_lowerTranslation?1!=this.m_limitState&&(this.m_limitState=1,this.m_impulse.z=0):I>=this.m_upperTranslation?2!=this.m_limitState&&(this.m_limitState=2,this.m_impulse.z=0):(this.m_limitState=d,this.m_impulse.z=0)}else this.m_limitState=d,this.m_impulse.z=0;if(0==this.m_enableMotor&&(this.m_motorImpulse=0),t.warmStarting){this.m_impulse.mul(t.dtRatio),this.m_motorImpulse*=t.dtRatio;var P=h.combine(this.m_impulse.x,this.m_perp,this.m_motorImpulse+this.m_impulse.z,this.m_axis),T=this.m_impulse.x*this.m_s1+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a1,z=this.m_impulse.x*this.m_s2+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a2;o.subMul(x,P),s-=b*T,c.addMul(g,P),l+=A*z}else this.m_impulse.setZero(),this.m_motorImpulse=0;this.m_bodyA.c_velocity.v.set(o),this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v.set(c),this.m_bodyB.c_velocity.w=l},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,r=this.m_invMassB,a=this.m_invIA,l=this.m_invIB;if(this.m_enableMotor&&3!=this.m_limitState){var _=h.dot(this.m_axis,h.sub(o,i))+this.m_a2*s-this.m_a1*e,u=this.m_motorMass*(this.m_motorSpeed-_),p=this.m_motorImpulse,y=t.dt*this.m_maxMotorForce;this.m_motorImpulse=m.clamp(this.m_motorImpulse+u,-y,y),u=this.m_motorImpulse-p;var f=h.mul(u,this.m_axis),v=u*this.m_a1,x=u*this.m_a2;i.subMul(n,f),e-=a*v,o.addMul(r,f),s+=l*x}var g=h.zero();if(g.x+=h.dot(this.m_perp,o)+this.m_s2*s,g.x-=h.dot(this.m_perp,i)+this.m_s1*e,g.y=s-e,this.m_enableLimit&&this.m_limitState!=d){var b=0;b+=h.dot(this.m_axis,o)+this.m_a2*s,b-=h.dot(this.m_axis,i)+this.m_a1*e;_=c(g.x,g.y,b);var A=c(this.m_impulse),B=this.m_K.solve33(c.neg(_));this.m_impulse.add(B),1==this.m_limitState?this.m_impulse.z=m.max(this.m_impulse.z,0):2==this.m_limitState&&(this.m_impulse.z=m.min(this.m_impulse.z,0));var w=h.combine(-1,g,-(this.m_impulse.z-A.z),h.neo(this.m_K.ez.x,this.m_K.ez.y)),M=h.add(this.m_K.solve22(w),h.neo(A.x,A.y));this.m_impulse.x=M.x,this.m_impulse.y=M.y,B=c.sub(this.m_impulse,A);f=h.combine(B.x,this.m_perp,B.z,this.m_axis),v=B.x*this.m_s1+B.y+B.z*this.m_a1,x=B.x*this.m_s2+B.y+B.z*this.m_a2;i.subMul(n,f),e-=a*v,o.addMul(r,f),s+=l*x}else{B=this.m_K.solve22(h.neg(g));this.m_impulse.x+=B.x,this.m_impulse.y+=B.y;f=h.mul(B.x,this.m_perp),v=B.x*this.m_s1+B.y,x=B.x*this.m_s2+B.y;i.subMul(n,f),e-=a*v,o.addMul(r,f),s+=l*x}this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=u.neo(e),r=u.neo(s),p=this.m_invMassA,d=this.m_invMassB,y=this.m_invIA,f=this.m_invIB,v=u.mulVec2(n,h.sub(this.m_localAnchorA,this.m_localCenterA)),x=u.mulVec2(r,h.sub(this.m_localAnchorB,this.m_localCenterB)),g=h.sub(h.add(o,x),h.add(i,v)),b=u.mulVec2(n,this.m_localXAxisA),A=h.cross(h.add(g,v),b),B=h.cross(x,b),w=u.mulVec2(n,this.m_localYAxisA),M=h.cross(h.add(g,v),w),C=h.cross(x,w),V=c(),S=h.zero();S.x=h.dot(w,g),S.y=s-e-this.m_referenceAngle;var I=m.abs(S.x),P=m.abs(S.y),T=a.linearSlop,z=a.maxLinearCorrection,k=!1,L=0;if(this.m_enableLimit){var q=h.dot(b,g);m.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*T?(L=m.clamp(q,-z,z),I=m.max(I,m.abs(q)),k=!0):q<=this.m_lowerTranslation?(L=m.clamp(q-this.m_lowerTranslation+T,-z,0),I=m.max(I,this.m_lowerTranslation-q),k=!0):q>=this.m_upperTranslation&&(L=m.clamp(q-this.m_upperTranslation-T,0,z),I=m.max(I,q-this.m_upperTranslation),k=!0)}if(k){var F=p+d+y*M*M+f*C*C,R=y*M+f*C,E=y*M*A+f*C*B;0==(J=y+f)&&(J=1);var j=y*A+f*B,D=p+d+y*A*A+f*B*B;(N=new _).ex.set(F,R,E),N.ey.set(R,J,j),N.ez.set(E,j,D);var Y=c();Y.x=S.x,Y.y=S.y,Y.z=L,V=N.solve33(c.neg(Y))}else{var J;F=p+d+y*M*M+f*C*C,R=y*M+f*C;0==(J=y+f)&&(J=1);var N;(N=new l).ex.set(F,R),N.ey.set(R,J);var O=N.solve(h.neg(S));V.x=O.x,V.y=O.y,V.z=0}var W=h.combine(V.x,w,V.z,b),X=V.x*M+V.y+V.z*A,H=V.x*C+V.y+V.z*B;return i.subMul(p,W),e-=y*X,o.addMul(d,W),s+=f*H,this.m_bodyA.c_position.c=i,this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c=o,this.m_bodyB.c_position.a=s,I<=a.linearSlop&&P<=a.angularSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":51,"../util/create":52,"../util/options":53}],34:[function(t,i,e){function o(t,i,e,a,m,l,p,d){if(!(this instanceof o))return new o(t,i,e,a,m,l,p,d);t=r(t,u),_.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=o.TYPE,this.m_groundAnchorA=a||(t.groundAnchorA||c.neo(-1,1)),this.m_groundAnchorB=m||(t.groundAnchorB||c.neo(1,1)),this.m_localAnchorA=l?i.getLocalPoint(l):t.localAnchorA||c.neo(-1,0),this.m_localAnchorB=p?e.getLocalPoint(p):t.localAnchorB||c.neo(1,0),this.m_lengthA=h.isFinite(t.lengthA)?t.lengthA:c.distance(l,a),this.m_lengthB=h.isFinite(t.lengthB)?t.lengthB:c.distance(p,m),this.m_ratio=h.isFinite(d)?d:t.ratio,s&&n.assert(d>h.EPSILON),this.m_constant=this.m_lengthA+this.m_ratio*this.m_lengthB,this.m_impulse=0,this.m_uA,this.m_uB,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass}var s=!0;i.exports=o;var n=t("../util/common"),r=t("../util/options"),a=t("../util/create"),m=t("../Settings"),h=t("../common/Math"),c=t("../common/Vec2"),l=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),_=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="pulley-joint",o.MIN_PULLEY_LENGTH=2;var u={collideConnected:!0};(o.prototype=a((o._super=_).prototype)).getGroundAnchorA=function(){return this.m_groundAnchorA},o.prototype.getGroundAnchorB=function(){return this.m_groundAnchorB},o.prototype.getLengthA=function(){return this.m_lengthA},o.prototype.getLengthB=function(){return this.m_lengthB},o.prototype.getRatio=function(){return this.m_ratio},o.prototype.getCurrentLengthA=function(){var t=this.m_bodyA.getWorldPoint(this.m_localAnchorA),i=this.m_groundAnchorA;return c.distance(t,i)},o.prototype.getCurrentLengthB=function(){var t=this.m_bodyB.getWorldPoint(this.m_localAnchorB),i=this.m_groundAnchorB;return c.distance(t,i)},o.prototype.shiftOrigin=function(t){this.m_groundAnchorA.sub(t),this.m_groundAnchorB.sub(t)},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return c.mul(this.m_impulse,this.m_uB).mul(t)},o.prototype.getReactionTorque=function(t){return 0},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,r=this.m_bodyB.c_position.a,a=this.m_bodyB.c_velocity.v,h=this.m_bodyB.c_velocity.w,_=l.neo(e),u=l.neo(r);this.m_rA=l.mulVec2(_,c.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=l.mulVec2(u,c.sub(this.m_localAnchorB,this.m_localCenterB)),this.m_uA=c.sub(c.add(i,this.m_rA),this.m_groundAnchorA),this.m_uB=c.sub(c.add(n,this.m_rB),this.m_groundAnchorB);var p=this.m_uA.length(),d=this.m_uB.length();p>10*m.linearSlop?this.m_uA.mul(1/p):this.m_uA.setZero(),d>10*m.linearSlop?this.m_uB.mul(1/d):this.m_uB.setZero();var y=c.cross(this.m_rA,this.m_uA),f=c.cross(this.m_rB,this.m_uB),v=this.m_invMassA+this.m_invIA*y*y,x=this.m_invMassB+this.m_invIB*f*f;if(this.m_mass=v+this.m_ratio*this.m_ratio*x,this.m_mass>0&&(this.m_mass=1/this.m_mass),t.warmStarting){this.m_impulse*=t.dtRatio;var g=c.mul(-this.m_impulse,this.m_uA),b=c.mul(-this.m_ratio*this.m_impulse,this.m_uB);o.addMul(this.m_invMassA,g),s+=this.m_invIA*c.cross(this.m_rA,g),a.addMul(this.m_invMassB,b),h+=this.m_invIB*c.cross(this.m_rB,b)}else this.m_impulse=0;this.m_bodyA.c_velocity.v=o,this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v=a,this.m_bodyB.c_velocity.w=h},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=c.add(i,c.cross(e,this.m_rA)),r=c.add(o,c.cross(s,this.m_rB)),a=-c.dot(this.m_uA,n)-this.m_ratio*c.dot(this.m_uB,r),m=-this.m_mass*a;this.m_impulse+=m;var h=c.mul(-m,this.m_uA),l=c.mul(-this.m_ratio*m,this.m_uB);i.addMul(this.m_invMassA,h),e+=this.m_invIA*c.cross(this.m_rA,h),o.addMul(this.m_invMassB,l),s+=this.m_invIB*c.cross(this.m_rB,l),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=l.neo(e),r=l.neo(s),a=l.mulVec2(n,c.sub(this.m_localAnchorA,this.m_localCenterA)),_=l.mulVec2(r,c.sub(this.m_localAnchorB,this.m_localCenterB)),u=c.sub(c.add(i,this.m_rA),this.m_groundAnchorA),p=c.sub(c.add(o,this.m_rB),this.m_groundAnchorB),d=u.length(),y=p.length();d>10*m.linearSlop?u.mul(1/d):u.setZero(),y>10*m.linearSlop?p.mul(1/y):p.setZero();var f=c.cross(a,u),v=c.cross(_,p),x=this.m_invMassA+this.m_invIA*f*f,g=this.m_invMassB+this.m_invIB*v*v,b=x+this.m_ratio*this.m_ratio*g;b>0&&(b=1/b);var A=this.m_constant-d-this.m_ratio*y,B=h.abs(A),w=-b*A,M=c.mul(-w,u),C=c.mul(-this.m_ratio*w,p);return i.addMul(this.m_invMassA,M),e+=this.m_invIA*c.cross(a,M),o.addMul(this.m_invMassB,C),s+=this.m_invIB*c.cross(_,C),this.m_bodyA.c_position.c=i,this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c=o,this.m_bodyB.c_position.a=s,B<m.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":51,"../util/create":52,"../util/options":53}],35:[function(t,i,e){function o(t,i,e,s){if(!(this instanceof o))return new o(t,i,e,s);t=n(t,y),p.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=o.TYPE,this.m_localAnchorA=s?i.getLocalPoint(s):t.localAnchorA||h.zero(),this.m_localAnchorB=s?e.getLocalPoint(s):t.localAnchorB||h.zero(),this.m_referenceAngle=m.isFinite(t.referenceAngle)?t.referenceAngle:e.getAngle()-i.getAngle(),this.m_impulse=c(),this.m_motorImpulse=0,this.m_lowerAngle=t.lowerAngle,this.m_upperAngle=t.upperAngle,this.m_maxMotorTorque=t.maxMotorTorque,this.m_motorSpeed=t.motorSpeed,this.m_enableLimit=t.enableLimit,this.m_enableMotor=t.enableMotor,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass=new _,this.m_motorMass,this.m_limitState=d}i.exports=o;var s=t("../util/common"),n=t("../util/options"),r=t("../util/create"),a=t("../Settings"),m=t("../common/Math"),h=t("../common/Vec2"),c=t("../common/Vec3"),l=t("../common/Mat22"),_=t("../common/Mat33"),u=t("../common/Rot"),p=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint")),d=0;o.TYPE="revolute-joint";var y={lowerAngle:0,upperAngle:0,maxMotorTorque:0,motorSpeed:0,enableLimit:!1,enableMotor:!1};(o.prototype=r((o._super=p).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.getReferenceAngle=function(){return this.m_referenceAngle},o.prototype.getJointAngle=function(){var t=this.m_bodyA;return this.m_bodyB.m_sweep.a-t.m_sweep.a-this.m_referenceAngle},o.prototype.getJointSpeed=function(){var t=this.m_bodyA;return this.m_bodyB.m_angularVelocity-t.m_angularVelocity},o.prototype.isMotorEnabled=function(){return this.m_enableMotor},o.prototype.enableMotor=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableMotor=t},o.prototype.getMotorTorque=function(t){return t*this.m_motorImpulse},o.prototype.setMotorSpeed=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_motorSpeed=t},o.prototype.getMotorSpeed=function(){return this.m_motorSpeed},o.prototype.setMaxMotorTorque=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_maxMotorTorque=t},o.prototype.isLimitEnabled=function(){return this.m_enableLimit},o.prototype.enableLimit=function(t){t!=this.m_enableLimit&&(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableLimit=t,this.m_impulse.z=0)},o.prototype.getLowerLimit=function(){return this.m_lowerAngle},o.prototype.getUpperLimit=function(){return this.m_upperAngle},o.prototype.setLimits=function(t,i){s.assert(t<=i),t==this.m_lowerAngle&&i==this.m_upperAngle||(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_impulse.z=0,this.m_lowerAngle=t,this.m_upperAngle=i)},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return h.neo(this.m_impulse.x,this.m_impulse.y).mul(t)},o.prototype.getReactionTorque=function(t){return t*this.m_impulse.z},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,r=this.m_bodyB.c_velocity.w,c=u.neo(i),l=u.neo(s);this.m_rA=u.mulVec2(c,h.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=u.mulVec2(l,h.sub(this.m_localAnchorB,this.m_localCenterB));var _=this.m_invMassA,p=this.m_invMassB,y=this.m_invIA,f=this.m_invIB,v=y+f===0;if(this.m_mass.ex.x=_+p+this.m_rA.y*this.m_rA.y*y+this.m_rB.y*this.m_rB.y*f,this.m_mass.ey.x=-this.m_rA.y*this.m_rA.x*y-this.m_rB.y*this.m_rB.x*f,this.m_mass.ez.x=-this.m_rA.y*y-this.m_rB.y*f,this.m_mass.ex.y=this.m_mass.ey.x,this.m_mass.ey.y=_+p+this.m_rA.x*this.m_rA.x*y+this.m_rB.x*this.m_rB.x*f,this.m_mass.ez.y=this.m_rA.x*y+this.m_rB.x*f,this.m_mass.ex.z=this.m_mass.ez.x,this.m_mass.ey.z=this.m_mass.ez.y,this.m_mass.ez.z=y+f,this.m_motorMass=y+f,this.m_motorMass>0&&(this.m_motorMass=1/this.m_motorMass),(0==this.m_enableMotor||v)&&(this.m_motorImpulse=0),this.m_enableLimit&&0==v){var x=s-i-this.m_referenceAngle;m.abs(this.m_upperAngle-this.m_lowerAngle)<2*a.angularSlop?this.m_limitState=3:x<=this.m_lowerAngle?(1!=this.m_limitState&&(this.m_impulse.z=0),this.m_limitState=1):x>=this.m_upperAngle?(2!=this.m_limitState&&(this.m_impulse.z=0),this.m_limitState=2):(this.m_limitState=d,this.m_impulse.z=0)}else this.m_limitState=d;if(t.warmStarting){this.m_impulse.mul(t.dtRatio),this.m_motorImpulse*=t.dtRatio;var g=h.neo(this.m_impulse.x,this.m_impulse.y);e.subMul(_,g),o-=y*(h.cross(this.m_rA,g)+this.m_motorImpulse+this.m_impulse.z),n.addMul(p,g),r+=f*(h.cross(this.m_rB,g)+this.m_motorImpulse+this.m_impulse.z)}else this.m_impulse.setZero(),this.m_motorImpulse=0;this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=n,this.m_bodyB.c_velocity.w=r},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,r=this.m_invMassB,a=this.m_invIA,l=this.m_invIB,_=a+l===0;if(this.m_enableMotor&&3!=this.m_limitState&&0==_){var u=s-e-this.m_motorSpeed,p=-this.m_motorMass*u,y=this.m_motorImpulse,f=t.dt*this.m_maxMotorTorque;this.m_motorImpulse=m.clamp(this.m_motorImpulse+p,-f,f),e-=a*(p=this.m_motorImpulse-y),s+=l*p}if(this.m_enableLimit&&this.m_limitState!=d&&0==_){var v=h.zero();v.addCombine(1,o,1,h.cross(s,this.m_rB)),v.subCombine(1,i,1,h.cross(e,this.m_rA));var x=s-e;u=c(v.x,v.y,x),p=c.neg(this.m_mass.solve33(u));if(3==this.m_limitState)this.m_impulse.add(p);else if(1==this.m_limitState){if(this.m_impulse.z+p.z<0){var g=h.combine(-1,v,this.m_impulse.z,h.neo(this.m_mass.ez.x,this.m_mass.ez.y)),b=this.m_mass.solve22(g);p.x=b.x,p.y=b.y,p.z=-this.m_impulse.z,this.m_impulse.x+=b.x,this.m_impulse.y+=b.y,this.m_impulse.z=0}else this.m_impulse.add(p)}else if(2==this.m_limitState){if(this.m_impulse.z+p.z>0){g=h.combine(-1,v,this.m_impulse.z,h.neo(this.m_mass.ez.x,this.m_mass.ez.y)),b=this.m_mass.solve22(g);p.x=b.x,p.y=b.y,p.z=-this.m_impulse.z,this.m_impulse.x+=b.x,this.m_impulse.y+=b.y,this.m_impulse.z=0}else this.m_impulse.add(p)}var A=h.neo(p.x,p.y);i.subMul(n,A),e-=a*(h.cross(this.m_rA,A)+p.z),o.addMul(r,A),s+=l*(h.cross(this.m_rB,A)+p.z)}else{(u=h.zero()).addCombine(1,o,1,h.cross(s,this.m_rB)),u.subCombine(1,i,1,h.cross(e,this.m_rA));p=this.m_mass.solve22(h.neg(u));this.m_impulse.x+=p.x,this.m_impulse.y+=p.y,i.subMul(n,p),e-=a*h.cross(this.m_rA,p),o.addMul(r,p),s+=l*h.cross(this.m_rB,p)}this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=u.neo(e),r=u.neo(s),c=0,_=0,p=this.m_invIA+this.m_invIB==0;if(this.m_enableLimit&&this.m_limitState!=d&&0==p){var y=s-e-this.m_referenceAngle,f=0;if(3==this.m_limitState){var v=m.clamp(y-this.m_lowerAngle,-a.maxAngularCorrection,a.maxAngularCorrection);f=-this.m_motorMass*v,c=m.abs(v)}else if(1==this.m_limitState){c=-(v=y-this.m_lowerAngle),v=m.clamp(v+a.angularSlop,-a.maxAngularCorrection,0),f=-this.m_motorMass*v}else if(2==this.m_limitState){c=v=y-this.m_upperAngle,v=m.clamp(v-a.angularSlop,0,a.maxAngularCorrection),f=-this.m_motorMass*v}e-=this.m_invIA*f,s+=this.m_invIB*f}n.set(e),r.set(s);var x=u.mulVec2(n,h.sub(this.m_localAnchorA,this.m_localCenterA)),g=u.mulVec2(r,h.sub(this.m_localAnchorB,this.m_localCenterB));(v=h.zero()).addCombine(1,o,1,g),v.subCombine(1,i,1,x),_=v.length();var b=this.m_invMassA,A=this.m_invMassB,B=this.m_invIA,w=this.m_invIB,M=new l;M.ex.x=b+A+B*x.y*x.y+w*g.y*g.y,M.ex.y=-B*x.x*x.y-w*g.x*g.y,M.ey.x=M.ex.y,M.ey.y=b+A+B*x.x*x.x+w*g.x*g.x;var C=h.neg(M.solve(v));return i.subMul(b,C),e-=B*h.cross(x,C),o.addMul(A,C),s+=w*h.cross(g,C),this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c.set(o),this.m_bodyB.c_position.a=s,_<=a.linearSlop&&c<=a.angularSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":51,"../util/create":52,"../util/options":53}],36:[function(t,i,e){function o(t,i,e,n){if(!(this instanceof o))return new o(t,i,e,n);t=s(t,_),c.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=o.TYPE,this.m_localAnchorA=n?i.getLocalPoint(n):t.localAnchorA||m.neo(-1,0),this.m_localAnchorB=n?e.getLocalPoint(n):t.localAnchorB||m.neo(1,0),this.m_maxLength=t.maxLength,this.m_mass=0,this.m_impulse=0,this.m_length=0,this.m_state=l,this.m_u,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass}i.exports=o;var s=t("../util/options"),n=t("../util/create"),r=t("../Settings"),a=t("../common/Math"),m=t("../common/Vec2"),h=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),c=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint")),l=0;o.TYPE="rope-joint";var _={maxLength:0};(o.prototype=n((o._super=c).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.setMaxLength=function(t){this.m_maxLength=t},o.prototype.getMaxLength=function(){return this.m_maxLength},o.prototype.getLimitState=function(){return this.m_state},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return m.mul(this.m_impulse,this.m_u).mul(t)},o.prototype.getReactionTorque=function(t){return 0},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,a=this.m_bodyB.c_position.a,c=this.m_bodyB.c_velocity.v,_=this.m_bodyB.c_velocity.w,u=h.neo(e),p=h.neo(a);this.m_rA=h.mulSub(u,this.m_localAnchorA,this.m_localCenterA),this.m_rB=h.mulSub(p,this.m_localAnchorB,this.m_localCenterB),this.m_u=m.zero(),this.m_u.addCombine(1,n,1,this.m_rB),this.m_u.subCombine(1,i,1,this.m_rA),this.m_length=this.m_u.length();var d=this.m_length-this.m_maxLength;if(this.m_state=d>0?2:l,!(this.m_length>r.linearSlop))return this.m_u.setZero(),this.m_mass=0,void(this.m_impulse=0);this.m_u.mul(1/this.m_length);var y=m.cross(this.m_rA,this.m_u),f=m.cross(this.m_rB,this.m_u),v=this.m_invMassA+this.m_invIA*y*y+this.m_invMassB+this.m_invIB*f*f;if(this.m_mass=0!=v?1/v:0,t.warmStarting){this.m_impulse*=t.dtRatio;var x=m.mul(this.m_impulse,this.m_u);o.subMul(this.m_invMassA,x),s-=this.m_invIA*m.cross(this.m_rA,x),c.addMul(this.m_invMassB,x),_+=this.m_invIB*m.cross(this.m_rB,x)}else this.m_impulse=0;this.m_bodyA.c_velocity.v.set(o),this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v.set(c),this.m_bodyB.c_velocity.w=_},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=m.addCross(i,e,this.m_rA),r=m.addCross(o,s,this.m_rB),h=this.m_length-this.m_maxLength,c=m.dot(this.m_u,m.sub(r,n));h<0&&(c+=t.inv_dt*h);var l=-this.m_mass*c,_=this.m_impulse;this.m_impulse=a.min(0,this.m_impulse+l),l=this.m_impulse-_;var u=m.mul(l,this.m_u);i.subMul(this.m_invMassA,u),e-=this.m_invIA*m.cross(this.m_rA,u),o.addMul(this.m_invMassB,u),s+=this.m_invIB*m.cross(this.m_rB,u),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=h.neo(e),c=h.neo(s),l=h.mulSub(n,this.m_localAnchorA,this.m_localCenterA),_=h.mulSub(c,this.m_localAnchorB,this.m_localCenterB),u=m.zero();u.addCombine(1,o,1,_),u.subCombine(1,i,1,l);var p=u.normalize(),d=p-this.m_maxLength;d=a.clamp(d,0,r.maxLinearCorrection);var y=-this.m_mass*d,f=m.mul(y,u);return i.subMul(this.m_invMassA,f),e-=this.m_invIA*m.cross(l,f),o.addMul(this.m_invMassB,f),s+=this.m_invIB*m.cross(_,f),this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c.set(o),this.m_bodyB.c_position.a=s,p-this.m_maxLength<r.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/create":52,"../util/options":53}],37:[function(t,i,e){function o(t,i,e,n){if(!(this instanceof o))return new o(t,i,e,n);t=s(t,u),_.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=o.TYPE,this.m_localAnchorA=n?i.getLocalPoint(n):t.localAnchorA||m.zero(),this.m_localAnchorB=n?e.getLocalPoint(n):t.localAnchorB||m.zero(),this.m_referenceAngle=a.isFinite(t.referenceAngle)?t.referenceAngle:e.getAngle()-i.getAngle(),this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_impulse=h(),this.m_bias=0,this.m_gamma=0,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass=new c}i.exports=o;var s=t("../util/options"),n=t("../util/create"),r=t("../Settings"),a=t("../common/Math"),m=t("../common/Vec2"),h=t("../common/Vec3"),c=(t("../common/Mat22"),t("../common/Mat33")),l=t("../common/Rot"),_=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="weld-joint";var u={frequencyHz:0,dampingRatio:0};(o.prototype=n((o._super=_).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.getReferenceAngle=function(){return this.m_referenceAngle},o.prototype.setFrequency=function(t){this.m_frequencyHz=t},o.prototype.getFrequency=function(){return this.m_frequencyHz},o.prototype.setDampingRatio=function(t){this.m_dampingRatio=t},o.prototype.getDampingRatio=function(){return this.m_dampingRatio},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return m.neo(this.m_impulse.x,this.m_impulse.y).mul(t)},o.prototype.getReactionTorque=function(t){return t*this.m_impulse.z},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,r=this.m_bodyB.c_velocity.w,h=l.neo(i),_=l.neo(s);this.m_rA=l.mulVec2(h,m.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=l.mulVec2(_,m.sub(this.m_localAnchorB,this.m_localCenterB));var u=this.m_invMassA,p=this.m_invMassB,d=this.m_invIA,y=this.m_invIB,f=new c;if(f.ex.x=u+p+this.m_rA.y*this.m_rA.y*d+this.m_rB.y*this.m_rB.y*y,f.ey.x=-this.m_rA.y*this.m_rA.x*d-this.m_rB.y*this.m_rB.x*y,f.ez.x=-this.m_rA.y*d-this.m_rB.y*y,f.ex.y=f.ey.x,f.ey.y=u+p+this.m_rA.x*this.m_rA.x*d+this.m_rB.x*this.m_rB.x*y,f.ez.y=this.m_rA.x*d+this.m_rB.x*y,f.ex.z=f.ez.x,f.ey.z=f.ez.y,f.ez.z=d+y,this.m_frequencyHz>0){f.getInverse22(this.m_mass);var v=d+y,x=v>0?1/v:0,g=s-i-this.m_referenceAngle,b=2*a.PI*this.m_frequencyHz,A=2*x*this.m_dampingRatio*b,B=x*b*b,w=t.dt;this.m_gamma=w*(A+w*B),this.m_gamma=0!=this.m_gamma?1/this.m_gamma:0,this.m_bias=g*w*B*this.m_gamma,v+=this.m_gamma,this.m_mass.ez.z=0!=v?1/v:0}else 0==f.ez.z?(f.getInverse22(this.m_mass),this.m_gamma=0,this.m_bias=0):(f.getSymInverse33(this.m_mass),this.m_gamma=0,this.m_bias=0);if(t.warmStarting){this.m_impulse.mul(t.dtRatio);var M=m.neo(this.m_impulse.x,this.m_impulse.y);e.subMul(u,M),o-=d*(m.cross(this.m_rA,M)+this.m_impulse.z),n.addMul(p,M),r+=y*(m.cross(this.m_rB,M)+this.m_impulse.z)}else this.m_impulse.setZero();this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=n,this.m_bodyB.c_velocity.w=r},o.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,o=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,r=this.m_invMassB,a=this.m_invIA,l=this.m_invIB;if(this.m_frequencyHz>0){var _=s-e,u=-this.m_mass.ez.z*(_+this.m_bias+this.m_gamma*this.m_impulse.z);this.m_impulse.z+=u,e-=a*u,s+=l*u;(y=m.zero()).addCombine(1,o,1,m.cross(s,this.m_rB)),y.subCombine(1,i,1,m.cross(e,this.m_rA));var p=m.neg(c.mulVec2(this.m_mass,y));this.m_impulse.x+=p.x,this.m_impulse.y+=p.y;var d=m.clone(p);i.subMul(n,d),e-=a*m.cross(this.m_rA,d),o.addMul(r,d),s+=l*m.cross(this.m_rB,d)}else{var y;(y=m.zero()).addCombine(1,o,1,m.cross(s,this.m_rB)),y.subCombine(1,i,1,m.cross(e,this.m_rA));_=s-e;var f=h(y.x,y.y,_),v=h.neg(c.mulVec3(this.m_mass,f));this.m_impulse.add(v);d=m.neo(v.x,v.y);i.subMul(n,d),e-=a*(m.cross(this.m_rA,d)+v.z),o.addMul(r,d),s+=l*(m.cross(this.m_rB,d)+v.z)}this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=o,this.m_bodyB.c_velocity.w=s},o.prototype.solvePositionConstraints=function(t){var i,e,o=this.m_bodyA.c_position.c,s=this.m_bodyA.c_position.a,n=this.m_bodyB.c_position.c,_=this.m_bodyB.c_position.a,u=l.neo(s),p=l.neo(_),d=this.m_invMassA,y=this.m_invMassB,f=this.m_invIA,v=this.m_invIB,x=l.mulVec2(u,m.sub(this.m_localAnchorA,this.m_localCenterA)),g=l.mulVec2(p,m.sub(this.m_localAnchorB,this.m_localCenterB)),b=new c;if(b.ex.x=d+y+x.y*x.y*f+g.y*g.y*v,b.ey.x=-x.y*x.x*f-g.y*g.x*v,b.ez.x=-x.y*f-g.y*v,b.ex.y=b.ey.x,b.ey.y=d+y+x.x*x.x*f+g.x*g.x*v,b.ez.y=x.x*f+g.x*v,b.ex.z=b.ez.x,b.ey.z=b.ez.y,b.ez.z=f+v,this.m_frequencyHz>0){(B=m.zero()).addCombine(1,n,1,g),B.subCombine(1,o,1,x),i=B.length(),e=0;var A=m.neg(b.solve22(B));o.subMul(d,A),s-=f*m.cross(x,A),n.addMul(y,A),_+=v*m.cross(g,A)}else{var B;(B=m.zero()).addCombine(1,n,1,g),B.subCombine(1,o,1,x);var w=_-s-this.m_referenceAngle;i=B.length(),e=a.abs(w);var M=h(B.x,B.y,w),C=h();if(b.ez.z>0)C=h.neg(b.solve33(M));else{var V=m.neg(b.solve22(B));C.set(V.x,V.y,0)}A=m.neo(C.x,C.y);o.subMul(d,A),s-=f*(m.cross(x,A)+C.z),n.addMul(y,A),_+=v*(m.cross(g,A)+C.z)}return this.m_bodyA.c_position.c=o,this.m_bodyA.c_position.a=s,this.m_bodyB.c_position.c=n,this.m_bodyB.c_position.a=_,i<=r.linearSlop&&e<=r.angularSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/create":52,"../util/options":53}],38:[function(t,i,e){function o(t,i,e,n,r){if(!(this instanceof o))return new o(t,i,e,n,r);t=s(t,l),c.call(this,t,i,e),i=this.m_bodyA,e=this.m_bodyB,this.m_type=o.TYPE,this.m_localAnchorA=n?i.getLocalPoint(n):t.localAnchorA||m.zero(),this.m_localAnchorB=n?e.getLocalPoint(n):t.localAnchorB||m.zero(),this.m_localAxis=r?i.getLocalVector(r):t.localAxisA||m.neo(1,0),this.m_localXAxisA=this.m_localAxis,this.m_localYAxisA=m.cross(1,this.m_localXAxisA),this.m_mass=0,this.m_impulse=0,this.m_motorMass=0,this.m_motorImpulse=0,this.m_springMass=0,this.m_springImpulse=0,this.m_maxMotorTorque=t.maxMotorTorque,this.m_motorSpeed=t.motorSpeed,this.m_enableMotor=t.enableMotor,this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_bias=0,this.m_gamma=0,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_ax=m.zero(),this.m_ay=m.zero(),this.m_sAx,this.m_sBx,this.m_sAy,this.m_sBy}i.exports=o;var s=t("../util/options"),n=t("../util/create"),r=t("../Settings"),a=t("../common/Math"),m=t("../common/Vec2"),h=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),c=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));o.TYPE="wheel-joint";var l={enableMotor:!1,maxMotorTorque:0,motorSpeed:0,frequencyHz:2,dampingRatio:.7};(o.prototype=n((o._super=c).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},o.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},o.prototype.getLocalAxisA=function(){return this.m_localXAxisA},o.prototype.getJointTranslation=function(){var t=this.m_bodyA,i=this.m_bodyB,e=t.getWorldPoint(this.m_localAnchorA),o=i.getWorldPoint(this.m_localAnchorB),s=m.sub(o,e),n=t.getWorldVector(this.m_localXAxisA);return m.dot(s,n)},o.prototype.getJointSpeed=function(){var t=this.m_bodyA.m_angularVelocity;return this.m_bodyB.m_angularVelocity-t},o.prototype.isMotorEnabled=function(){return this.m_enableMotor},o.prototype.enableMotor=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableMotor=t},o.prototype.setMotorSpeed=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_motorSpeed=t},o.prototype.getMotorSpeed=function(){return this.m_motorSpeed},o.prototype.setMaxMotorTorque=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_maxMotorTorque=t},o.prototype.getMaxMotorTorque=function(){return this.m_maxMotorTorque},o.prototype.getMotorTorque=function(t){return t*this.m_motorImpulse},o.prototype.setSpringFrequencyHz=function(t){this.m_frequencyHz=t},o.prototype.getSpringFrequencyHz=function(){return this.m_frequencyHz},o.prototype.setSpringDampingRatio=function(t){this.m_dampingRatio=t},o.prototype.getSpringDampingRatio=function(){return this.m_dampingRatio},o.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},o.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},o.prototype.getReactionForce=function(t){return m.combine(this.m_impulse,this.m_ay,this.m_springImpulse,this.m_ax).mul(t)},o.prototype.getReactionTorque=function(t){return t*this.m_motorImpulse},o.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_invMassA,e=this.m_invMassB,o=this.m_invIA,s=this.m_invIB,n=this.m_bodyA.c_position.c,r=this.m_bodyA.c_position.a,c=this.m_bodyA.c_velocity.v,l=this.m_bodyA.c_velocity.w,_=this.m_bodyB.c_position.c,u=this.m_bodyB.c_position.a,p=this.m_bodyB.c_velocity.v,d=this.m_bodyB.c_velocity.w,y=h.neo(r),f=h.neo(u),v=h.mulVec2(y,m.sub(this.m_localAnchorA,this.m_localCenterA)),x=h.mulVec2(f,m.sub(this.m_localAnchorB,this.m_localCenterB));if((B=m.zero()).addCombine(1,_,1,x),B.subCombine(1,n,1,v),this.m_ay=h.mulVec2(y,this.m_localYAxisA),this.m_sAy=m.cross(m.add(B,v),this.m_ay),this.m_sBy=m.cross(x,this.m_ay),this.m_mass=i+e+o*this.m_sAy*this.m_sAy+s*this.m_sBy*this.m_sBy,this.m_mass>0&&(this.m_mass=1/this.m_mass),this.m_springMass=0,this.m_bias=0,this.m_gamma=0,this.m_frequencyHz>0){this.m_ax=h.mulVec2(y,this.m_localXAxisA),this.m_sAx=m.cross(m.add(B,v),this.m_ax),this.m_sBx=m.cross(x,this.m_ax);var g=i+e+o*this.m_sAx*this.m_sAx+s*this.m_sBx*this.m_sBx;if(g>0){this.m_springMass=1/g;var b=m.dot(B,this.m_ax),A=2*a.PI*this.m_frequencyHz,B=2*this.m_springMass*this.m_dampingRatio*A,w=this.m_springMass*A*A,M=t.dt;this.m_gamma=M*(B+M*w),this.m_gamma>0&&(this.m_gamma=1/this.m_gamma),this.m_bias=b*M*w*this.m_gamma,this.m_springMass=g+this.m_gamma,this.m_springMass>0&&(this.m_springMass=1/this.m_springMass)}}else this.m_springImpulse=0;if(this.m_enableMotor?(this.m_motorMass=o+s,this.m_motorMass>0&&(this.m_motorMass=1/this.m_motorMass)):(this.m_motorMass=0,this.m_motorImpulse=0),t.warmStarting){this.m_impulse*=t.dtRatio,this.m_springImpulse*=t.dtRatio,this.m_motorImpulse*=t.dtRatio;var C=m.combine(this.m_impulse,this.m_ay,this.m_springImpulse,this.m_ax),V=this.m_impulse*this.m_sAy+this.m_springImpulse*this.m_sAx+this.m_motorImpulse,S=this.m_impulse*this.m_sBy+this.m_springImpulse*this.m_sBx+this.m_motorImpulse;c.subMul(this.m_invMassA,C),l-=this.m_invIA*V,p.addMul(this.m_invMassB,C),d+=this.m_invIB*S}else this.m_impulse=0,this.m_springImpulse=0,this.m_motorImpulse=0;this.m_bodyA.c_velocity.v.set(c),this.m_bodyA.c_velocity.w=l,this.m_bodyB.c_velocity.v.set(p),this.m_bodyB.c_velocity.w=d},o.prototype.solveVelocityConstraints=function(t){var i=this.m_invMassA,e=this.m_invMassB,o=this.m_invIA,s=this.m_invIB,n=this.m_bodyA.c_velocity.v,r=this.m_bodyA.c_velocity.w,h=this.m_bodyB.c_velocity.v,c=this.m_bodyB.c_velocity.w,l=m.dot(this.m_ax,h)-m.dot(this.m_ax,n)+this.m_sBx*c-this.m_sAx*r,_=-this.m_springMass*(l+this.m_bias+this.m_gamma*this.m_springImpulse);this.m_springImpulse+=_;var u=m.mul(_,this.m_ax),p=_*this.m_sAx,d=_*this.m_sBx;n.subMul(i,u),r-=o*p,h.addMul(e,u);l=(c+=s*d)-r-this.m_motorSpeed,_=-this.m_motorMass*l;var y=this.m_motorImpulse,f=t.dt*this.m_maxMotorTorque;this.m_motorImpulse=a.clamp(this.m_motorImpulse+_,-f,f),r-=o*(_=this.m_motorImpulse-y),c+=s*_;l=m.dot(this.m_ay,h)-m.dot(this.m_ay,n)+this.m_sBy*c-this.m_sAy*r,_=-this.m_mass*l;this.m_impulse+=_;u=m.mul(_,this.m_ay),p=_*this.m_sAy,d=_*this.m_sBy;n.subMul(i,u),r-=o*p,h.addMul(e,u),c+=s*d,this.m_bodyA.c_velocity.v.set(n),this.m_bodyA.c_velocity.w=r,this.m_bodyB.c_velocity.v.set(h),this.m_bodyB.c_velocity.w=c},o.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,e=this.m_bodyA.c_position.a,o=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=h.neo(e),c=h.neo(s),l=h.mulVec2(n,m.sub(this.m_localAnchorA,this.m_localCenterA)),_=h.mulVec2(c,m.sub(this.m_localAnchorB,this.m_localCenterB)),u=m.zero();u.addCombine(1,o,1,_),u.subCombine(1,i,1,l);var p,d=h.mulVec2(n,this.m_localYAxisA),y=m.cross(m.add(u,l),d),f=m.cross(_,d),v=m.dot(u,d),x=this.m_invMassA+this.m_invMassB+this.m_invIA*this.m_sAy*this.m_sAy+this.m_invIB*this.m_sBy*this.m_sBy;p=0!=x?-v/x:0;var g=m.mul(p,d),b=p*y,A=p*f;return i.subMul(this.m_invMassA,g),e-=this.m_invIA*b,o.addMul(this.m_invMassB,g),s+=this.m_invIB*A,this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=e,this.m_bodyB.c_position.c.set(o),this.m_bodyB.c_position.a=s,a.abs(v)<=r.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/create":52,"../util/options":53}],39:[function(t,i,e){function o(t,i,e,s){if(!(this instanceof o))return new o(t,i,e,s);o._super.call(this),this._setAsBox(t,i,e,s)}i.exports=o;t("../util/common");var s=t("../util/create"),n=t("./PolygonShape");o.prototype=s((o._super=n).prototype),o.TYPE="polygon"},{"../util/common":51,"../util/create":52,"./PolygonShape":48}],40:[function(t,i,e){function o(t,i){if(!(this instanceof o))return new o(t,i);o._super.call(this),this.m_type=o.TYPE,this.m_radius=m.polygonRadius,this.m_vertices=[],this.m_count=0,this.m_prevVertex=null,this.m_nextVertex=null,this.m_hasPrevVertex=!1,this.m_hasNextVertex=!1,t&&t.length&&(i?this._createLoop(t):this._createChain(t))}i.exports=o;var s=t("../util/common"),n=t("../util/create"),r=(t("../util/options"),t("../common/Math"),t("../common/Transform")),a=(t("../common/Rot"),t("../common/Vec2")),m=(t("../collision/AABB"),t("../Settings")),h=t("../Shape"),c=t("./EdgeShape");o.prototype=n((o._super=h).prototype),o.TYPE="chain",o.prototype._createLoop=function(t){s.assert(0==this.m_vertices.length&&0==this.m_count),s.assert(t.length>=3);for(var i=1;i<t.length;++i){var e=t[i-1],o=t[i];s.assert(a.distanceSquared(e,o)>m.linearSlopSquared)}this.m_vertices.length=0,this.m_count=t.length+1;for(i=0;i<t.length;++i)this.m_vertices[i]=t[i].clone();return this.m_vertices[t.length]=t[0].clone(),this.m_prevVertex=this.m_vertices[this.m_count-2],this.m_nextVertex=this.m_vertices[1],this.m_hasPrevVertex=!0,this.m_hasNextVertex=!0,this},o.prototype._createChain=function(t){s.assert(0==this.m_vertices.length&&0==this.m_count),s.assert(t.length>=2);for(var i=1;i<t.length;++i){var e=t[i-1],o=t[i];s.assert(a.distanceSquared(e,o)>m.linearSlopSquared)}this.m_count=t.length;for(i=0;i<t.length;++i)this.m_vertices[i]=t[i].clone();return this.m_hasPrevVertex=!1,this.m_hasNextVertex=!1,this.m_prevVertex=null,this.m_nextVertex=null,this},o.prototype._setPrevVertex=function(t){this.m_prevVertex=t,this.m_hasPrevVertex=!0},o.prototype._setNextVertex=function(t){this.m_nextVertex=t,this.m_hasNextVertex=!0},o.prototype._clone=function(){var t=new o;return t.createChain(this.m_vertices),t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_prevVertex=this.m_prevVertex,t.m_nextVertex=this.m_nextVertex,t.m_hasPrevVertex=this.m_hasPrevVertex,t.m_hasNextVertex=this.m_hasNextVertex,t},o.prototype.getChildCount=function(){return this.m_count-1},o.prototype.getChildEdge=function(t,i){s.assert(0<=i&&i<this.m_count-1),t.m_type=c.TYPE,t.m_radius=this.m_radius,t.m_vertex1=this.m_vertices[i],t.m_vertex2=this.m_vertices[i+1],i>0?(t.m_vertex0=this.m_vertices[i-1],t.m_hasVertex0=!0):(t.m_vertex0=this.m_prevVertex,t.m_hasVertex0=this.m_hasPrevVertex),i<this.m_count-2?(t.m_vertex3=this.m_vertices[i+2],t.m_hasVertex3=!0):(t.m_vertex3=this.m_nextVertex,t.m_hasVertex3=this.m_hasNextVertex)},o.prototype.getVertex=function(t){return s.assert(0<=t&&t<=this.m_count),t<this.m_count?this.m_vertices[t]:this.m_vertices[0]},o.prototype.testPoint=function(t,i){return!1},o.prototype.rayCast=function(t,i,e,o){s.assert(0<=o&&o<this.m_count);return new c(this.getVertex(o),this.getVertex(o+1)).rayCast(t,i,e,0)},o.prototype.computeAABB=function(t,i,e){s.assert(0<=e&&e<this.m_count);var o=r.mulVec2(i,this.getVertex(e)),n=r.mulVec2(i,this.getVertex(e+1));t.combinePoints(o,n)},o.prototype.computeMass=function(t,i){t.mass=0,t.center=a.neo(),t.I=0},o.prototype.computeDistanceProxy=function(t,i){s.assert(0<=i&&i<this.m_count),t.m_buffer[0]=this.getVertex(i),t.m_buffer[1]=this.getVertex(i+1),t.m_vertices=t.m_buffer,t.m_count=2,t.m_radius=this.m_radius}},{"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":51,"../util/create":52,"../util/options":53,"./EdgeShape":47}],41:[function(t,i,e){function o(t,i){if(!(this instanceof o))return new o(t,i);o._super.call(this),this.m_type=o.TYPE,this.m_p=m.zero(),this.m_radius=1,"object"==typeof t&&m.isValid(t)?(this.m_p.set(t),"number"==typeof i&&(this.m_radius=i)):"number"==typeof t&&(this.m_radius=t)}i.exports=o;var s=t("../util/common"),n=t("../util/create"),r=(t("../util/options"),t("../common/Math")),a=(t("../common/Transform"),t("../common/Rot")),m=t("../common/Vec2"),h=(t("../collision/AABB"),t("../Settings"),t("../Shape"));o.prototype=n((o._super=h).prototype),o.TYPE="circle",o.prototype.getRadius=function(){return this.m_radius},o.prototype.getCenter=function(){return this.m_p},o.prototype.getVertex=function(t){return s.assert(0==t),this.m_p},o.prototype.getVertexCount=function(t){return 1},o.prototype._clone=function(){var t=new o;return t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_p=this.m_p.clone(),t},o.prototype.getChildCount=function(){return 1},o.prototype.testPoint=function(t,i){var e=m.add(t.p,a.mulVec2(t.q,this.m_p)),o=m.sub(i,e);return m.dot(o,o)<=this.m_radius*this.m_radius},o.prototype.rayCast=function(t,i,e,o){var s=m.add(e.p,a.mulVec2(e.q,this.m_p)),n=m.sub(i.p1,s),h=m.dot(n,n)-this.m_radius*this.m_radius,c=m.sub(i.p2,i.p1),l=m.dot(n,c),_=m.dot(c,c),u=l*l-_*h;if(u<0||_<r.EPSILON)return!1;var p=-(l+r.sqrt(u));return 0<=p&&p<=i.maxFraction*_&&(p/=_,t.fraction=p,t.normal=m.add(n,m.mul(p,c)),t.normal.normalize(),!0)},o.prototype.computeAABB=function(t,i,e){var o=m.add(i.p,a.mulVec2(i.q,this.m_p));t.lowerBound.set(o.x-this.m_radius,o.y-this.m_radius),t.upperBound.set(o.x+this.m_radius,o.y+this.m_radius)},o.prototype.computeMass=function(t,i){t.mass=i*r.PI*this.m_radius*this.m_radius,t.center=this.m_p,t.I=t.mass*(.5*this.m_radius*this.m_radius+m.dot(this.m_p,this.m_p))},o.prototype.computeDistanceProxy=function(t){t.m_vertices.push(this.m_p),t.m_count=1,t.m_radius=this.m_radius}},{"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":51,"../util/create":52,"../util/options":53}],42:[function(t,i,e){function o(t,i,e,o,s){t.pointCount=0;var n=r.mulVec2(e,i.m_p),m=r.mulVec2(s,o.m_p),c=a.distanceSquared(m,n),l=i.m_radius+o.m_radius;c>l*l||(t.type=h.e_circles,t.localPoint.set(i.m_p),t.localNormal.setZero(),t.pointCount=1,t.points[0].localPoint.set(o.m_p),t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=h.e_vertex,t.points[0].id.cf.indexB=0,t.points[0].id.cf.typeB=h.e_vertex)}var s=!0,n=t("../util/common"),r=(t("../util/create"),t("../common/Math"),t("../common/Transform")),a=t("../common/Vec2"),m=(t("../Settings"),t("../Shape"),t("../Contact")),h=t("../Manifold"),c=t("./CircleShape");m.addType(c.TYPE,c.TYPE,function(t,i,e,r,a,m,h){s&&n.assert(e.getType()==c.TYPE),s&&n.assert(m.getType()==c.TYPE),o(t,e.getShape(),i,m.getShape(),a)}),e.CollideCircles=o},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../common/Math":18,"../common/Transform":22,"../common/Vec2":23,"../util/common":51,"../util/create":52,"./CircleShape":41}],43:[function(t,i,e){var o=!0,s=t("../util/common"),n=t("../common/Math"),r=t("../common/Transform"),a=(t("../common/Rot"),t("../common/Vec2")),m=(t("../collision/AABB"),t("../Settings"),t("../Manifold")),h=t("../Contact"),c=(t("../Shape"),t("./CircleShape")),l=t("./PolygonShape");h.addType(l.TYPE,c.TYPE,function(t,i,e,h,_,u,p){o&&s.assert(e.getType()==l.TYPE),o&&s.assert(u.getType()==c.TYPE),function(t,i,e,o,s){t.pointCount=0;for(var h=r.mulVec2(s,o.m_p),c=r.mulTVec2(e,h),l=0,_=-1/0,u=i.m_radius+o.m_radius,p=i.m_count,d=i.m_vertices,y=i.m_normals,f=0;f<p;++f){var v=a.dot(y[f],a.sub(c,d[f]));if(v>u)return;v>_&&(_=v,l=f)}var x=l,g=x+1<p?x+1:0,b=d[x],A=d[g];if(_<n.EPSILON)return t.pointCount=1,t.type=m.e_faceA,t.localNormal.set(y[l]),t.localPoint.setCombine(.5,b,.5,A),t.points[0].localPoint.set(o.m_p),t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=m.e_vertex,t.points[0].id.cf.indexB=0,void(t.points[0].id.cf.typeB=m.e_vertex);var B=a.dot(a.sub(c,b),a.sub(A,b)),w=a.dot(a.sub(c,A),a.sub(b,A));if(B<=0){if(a.distanceSquared(c,b)>u*u)return;t.pointCount=1,t.type=m.e_faceA,t.localNormal.setCombine(1,c,-1,b),t.localNormal.normalize(),t.localPoint.set(b),t.points[0].localPoint.set(o.m_p),t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=m.e_vertex,t.points[0].id.cf.indexB=0,t.points[0].id.cf.typeB=m.e_vertex}else if(w<=0){if(a.distanceSquared(c,A)>u*u)return;t.pointCount=1,t.type=m.e_faceA,t.localNormal.setCombine(1,c,-1,A),t.localNormal.normalize(),t.localPoint.set(A),t.points[0].localPoint.set(o.m_p),t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=m.e_vertex,t.points[0].id.cf.indexB=0,t.points[0].id.cf.typeB=m.e_vertex}else{var M=a.mid(b,A),_=a.dot(c,y[x])-a.dot(M,y[x]);if(_>u)return;t.pointCount=1,t.type=m.e_faceA,t.localNormal.set(y[x]),t.localPoint.set(M),t.points[0].localPoint.set(o.m_p),t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=m.e_vertex,t.points[0].id.cf.indexB=0,t.points[0].id.cf.typeB=m.e_vertex}}(t,e.getShape(),i,u.getShape(),_)})},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":51,"./CircleShape":41,"./PolygonShape":48}],44:[function(t,i,e){function o(t,i,e,o,m){t.pointCount=0;var c=r.mulTVec2(e,r.mulVec2(m,o.m_p)),l=i.m_vertex1,_=i.m_vertex2,u=a.sub(_,l),p=a.dot(u,a.sub(_,c)),d=a.dot(u,a.sub(c,l)),y=i.m_radius+o.m_radius;if(d<=0){var f=a.clone(l),v=a.sub(c,f);if(a.dot(v,v)>y*y)return;if(i.m_hasVertex0){var x=i.m_vertex0,g=l,b=a.sub(g,x);if(a.dot(b,a.sub(g,c))>0)return}return t.type=h.e_circles,t.localNormal.setZero(),t.localPoint.set(f),t.pointCount=1,t.points[0].localPoint.set(o.m_p),t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=h.e_vertex,t.points[0].id.cf.indexB=0,void(t.points[0].id.cf.typeB=h.e_vertex)}if(p<=0){f=a.clone(_),v=a.sub(c,f);if(a.dot(v,v)>y*y)return;if(i.m_hasVertex3){var A=i.m_vertex3,B=_,w=a.sub(A,B);if(a.dot(w,a.sub(c,B))>0)return}return t.type=h.e_circles,t.localNormal.setZero(),t.localPoint.set(f),t.pointCount=1,t.points[0].localPoint.set(o.m_p),t.points[0].id.cf.indexA=1,t.points[0].id.cf.typeA=h.e_vertex,t.points[0].id.cf.indexB=0,void(t.points[0].id.cf.typeB=h.e_vertex)}var M=a.dot(u,u);s&&n.assert(M>0);f=a.combine(p/M,l,d/M,_),v=a.sub(c,f);if(!(a.dot(v,v)>y*y)){var C=a.neo(-u.y,u.x);a.dot(C,a.sub(c,l))<0&&C.set(-C.x,-C.y),C.normalize(),t.type=h.e_faceA,t.localNormal.set(C),t.localPoint.set(l),t.pointCount=1,t.points[0].localPoint.set(o.m_p),t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=h.e_face,t.points[0].id.cf.indexB=0,t.points[0].id.cf.typeB=h.e_vertex}}var s=!0,n=t("../util/common"),r=(t("../util/create"),t("../common/Math"),t("../common/Transform")),a=t("../common/Vec2"),m=(t("../common/Rot"),t("../Settings"),t("../Shape"),t("../Contact")),h=t("../Manifold"),c=t("./EdgeShape"),l=t("./ChainShape"),_=t("./CircleShape");m.addType(c.TYPE,_.TYPE,function(t,i,e,r,a,m,h){s&&n.assert(e.getType()==c.TYPE),s&&n.assert(m.getType()==_.TYPE),o(t,e.getShape(),i,m.getShape(),a)}),m.addType(l.TYPE,_.TYPE,function(t,i,e,r,a,m,h){s&&n.assert(e.getType()==l.TYPE),s&&n.assert(m.getType()==_.TYPE);var u=e.getShape(),p=new c;u.getChildEdge(p,r),o(t,p,i,m.getShape(),a)})},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":51,"../util/create":52,"./ChainShape":40,"./CircleShape":41,"./EdgeShape":47}],45:[function(t,i,e){function o(){this.type,this.index,this.separation}function s(t,i,e,o,s){var n=m.mulTXf(e,s),r=m.mulVec2(n,o.m_centroid),_=i.m_vertex0,p=i.m_vertex1,d=i.m_vertex2,y=i.m_vertex3,w=i.m_hasVertex0,M=i.m_hasVertex3,C=h.sub(d,p);C.normalize();var V=h.neo(C.y,-C.x),S=h.dot(V,h.sub(r,p)),I=0,P=0,T=!1,z=!1;if(w){var k=h.sub(p,_);k.normalize();var L=h.neo(k.y,-k.x);T=h.cross(k,C)>=0,I=h.dot(L,r)-h.dot(L,_)}if(M){var q=h.sub(y,d);q.normalize();var F=h.neo(q.y,-q.x);z=h.cross(C,q)>0,P=h.dot(F,r)-h.dot(F,d)}var R,E=h.zero(),j=h.zero(),D=h.zero();w&&M?T&&z?(R=I>=0||S>=0||P>=0)?(E.set(V),j.set(L),D.set(F)):(E.setMul(-1,V),j.setMul(-1,V),D.setMul(-1,V)):T?(R=I>=0||S>=0&&P>=0)?(E.set(V),j.set(L),D.set(V)):(E.setMul(-1,V),j.setMul(-1,F),D.setMul(-1,V)):z?(R=P>=0||I>=0&&S>=0)?(E.set(V),j.set(V),D.set(F)):(E.setMul(-1,V),j.setMul(-1,V),D.setMul(-1,L)):(R=I>=0&&S>=0&&P>=0)?(E.set(V),j.set(V),D.set(V)):(E.setMul(-1,V),j.setMul(-1,F),D.setMul(-1,L)):w?T?(R=I>=0||S>=0)?(E.set(V),j.set(L),D.setMul(-1,V)):(E.setMul(-1,V),j.set(V),D.setMul(-1,V)):(R=I>=0&&S>=0)?(E.set(V),j.set(V),D.setMul(-1,V)):(E.setMul(-1,V),j.set(V),D.setMul(-1,L)):M?z?(R=S>=0||P>=0)?(E.set(V),j.setMul(-1,V),D.set(F)):(E.setMul(-1,V),j.setMul(-1,V),D.set(V)):(R=S>=0&&P>=0)?(E.set(V),j.setMul(-1,V),D.set(V)):(E.setMul(-1,V),j.setMul(-1,F),D.set(V)):(R=S>=0)?(E.set(V),j.setMul(-1,V),D.setMul(-1,V)):(E.setMul(-1,V),j.set(V),D.set(V)),A.count=o.m_count;for(var Y=0;Y<o.m_count;++Y)A.vertices[Y]=m.mulVec2(n,o.m_vertices[Y]),A.normals[Y]=c.mulVec2(n.q,o.m_normals[Y]);var J=2*l.polygonRadius;t.pointCount=0,g.type=v,g.index=R?0:1,g.separation=1/0;for(Y=0;Y<A.count;++Y){(O=h.dot(E,h.sub(A.vertices[Y],p)))<g.separation&&(g.separation=O)}if(g.type!=f&&!(g.separation>J)){b.type=f,b.index=-1,b.separation=-1/0;var N=h.neo(-E.y,E.x);for(Y=0;Y<A.count;++Y){var O,W=h.neg(A.normals[Y]),X=h.dot(W,h.sub(A.vertices[Y],p)),H=h.dot(W,h.sub(A.vertices[Y],d));if((O=a.min(X,H))>J){b.type=x,b.index=Y,b.separation=O;break}if(h.dot(W,N)>=0){if(h.dot(h.sub(W,D),E)<-l.angularSlop)continue}else if(h.dot(h.sub(W,j),E)<-l.angularSlop)continue;O>b.separation&&(b.type=x,b.index=Y,b.separation=O)}if(!(b.type!=f&&b.separation>J)){var Z;Z=b.type==f?g:b.separation>.98*g.separation+.001?b:g;var K=[new u.clipVertex,new u.clipVertex];if(Z.type==v){t.type=u.e_faceA;var G=0,U=h.dot(E,A.normals[0]);for(Y=1;Y<A.count;++Y){var $=h.dot(E,A.normals[Y]);$<U&&(U=$,G=Y)}var Q=G,tt=Q+1<A.count?Q+1:0;K[0].v=A.vertices[Q],K[0].id.cf.indexA=0,K[0].id.cf.indexB=Q,K[0].id.cf.typeA=u.e_face,K[0].id.cf.typeB=u.e_vertex,K[1].v=A.vertices[tt],K[1].id.cf.indexA=0,K[1].id.cf.indexB=tt,K[1].id.cf.typeA=u.e_face,K[1].id.cf.typeB=u.e_vertex,R?(B.i1=0,B.i2=1,B.v1=p,B.v2=d,B.normal.set(V)):(B.i1=1,B.i2=0,B.v1=d,B.v2=p,B.normal.setMul(-1,V))}else t.type=u.e_faceB,K[0].v=p,K[0].id.cf.indexA=0,K[0].id.cf.indexB=Z.index,K[0].id.cf.typeA=u.e_vertex,K[0].id.cf.typeB=u.e_face,K[1].v=d,K[1].id.cf.indexA=0,K[1].id.cf.indexB=Z.index,K[1].id.cf.typeA=u.e_vertex,K[1].id.cf.typeB=u.e_face,B.i1=Z.index,B.i2=B.i1+1<A.count?B.i1+1:0,B.v1=A.vertices[B.i1],B.v2=A.vertices[B.i2],B.normal.set(A.normals[B.i1]);B.sideNormal1.set(B.normal.y,-B.normal.x),B.sideNormal2.setMul(-1,B.sideNormal1),B.sideOffset1=h.dot(B.sideNormal1,B.v1),B.sideOffset2=h.dot(B.sideNormal2,B.v2);var it=[new u.clipVertex,new u.clipVertex],et=[new u.clipVertex,new u.clipVertex];if(!(u.clipSegmentToLine(it,K,B.sideNormal1,B.sideOffset1,B.i1)<l.maxManifoldPoints||u.clipSegmentToLine(et,it,B.sideNormal2,B.sideOffset2,B.i2)<l.maxManifoldPoints)){Z.type==v?(t.localNormal=h.clone(B.normal),t.localPoint=h.clone(B.v1)):(t.localNormal=h.clone(o.m_normals[B.i1]),t.localPoint=h.clone(o.m_vertices[B.i1]));var ot=0;for(Y=0;Y<l.maxManifoldPoints;++Y){if(h.dot(B.normal,h.sub(et[Y].v,B.v1))<=J){var st=t.points[ot];Z.type==v?(st.localPoint=m.mulT(n,et[Y].v),st.id=et[Y].id):(st.localPoint=et[Y].v,st.id.cf.typeA=et[Y].id.cf.typeB,st.id.cf.typeB=et[Y].id.cf.typeA,st.id.cf.indexA=et[Y].id.cf.indexB,st.id.cf.indexB=et[Y].id.cf.indexA),++ot}}t.pointCount=ot}}}}var n=!0,r=t("../util/common"),a=(t("../util/create"),t("../common/Math")),m=t("../common/Transform"),h=t("../common/Vec2"),c=t("../common/Rot"),l=t("../Settings"),_=(t("../Shape"),t("../Contact")),u=t("../Manifold"),p=t("./EdgeShape"),d=t("./ChainShape"),y=t("./PolygonShape");_.addType(p.TYPE,y.TYPE,function(t,i,e,o,a,m,h){n&&r.assert(e.getType()==p.TYPE),n&&r.assert(m.getType()==y.TYPE),s(t,e.getShape(),i,m.getShape(),a)}),_.addType(d.TYPE,y.TYPE,function(t,i,e,o,a,m,h){n&&r.assert(e.getType()==d.TYPE),n&&r.assert(m.getType()==y.TYPE);var c=e.getShape(),l=new p;c.getChildEdge(l,o),s(t,l,i,m.getShape(),a)});var f=-1,v=1,x=2,g=new o,b=new o,A=new function(){this.vertices=[],this.normals=[],this.count=0},B=new function(){this.i1,this.i2,this.v1,this.v2,this.normal=h.zero(),this.sideNormal1=h.zero(),this.sideOffset1,this.sideNormal2=h.zero(),this.sideOffset2}},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":51,"../util/create":52,"./ChainShape":40,"./EdgeShape":47,"./PolygonShape":48}],46:[function(t,i,e){function o(t,i,e,o){for(var s=t.m_count,n=e.m_count,r=t.m_normals,c=t.m_vertices,l=e.m_vertices,_=a.mulTXf_(o,i,v),u=0,x=-1/0,g=0;g<s;++g){for(var b=m.mulVec2_(_.q,r[g],f),A=a.mulVec2_(_,c[g],y),B=1/0,w=0;w<n;++w){var M=h.dot(b,l[w])-h.dot(b,A);M<B&&(B=M)}B>x&&(x=B,u=g)}p=x,d=u}function s(t,i,e,s,_){t.pointCount=0;var u=i.m_radius+s.m_radius;o(i,e,s,_);var y=d,f=p;if(!(f>u)){o(s,_,i,e);var v=d;if(!(p>u)){var z,k,L,q,F,R;p>f+.1*c.linearSlop?(z=s,k=i,L=_,q=e,F=v,t.type=l.e_faceB,R=1):(z=i,k=s,L=e,q=_,F=y,t.type=l.e_faceA,R=0);var E=T;T[0].init(),T[1].init(),function(t,i,e,o,s,c){var _=i.m_normals,u=s.m_count,p=s.m_vertices,d=s.m_normals;n&&r.assert(0<=o&&o<i.m_count);for(var y=m.mulTVec2_(c.q,m.mulVec2_(e.q,_[o],x),g),f=0,v=1/0,b=0;b<u;++b){var A=h.dot(y,d[b]);A<v&&(v=A,f=b)}var B=f,w=B+1<u?B+1:0;t[0].v=a.mulVec2(c,p[B]),t[0].id.cf.indexA=o,t[0].id.cf.indexB=B,t[0].id.cf.typeA=l.e_face,t[0].id.cf.typeB=l.e_vertex,t[1].v=a.mulVec2(c,p[w]),t[1].id.cf.indexA=o,t[1].id.cf.indexB=w,t[1].id.cf.typeA=l.e_face,t[1].id.cf.typeB=l.e_vertex}(E,z,L,F,k,q);var j=z.m_count,D=z.m_vertices,Y=F,J=F+1<j?F+1:0,N=C.set(D[Y]),O=V.set(D[J]),W=h.sub_(O,N,w);W.normalize();var X=h.crossVec2Num_(W,1,M),H=h.combine_(.5,N,.5,O,b),Z=m.mulVec2_(L.q,W,A),K=h.crossVec2Num_(Z,1,B);N=a.mulVec2_(L,N,N),O=a.mulVec2_(L,O,O);var G=h.dot(K,N),U=-h.dot(Z,N)+u,$=h.dot(Z,O)+u;I[0].init(),I[1].init(),P[0].init(),P[1].init();var Q=I,tt=P;if(!(l.clipSegmentToLine(Q,E,h.neg_(Z,S),U,Y)<c.maxManifoldPoints||l.clipSegmentToLine(tt,Q,Z,$,J)<c.maxManifoldPoints)){t.localNormal.set(X),t.localPoint.set(H);for(var it=0,et=0;et<c.maxManifoldPoints;++et){if(h.dot(K,tt[et].v)-G<=u){var ot=t.points[et];if(ot.init(),ot.localPoint.set(a.mulTVec2(q,tt[et].v,S)),ot.id=tt[et].id,R){var st=ot.id.cf,nt=st.indexA,rt=st.indexB,at=st.typeA,mt=st.typeB;st.indexA=rt,st.indexB=nt,st.typeA=mt,st.typeB=at}++it}}t.pointCount=it}}}}var n=!0,r=t("../util/common"),a=(t("../common/Math"),t("../common/Transform")),m=t("../common/Rot"),h=t("../common/Vec2"),c=(t("../collision/AABB"),t("../Settings")),l=t("../Manifold"),_=t("../Contact"),u=(t("../Shape"),t("./PolygonShape"));i.exports=s,_.addType(u.TYPE,u.TYPE,function(t,i,e,o,a,m,h){n&&r.assert(e.getType()==u.TYPE),n&&r.assert(m.getType()==u.TYPE),s(t,e.getShape(),i,m.getShape(),a)});var p,d,y=h.zero(),f=h.zero(),v=a.identity(),x=h.zero(),g=h.zero(),b=h.zero(),A=h.zero(),B=h.zero(),w=h.zero(),M=h.zero(),C=h.zero(),V=h.zero(),S=h.zero(),I=[new l.clipVertex,new l.clipVertex],P=[new l.clipVertex,new l.clipVertex],T=[new l.clipVertex,new l.clipVertex]},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":51,"./PolygonShape":48}],47:[function(t,i,e){function o(t,i){if(!(this instanceof o))return new o(t,i);o._super.call(this),this.m_type=o.TYPE,this.m_radius=n.polygonRadius,this.m_vertex1=t?h.clone(t):h.zero(),this.m_vertex2=i?h.clone(i):h.zero(),this.m_vertex0=h.zero(),this.m_vertex3=h.zero(),this.m_hasVertex0=!1,this.m_hasVertex3=!1}i.exports=o;var s=t("../util/create"),n=(t("../util/options"),t("../Settings")),r=t("../Shape"),a=(t("../common/Math"),t("../common/Transform")),m=t("../common/Rot"),h=t("../common/Vec2");t("../collision/AABB");o.prototype=s((o._super=r).prototype),o.TYPE="edge",o.prototype.setNext=function(t){return t?(this.m_vertex3.set(t),this.m_hasVertex3=!0):(this.m_vertex3.setZero(),this.m_hasVertex3=!1),this},o.prototype.setPrev=function(t){return t?(this.m_vertex0.set(t),this.m_hasVertex0=!0):(this.m_vertex0.setZero(),this.m_hasVertex0=!1),this},o.prototype._set=function(t,i){return this.m_vertex1.set(t),this.m_vertex2.set(i),this.m_hasVertex0=!1,this.m_hasVertex3=!1,this},o.prototype._clone=function(){var t=new o;return t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_vertex1.set(this.m_vertex1),t.m_vertex2.set(this.m_vertex2),t.m_vertex0.set(this.m_vertex0),t.m_vertex3.set(this.m_vertex3),t.m_hasVertex0=this.m_hasVertex0,t.m_hasVertex3=this.m_hasVertex3,t},o.prototype.getChildCount=function(){return 1},o.prototype.testPoint=function(t,i){return!1},o.prototype.rayCast=function(t,i,e,o){var s=m.mulTVec2(e.q,h.sub(i.p1,e.p)),n=m.mulTVec2(e.q,h.sub(i.p2,e.p)),r=h.sub(n,s),a=this.m_vertex1,c=this.m_vertex2,l=h.sub(c,a),_=h.neo(l.y,-l.x);_.normalize();var u=h.dot(_,h.sub(a,s)),p=h.dot(_,r);if(0==p)return!1;var d=u/p;if(d<0||i.maxFraction<d)return!1;var y=h.add(s,h.mul(d,r)),f=h.sub(c,a),v=h.dot(f,f);if(0==v)return!1;var x=h.dot(h.sub(y,a),f)/v;return!(x<0||1<x)&&(t.fraction=d,t.normal=u>0?m.mulVec2(e.q,_).neg():m.mulVec2(e.q,_),!0)},o.prototype.computeAABB=function(t,i,e){var o=a.mulVec2(i,this.m_vertex1),s=a.mulVec2(i,this.m_vertex2);t.combinePoints(o,s),t.extend(this.m_radius)},o.prototype.computeMass=function(t,i){t.mass=0,t.center.setCombine(.5,this.m_vertex1,.5,this.m_vertex2),t.I=0},o.prototype.computeDistanceProxy=function(t){t.m_vertices.push(this.m_vertex1),t.m_vertices.push(this.m_vertex2),t.m_count=2,t.m_radius=this.m_radius}},{"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/create":52,"../util/options":53}],48:[function(t,i,e){function o(t){if(!(this instanceof o))return new o(t);o._super.call(this),this.m_type=o.TYPE,this.m_radius=l.polygonRadius,this.m_centroid=c.zero(),this.m_vertices=[],this.m_normals=[],this.m_count=0,t&&t.length&&this._set(t)}var s=!0;i.exports=o;var n=t("../util/common"),r=t("../util/create"),a=(t("../util/options"),t("../common/Math")),m=t("../common/Transform"),h=t("../common/Rot"),c=t("../common/Vec2"),l=(t("../collision/AABB"),t("../Settings")),_=t("../Shape");o.prototype=r((o._super=_).prototype),o.TYPE="polygon",o.prototype.getVertex=function(t){return s&&n.assert(0<=t&&t<this.m_count),this.m_vertices[t]},o.prototype._clone=function(){var t=new o;t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_count=this.m_count,t.m_centroid.set(this.m_centroid);for(var i=0;i<this.m_count;i++)t.m_vertices.push(this.m_vertices[i].clone());for(i=0;i<this.m_normals.length;i++)t.m_normals.push(this.m_normals[i].clone());return t},o.prototype.getChildCount=function(){return 1},o.prototype._set=function(t){if(s&&n.assert(3<=t.length&&t.length<=l.maxPolygonVertices),t.length<3)this._setAsBox(1,1);else{for(var i=a.min(t.length,l.maxPolygonVertices),e=[],o=0,r=0;r<i;++r){for(var m=t[r],h=!0,_=0;_<o;++_)if(c.distanceSquared(m,e[_])<.25*l.linearSlopSquared){h=!1;break}h&&(e[o++]=m)}if((i=o)<3)return s&&n.assert(!1),void this._setAsBox(1,1);var u=0,p=e[0].x;for(r=1;r<i;++r){var d=e[r].x;(d>p||d==p&&e[r].y<e[u].y)&&(u=r,p=d)}for(var y=[],f=0,v=u;;){y[f]=v;var x=0;for(_=1;_<i;++_)if(x!=v){var g=c.sub(e[x],e[y[f]]),b=(m=c.sub(e[_],e[y[f]]),c.cross(g,m));b<0&&(x=_),0==b&&m.lengthSquared()>g.lengthSquared()&&(x=_)}else x=_;if(++f,v=x,x==u)break}if(f<3)return s&&n.assert(!1),void this._setAsBox(1,1);this.m_count=f;for(r=0;r<f;++r)this.m_vertices[r]=e[y[r]];for(r=0;r<f;++r){var A=r,B=r+1<f?r+1:0,w=c.sub(this.m_vertices[B],this.m_vertices[A]);s&&n.assert(w.lengthSquared()>a.EPSILON*a.EPSILON),this.m_normals[r]=c.cross(w,1),this.m_normals[r].normalize()}this.m_centroid=function(t,i){s&&n.assert(i>=3);for(var e=c.zero(),o=0,r=c.zero(),m=0;m<i;++m){var h=r,l=t[m],_=m+1<i?t[m+1]:t[0],u=c.sub(l,h),p=c.sub(_,h),d=.5*c.cross(u,p);o+=d,e.addMul(d*(1/3),h),e.addMul(d*(1/3),l),e.addMul(d*(1/3),_)}return s&&n.assert(o>a.EPSILON),e.mul(1/o),e}(this.m_vertices,f)}},o.prototype._setAsBox=function(t,i,e,o){if(this.m_vertices[0]=c.neo(-t,-i),this.m_vertices[1]=c.neo(t,-i),this.m_vertices[2]=c.neo(t,i),this.m_vertices[3]=c.neo(-t,i),this.m_normals[0]=c.neo(0,-1),this.m_normals[1]=c.neo(1,0),this.m_normals[2]=c.neo(0,1),this.m_normals[3]=c.neo(-1,0),this.m_count=4,c.isValid(e)){o=o||0,this.m_centroid.set(e);var s=m.identity();s.p.set(e),s.q.set(o);for(var n=0;n<this.m_count;++n)this.m_vertices[n]=m.mulVec2(s,this.m_vertices[n]),this.m_normals[n]=h.mulVec2(s.q,this.m_normals[n])}},o.prototype.testPoint=function(t,i){for(var e=h.mulTVec2(t.q,c.sub(i,t.p)),o=0;o<this.m_count;++o){if(c.dot(this.m_normals[o],c.sub(e,this.m_vertices[o]))>0)return!1}return!0},o.prototype.rayCast=function(t,i,e,o){for(var r=h.mulTVec2(e.q,c.sub(i.p1,e.p)),a=h.mulTVec2(e.q,c.sub(i.p2,e.p)),m=c.sub(a,r),l=0,_=i.maxFraction,u=-1,p=0;p<this.m_count;++p){var d=c.dot(this.m_normals[p],c.sub(this.m_vertices[p],r)),y=c.dot(this.m_normals[p],m);if(0==y){if(d<0)return!1}else y<0&&d<l*y?(l=d/y,u=p):y>0&&d<_*y&&(_=d/y);if(_<l)return!1}return s&&n.assert(0<=l&&l<=i.maxFraction),u>=0&&(t.fraction=l,t.normal=h.mulVec2(e.q,this.m_normals[u]),!0)},o.prototype.computeAABB=function(t,i,e){for(var o=1/0,s=1/0,n=-1/0,r=-1/0,h=0;h<this.m_count;++h){var c=m.mulVec2(i,this.m_vertices[h]);o=a.min(o,c.x),n=a.max(n,c.x),s=a.min(s,c.y),r=a.max(r,c.y)}t.lowerBound.set(o,s),t.upperBound.set(n,r),t.extend(this.m_radius)},o.prototype.computeMass=function(t,i){s&&n.assert(this.m_count>=3);for(var e=c.zero(),o=0,r=0,m=c.zero(),h=0;h<this.m_count;++h)m.add(this.m_vertices[h]);m.mul(1/this.m_count);for(h=0;h<this.m_count;++h){var l=c.sub(this.m_vertices[h],m),_=h+1<this.m_count?c.sub(this.m_vertices[h+1],m):c.sub(this.m_vertices[0],m),u=c.cross(l,_),p=.5*u;o+=p,e.addCombine(p*(1/3),l,p*(1/3),_);var d=l.x,y=l.y,f=_.x,v=_.y;r+=1/3*.25*u*(d*d+f*d+f*f+(y*y+v*y+v*v))}t.mass=i*o,s&&n.assert(o>a.EPSILON),e.mul(1/o),t.center.setCombine(1,e,1,m),t.I=i*r,t.I+=t.mass*(c.dot(t.center,t.center)-c.dot(e,e))},o.prototype.validate=function(){for(var t=0;t<this.m_count;++t)for(var i=t,e=t<this.m_count-1?i+1:0,o=this.m_vertices[i],s=c.sub(this.m_vertices[e],o),n=0;n<this.m_count;++n)if(n!=i&&n!=e){var r=c.sub(this.m_vertices[n],o);if(c.cross(s,r)<0)return!1}return!0},o.prototype.computeDistanceProxy=function(t){t.m_vertices=this.m_vertices,t.m_count=this.m_count,t.m_radius=this.m_radius}},{"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":51,"../util/create":52,"../util/options":53}],49:[function(t,i,e){i.exports=function(t){var i=[],e=t.max||1/0,o=t.create||function(){return{}},s=t.allocate||function(){},n=t.release||function(){},r=t.discard||function(){},a=0,m=0,h=0,c=0;this.max=function(t){return"number"==typeof t?(e=t,this):e},this.size=function(){return i.length},this.allocate=function(){var t;return i.length>0?t=i.shift():(a++,t=o()),m++,s(t),t},this.release=function(t){i.length<e?(h++,n(t),i.push(t)):(c++,r(t))},this.toString=function(){return" +"+a+" >"+m+" <"+h+" -"+c+" ="+i.length+"/"+e}}},{}],50:[function(t,i,e){i.exports.now=function(){return Date.now()},i.exports.diff=function(t){return Date.now()-t}},{}],51:[function(t,i,e){e.debug=function(){},e.assert=function(t,i,e){if(!t)throw e&&console.log(e),new Error(i)}},{}],52:[function(t,i,e){function o(){}"function"==typeof Object.create?i.exports=function(t,i){return Object.create.call(Object,t,i)}:i.exports=function(t,i){if(i)throw Error("Second argument is not supported!");if("object"!=typeof t||null===t)throw Error("Invalid prototype!");return o.prototype=t,new o}},{}],53:[function(t,i,e){Object.prototype.propertyIsEnumerable;i.exports=function(t,i){null!==t&&void 0!==t||(t={});for(var e in i)i.hasOwnProperty(e)&&void 0===t[e]&&(t[e]=i[e]);if("function"==typeof Object.getOwnPropertySymbols)for(var o=Object.getOwnPropertySymbols(i),s=0;s<o.length;s++){var n=o[s];i.propertyIsEnumerable(n)&&void 0===t[e]&&(t[n]=i[n])}return t}},{}],54:[function(t,i,e){function o(t){return t}function s(t){if("function"==typeof t)return t;if("string"!=typeof t)return o;var i=n[t];if(i)return i;var e=/^(\w+)(-(in|out|in-out|out-in))?(\((.*)\))?$/i.exec(t);if(!e||!e.length)return o;var s=a[e[1]],m=r[e[3]],h=e[5];
// TODO: It can be a memory leak with different `params`.
return i=s&&s.fn?s.fn:s&&s.fc?s.fc.apply(s.fc,h&&h.replace(/\s+/,"").split(",")):o,m&&(i=m.fn(i)),n[t]=i,i}var n={},r={},a={};s.add=function(t){for(var i=(t.name||t.mode).split(/\s+/),e=0;e<i.length;e++){var o=i[e];o&&((t.name?a:r)[o]=t)}},s.add({mode:"in",fn:function(t){return t}}),s.add({mode:"out",fn:function(t){return function(i){return 1-t(1-i)}}}),s.add({mode:"in-out",fn:function(t){return function(i){return i<.5?t(2*i)/2:1-t(2*(1-i))/2}}}),s.add({mode:"out-in",fn:function(t){return function(i){return i<.5?1-t(2*(1-i))/2:t(2*i)/2}}}),s.add({name:"linear",fn:function(t){return t}}),s.add({name:"quad",fn:function(t){return t*t}}),s.add({name:"cubic",fn:function(t){return t*t*t}}),s.add({name:"quart",fn:function(t){return t*t*t*t}}),s.add({name:"quint",fn:function(t){return t*t*t*t*t}}),s.add({name:"sin sine",fn:function(t){return 1-Math.cos(t*Math.PI/2)}}),s.add({name:"exp expo",fn:function(t){return 0==t?0:Math.pow(2,10*(t-1))}}),s.add({name:"circle circ",fn:function(t){return 1-Math.sqrt(1-t*t)}}),s.add({name:"bounce",fn:function(t){return t<1/2.75?7.5625*t*t:t<2/2.75?7.5625*(t-=1.5/2.75)*t+.75:t<2.5/2.75?7.5625*(t-=2.25/2.75)*t+.9375:7.5625*(t-=2.625/2.75)*t+.984375}}),s.add({name:"poly",fc:function(t){return function(i){return Math.pow(i,t)}}}),s.add({name:"elastic",fc:function(t,i){i=i||.45,t=t||1;var e=i/(2*Math.PI)*Math.asin(1/t);return function(o){return 1+t*Math.pow(2,-10*o)*Math.sin((o-e)*(2*Math.PI)/i)}}}),s.add({name:"back",fc:function(t){return t=void 0!==t?t:1.70158,function(i){return i*i*((t+1)*i-t)}}}),i.exports=s},{}],55:[function(t,i,e){function o(t,i){if(this instanceof o){var e=t.viewport().ratio||1;t.on("viewport",function(t){e=t.ratio||e}),this.x=0,this.y=0,this.toString=function(){return(0|this.x)+"x"+(0|this.y)},this.locate=function(t){!function(t,i,e){
// pageX/Y if available?
i.touches&&i.touches.length?(e.x=i.touches[0].clientX,e.y=i.touches[0].clientY):(e.x=i.clientX,e.y=i.clientY);var o=t.getBoundingClientRect();e.x-=o.left,e.y-=o.top,e.x-=0|t.clientLeft,e.y-=0|t.clientTop}(i,t,this),this.x*=e,this.y*=e},this.lookup=function(i,e){this.type=i,this.root=t,this.event=null,e.length=0,this.collect=e,this.root.visit(this.visitor,this)},this.publish=function(i,e,o){if(this.type=i,this.root=t,this.event=e,this.collect=!1,this.timeStamp=Date.now(),o){for(;o.length&&!this.visitor.end(o.shift(),this););o.length=0}else this.root.visit(this.visitor,this)},this.visitor={reverse:!0,visible:!0,start:function(t,i){return!t._flag(i.type)},end:function(t,i){
// mouse: event/collect, type, root
n.raw=i.event,n.type=i.type,n.timeStamp=i.timeStamp,n.abs.x=i.x,n.abs.y=i.y;var e=t.listeners(i.type);if(e&&(t.matrix().inverse().map(i,n),(t===i.root||t.hitTest(n))&&(i.collect&&i.collect.push(t),i.event))){for(var o=!1,s=0;s<e.length;s++)o=!!e[s].call(t,n)||o;return o}}}}}function s(t,i,e){Object.defineProperty(t,i,{value:e})}t("../core")._load(function(t,i){o.subscribe(t,i)}),
// TODO: capture mouse
o.CLICK="click",o.START="touchstart mousedown",o.MOVE="touchmove mousemove",o.END="touchend mouseup",o.CANCEL="touchcancel mousecancel",o.subscribe=function(t,i){function e(i){i.preventDefault(),t.mouse.locate(i),
// DEBUG && console.log('Mouse Start: ' + event.type + ' ' + mouse);
t.mouse.publish(i.type,i),t.mouse.lookup("click",a),t.mouse.lookup("mousecancel",m)}function s(i){i.preventDefault(),t.mouse.locate(i),t.mouse.publish(i.type,i)}function n(i){i.preventDefault(),
// up/end location is not available, last one is used instead
// DEBUG && console.log('Mouse End: ' + event.type + ' ' + mouse);
t.mouse.publish(i.type,i),a.length&&
// DEBUG && console.log('Mouse Click: ' + clicklist.length);
t.mouse.publish("click",i,a),m.length=0}function r(i){m.length&&
// DEBUG && console.log('Mouse Cancel: ' + event.type);
t.mouse.publish("mousecancel",i,m),a.length=0}if(!t.mouse){t.mouse=new o(t,i),
// `click` events are synthesized from start/end events on same nodes
// `mousecancel` events are synthesized on blur or mouseup outside element
i.addEventListener("touchstart",e),i.addEventListener("touchend",n),i.addEventListener("touchmove",s),i.addEventListener("touchcancel",r),i.addEventListener("mousedown",e),i.addEventListener("mouseup",n),i.addEventListener("mousemove",s),document.addEventListener("mouseup",r),window.addEventListener("blur",r);var a=[],m=[]}};
// TODO: define per mouse object with get-only x and y
var n={},r={};s(n,"clone",function(t){return t=t||{},t.x=this.x,t.y=this.y,t}),s(n,"toString",function(){return(0|this.x)+"x"+(0|this.y)+" ("+this.abs+")"}),s(n,"abs",r),s(r,"clone",function(t){return t=t||{},t.x=this.x,t.y=this.y,t}),s(r,"toString",function(){return(0|this.x)+"x"+(0|this.y)}),i.exports=o},{"../core":60}],56:[function(t,i,e){function o(t,i,e){this._end={},this._duration=i||400,this._delay=e||0,this._owner=t,this._time=0}function s(t,i,e,o){"number"==typeof t.pin(e)?i[e]=o:"number"==typeof t.pin(e+"X")&&"number"==typeof t.pin(e+"Y")&&(i[e+"X"]=o,i[e+"Y"]=o)}var n=t("./easing"),r=t("../core"),a=t("../pin");r.prototype.tween=function(t,i,e){if("number"!=typeof t?(e=t,i=0,t=0):"number"!=typeof i&&(e=i,i=0),!this._tweens){this._tweens=[];var s=0;this.tick(function(t,i,e){if(this._tweens.length){
// ignore old elapsed
var o=s!=e;if(s=i,o)return!0;var n=this._tweens[0],r=n.tick(this,t,i,e);if(r&&n===this._tweens[0]&&this._tweens.shift(),"function"==typeof r)try{r.call(this)}catch(t){console.log(t)}return"object"==typeof r&&this._tweens.unshift(r),!0}},!0)}this.touch(),e||(this._tweens.length=0);var n=new o(this,t,i);return this._tweens.push(n),n},o.prototype.tick=function(t,i,e,o){if(this._time+=i,!(this._time<this._delay)){var s=this._time-this._delay;if(!this._start){this._start={};for(var n in this._end)this._start[n]=this._owner.pin(n)}var r,a;s<this._duration?(r=s/this._duration,a=!1):(r=1,a=!0),"function"==typeof this._easing&&(r=this._easing(r));var m=1-r;for(var n in this._end)this._owner.pin(n,this._start[n]*m+this._end[n]*r);return a?this._next||this._done||!0:void 0}},o.prototype.tween=function(t,i){return this._next=new o(this._owner,t,i)},o.prototype.duration=function(t){return this._duration=t,this},o.prototype.delay=function(t){return this._delay=t,this},o.prototype.ease=function(t){return this._easing=n(t),this},o.prototype.done=function(t){return this._done=t,this},o.prototype.hide=function(){return this.done(function(){this.hide()}),this},o.prototype.remove=function(){return this.done(function(){this.remove()}),this},o.prototype.pin=function(t,i){if("object"==typeof t)for(var e in t)s(this._owner,this._end,e,t[e]);else void 0!==i&&s(this._owner,this._end,t,i);return this},a._add_shortcuts(o),/**
 * @deprecated Use .done(fn) instead.
 */
o.prototype.then=function(t){return this.done(t),this},/**
 * @deprecated NOOP
 */
o.prototype.clear=function(t){return this},i.exports=o},{"../core":60,"../pin":68,"./easing":54}],57:[function(t,i,e){function o(){o._super.call(this),this.label("Anim"),this._textures=[],this._fps=s.Anim.FPS,this._ft=1e3/this._fps,this._time=-1,this._repeat=0,this._index=0,this._frames=[];var t=0;this.tick(function(i,e,o){if(!(this._time<0||this._frames.length<=1)){
// ignore old elapsed
var s=t!=o;if(t=e,s)return!0;if(this._time+=i,this._time<this._ft)return!0;var n=this._time/this._ft|0;return this._time-=n*this._ft,this.moveFrame(n),!(this._repeat>0&&(this._repeat-=n)<=0)||(this.stop(),this._callback&&this._callback(),!1)}},!1)}var s=t("./core");t("./pin"),t("./loop");var n=t("./util/create"),r=t("./util/math");s.anim=function(t,i){var e=new o;return e.frames(t).gotoFrame(0),i&&e.fps(i),e},o.prototype=n((o._super=s).prototype),
// TODO: replace with atlas fps or texture time
s.Anim={FPS:15},o.prototype.fps=function(t){return void 0===t?this._fps:(this._fps=t>0?t:s.Anim.FPS,this._ft=1e3/this._fps,this)},/**
 * @deprecated Use frames
 */
o.prototype.setFrames=function(t,i,e){return this.frames(t,i,e)},o.prototype.frames=function(t){return this._index=0,this._frames=s.texture(t).array(),this.touch(),this},o.prototype.length=function(){return this._frames?this._frames.length:0},o.prototype.gotoFrame=function(t,i){return this._index=0|r.rotate(t,this._frames.length),i=i||!this._textures[0],this._textures[0]=this._frames[this._index],i&&(this.pin("width",this._textures[0].width),this.pin("height",this._textures[0].height)),this.touch(),this},o.prototype.moveFrame=function(t){return this.gotoFrame(this._index+t)},o.prototype.repeat=function(t,i){return this._repeat=t*this._frames.length-1,this._callback=i,this.play(),this},o.prototype.play=function(t){return void 0!==t?(this.gotoFrame(t),this._time=0):this._time<0&&(this._time=0),this.touch(),this},o.prototype.stop=function(t){return this._time=-1,void 0!==t&&this.gotoFrame(t),this}},{"./core":60,"./loop":66,"./pin":68,"./util/create":74,"./util/math":78}],58:[function(t,i,e){function o(t){function i(t){if(!t||c.fn(t.draw))return t;t=m({},t),c.fn(a)&&(t=a(t)),1!=h&&(t.x*=h,t.y*=h,t.width*=h,t.height*=h,t.top*=h,t.bottom*=h,t.left*=h,t.right*=h),0!=_&&(t.x+=_,t.y+=_,t.width-=2*_,t.height-=2*_,t.top-=_,t.bottom-=_,t.left-=_,t.right-=_);var i=r.pipe();return i.top=t.top,i.bottom=t.bottom,i.left=t.left,i.right=t.right,i.src(t.x,t.y,t.width,t.height),i}function e(t){if(u){if(c.fn(u))return u(t);if(c.hash(u))return u[t]}if(d){for(var i=null,e=0,o=0;o<d.length;o++)l.startsWith(d[o].name,t)&&(0===e?i=d[o]:1===e?i=[i,d[o]]:i.push(d[o]),e++);return 0===e&&c.fn(p)&&(i=function(i){return p(t+(i||""))}),i}}o._super.call(this);var r=this;n(t,"filter"),n(t,"cutouts"),n(t,"sprites"),n(t,"factory");var a=t.map||t.filter,h=t.ppu||t.ratio||1,_=t.trim||0,u=t.textures,p=t.factory,d=t.cutouts||t.sprites;this.select=function(t){if(!t)
// TODO: if `textures` is texture def, map or fn?
return new s(this.pipe());var o=e(t);return o?new s(o,e,i):void 0}}function s(t,i,e){function o(t,s){return t?c.fn(t.draw)?t:c.hash(t)&&c.number(t.width)&&c.number(t.height)&&c.fn(e)?e(t):c.hash(t)&&c.defined(s)?o(t[s]):c.fn(t)?o(t(s)):c.array(t)?o(t[0]):c.string(t)&&c.fn(i)?o(i(t)):void 0:p}this.one=function(i){return o(t,i)},this.array=function(i){var e=c.array(i)?i:[];if(c.array(t))for(var s=0;s<t.length;s++)e[s]=o(t[s]);else e[0]=o(t);return e}}function n(t,i,e){i in t&&console.log(e?e.replace("%name",i):"'"+i+"' field of texture atlas is deprecated.")}var r=t("./core"),a=t("./texture"),m=t("./util/extend"),h=t("./util/create"),c=t("./util/is"),l=t("./util/string"),_={},u=[];
// TODO: print subquery not found error
// TODO: index textures
r.atlas=function(t){var i=c.fn(t.draw)?t:new o(t);t.name&&(_[t.name]=i),u.push(i),n(t,"imagePath"),n(t,"imageRatio");var e=t.imagePath,s=t.imageRatio||1;return c.string(t.image)?e=t.image:c.hash(t.image)&&(e=t.image.src||t.image.url,s=t.image.ratio||s),e&&r.preload(function(t){e=r.resolve(e);r.config("image-loader")(e,function(e){i.src(e,s),t()},function(i){t()})}),i},o.prototype=h((o._super=a).prototype);var p=new a;p.x=p.y=p.width=p.height=0,p.pipe=p.src=p.dest=function(){return this},p.draw=function(){};var d=new s(p);r.texture=function(t){if(!c.string(t))return new s(t);var i,e,o=null;for((e=t.indexOf(":"))>0&&t.length>e+1&&(o=(i=_[t.slice(0,e)])&&i.select(t.slice(e+1))),!o&&(i=_[t])&&(o=i.select()),e=0;!o&&e<u.length;e++)o=u[e].select(t);return o||(console.error("Texture not found: "+t),o=d),o},i.exports=o},{"./core":60,"./texture":71,"./util/create":74,"./util/extend":76,"./util/is":77,"./util/string":81}],59:[function(t,i,e){var o=t("./core"),s=t("./texture");o.canvas=function(t,i,e){"string"==typeof t?"object"==typeof i||("function"==typeof i&&(e=i),i={}):("function"==typeof t&&(e=t),i={},t="2d");var o=document.createElement("canvas"),n=o.getContext(t,i),r=new s(o);return r.context=function(){return n},r.size=function(t,i,e){return e=e||1,o.width=t*e,o.height=i*e,this.src(o,e),this},r.canvas=function(t){return"function"==typeof t?t.call(this,n):void 0===t&&"function"==typeof e&&e.call(this,n),this},"function"==typeof e&&e.call(r,n),r}},{"./core":60,"./texture":71}],60:[function(t,i,e){function o(t){if(!(this instanceof o))return r.fn(t)?o.app.apply(o,arguments):r.object(t)?o.atlas.apply(o,arguments):t;s.create++;for(var i=0;i<m.length;i++)m[i].call(this)}var s=t("./util/stats"),n=t("./util/extend"),r=t("./util/is"),a=t("./util/await");s.create=0;var m=[];o._init=function(t){m.push(t)};var h=[];o._load=function(t){h.push(t)};var c={};o.config=function(){if(1===arguments.length&&r.string(arguments[0]))return c[arguments[0]];1===arguments.length&&r.object(arguments[0])&&n(c,arguments[0]),2===arguments.length&&r.string(arguments[0])&&(arguments[0],arguments[1])};var l=[],_=[],u=!1,p=!1;o.app=function(t,i){if(u){o.config("app-loader")(function(i,e){for(var o=0;o<h.length;o++)h[o].call(this,i,e);t(i,e),_.push(i),i.start()},i)}else l.push(arguments)};var d=a();o.preload=function(t){if("string"==typeof t){var i=o.resolve(t);/\.js($|\?|\#)/.test(i)&&(t=function(t){!function(t,i){var e=document.createElement("script");e.addEventListener("load",function(){i()}),e.addEventListener("error",function(e){i(e||"Error loading script: "+t)}),e.src=t,e.id="preload-"+Date.now(),document.body.appendChild(e)}(i,t)})}"function"==typeof t&&
// if (!_started) {
// _preload_queue.push(load);
// return;
// }
t(d())},o.start=function(t){o.config(t),
// DEBUG && console.log('Preloading...');
// _started = true;
// while (_preload_queue.length) {
// var load = _preload_queue.shift();
// load(loading());
// }
d.then(function(){for(u=!0;l.length;){var t=l.shift();o.app.apply(o,t)}})},o.pause=function(){if(!p){p=!0;for(var t=_.length-1;t>=0;t--)_[t].pause()}},o.resume=function(){if(p){p=!1;for(var t=_.length-1;t>=0;t--)_[t].resume()}},o.create=function(){return new o},o.resolve=function(){if("undefined"==typeof window||"undefined"==typeof document)return function(t){return t};var t=document.getElementsByTagName("script");return function(i){if(/^\.\//.test(i)){var e=function(){
// HTML5
if(document.currentScript)return document.currentScript.src;
// IE>=10
var i;try{var e=new Error;if(!e.stack)throw e;i=e.stack}catch(e){i=e.stack}if("string"==typeof i)
// Uses the last line, where the call started
for(var o=(i=i.split("\n")).length;o--;){var s=i[o].match(/(\w+\:\/\/[^/]*?\/.+?)(:\d+)(:\d+)?/);if(s)return s[1]}
// IE<11
if(t.length&&"readyState"in t[0])for(o=t.length;o--;)if("interactive"===t[o].readyState)return t[o].src;return location.href}();i=e.substring(0,e.lastIndexOf("/")+1)+i.substring(2)}return i}}(),i.exports=o},{"./util/await":73,"./util/extend":76,"./util/is":77,"./util/stats":80}],61:[function(t,i,e){t("./util/event")(t("./core").prototype,function(t,i,e){t._flag(i,e)})},{"./core":60,"./util/event":75}],62:[function(t,i,e){function o(){o._super.call(this),this.label("Image"),this._textures=[],this._image=null}var s=t("./core");t("./pin"),t("./loop");var n=t("./util/repeat"),r=t("./util/create");i.exports=o,s.image=function(t){var i=new o;return t&&i.image(t),i},/**
 * @deprecated Use image
 */
(o.prototype=r((o._super=s).prototype)).setImage=function(t,i,e){return this.image(t,i,e)},o.prototype.image=function(t){return this._image=s.texture(t).one(),this.pin("width",this._image?this._image.width:0),this.pin("height",this._image?this._image.height:0),this._textures[0]=this._image.pipe(),this._textures.length=1,this},o.prototype.tile=function(t){return this._repeat(!1,t),this},o.prototype.stretch=function(t){return this._repeat(!0,t),this},o.prototype._repeat=function(t,i){function e(t,i,e,s,n,r,a,m,h){var c=o._textures.length>t?o._textures[t]:o._textures[t]=o._image.pipe();c.src(i,e,s,n),c.dest(r,a,m,h)}var o=this;this.untick(this._repeatTicker),this.tick(this._repeatTicker=function(){if(this._mo_stretch!=this._pin._ts_transform){this._mo_stretch=this._pin._ts_transform;var o=this.pin("width"),s=this.pin("height");this._textures.length=n(this._image,o,s,t,i,e)}})}},{"./core":60,"./loop":66,"./pin":68,"./util/create":74,"./util/repeat":79}],63:[function(t,i,e){i.exports=t("./core"),i.exports.Matrix=t("./matrix"),i.exports.Texture=t("./texture"),t("./atlas"),t("./tree"),t("./event"),t("./pin"),t("./loop"),t("./root")},{"./atlas":58,"./core":60,"./event":61,"./loop":66,"./matrix":67,"./pin":68,"./root":69,"./texture":71,"./tree":72}],64:[function(t,i,e){var o=t("./core");t("./pin"),t("./loop");t("./util/create");o.row=function(t){return o.create().row(t).label("Row")},o.prototype.row=function(t){return this.sequence("row",t),this},o.column=function(t){return o.create().column(t).label("Row")},o.prototype.column=function(t){return this.sequence("column",t),this},o.sequence=function(t,i){return o.create().sequence(t,i).label("Sequence")},o.prototype.sequence=function(t,i){return this._padding=this._padding||0,this._spacing=this._spacing||0,this.untick(this._layoutTiker),this.tick(this._layoutTiker=function(){if(this._mo_seq!=this._ts_touch){this._mo_seq=this._ts_touch;var e=this._mo_seqAlign!=this._ts_children;this._mo_seqAlign=this._ts_children;for(var o,s=0,n=0,r=this.first(!0),a=!0;o=r;){r=o.next(!0),o.matrix(!0);var m=o.pin("boxWidth"),h=o.pin("boxHeight");"column"==t?(!a&&(n+=this._spacing),o.pin("offsetY")!=n&&o.pin("offsetY",n),s=Math.max(s,m),n+=h,e&&o.pin("alignX",i)):"row"==t&&(!a&&(s+=this._spacing),o.pin("offsetX")!=s&&o.pin("offsetX",s),s+=m,n=Math.max(n,h),e&&o.pin("alignY",i)),a=!1}s+=2*this._padding,n+=2*this._padding,this.pin("width")!=s&&this.pin("width",s),this.pin("height")!=n&&this.pin("height",n)}}),this},o.box=function(){return o.create().box().label("Box")},o.prototype.box=function(){return this._padding=this._padding||0,this.untick(this._layoutTiker),this.tick(this._layoutTiker=function(){if(this._mo_box!=this._ts_touch){this._mo_box=this._ts_touch;for(var t,i=0,e=0,o=this.first(!0);t=o;){o=t.next(!0),t.matrix(!0);var s=t.pin("boxWidth"),n=t.pin("boxHeight");i=Math.max(i,s),e=Math.max(e,n)}i+=2*this._padding,e+=2*this._padding,this.pin("width")!=i&&this.pin("width",i),this.pin("height")!=e&&this.pin("height",e)}}),this},o.layer=function(){return o.create().layer().label("Layer")},o.prototype.layer=function(){return this.untick(this._layoutTiker),this.tick(this._layoutTiker=function(){var t=this.parent();if(t){var i=t.pin("width");this.pin("width")!=i&&this.pin("width",i);var e=t.pin("height");this.pin("height")!=e&&this.pin("height",e)}},!0),this},
// TODO: move padding to pin
o.prototype.padding=function(t){return this._padding=t,this},o.prototype.spacing=function(t){return this._spacing=t,this}},{"./core":60,"./loop":66,"./pin":68,"./util/create":74}],65:[function(t,i,e){var o=t("../core");o._supported=function(){var t=document.createElement("canvas");return!(!t.getContext||!t.getContext("2d"))}(),window.addEventListener("load",function(){o._supported&&o.start()},!1),o.config({"app-loader":function(t,i){function e(){r.setTransform(1,0,0,1,0,0),r.clearRect(0,0,m,h),d.render(r)}function s(){a?(
// screen.availWidth/Height?
m=window.innerWidth>0?window.innerWidth:screen.width,h=window.innerHeight>0?window.innerHeight:screen.height,n.style.width=m+"px",n.style.height=h+"px"):(m=n.clientWidth,h=n.clientHeight),m*=c,h*=c,n.width===m&&n.height===h||(n.width=m,n.height=h,d.viewport(m,h,c),e())}var n=(i=i||{}).canvas,r=null,a=!1,m=0,h=0,c=1;if("string"==typeof n&&(n=document.getElementById(n)),n||(n=document.getElementById("cutjs")||document.getElementById("stage")),!n){a=!0,(n=document.createElement("canvas")).style.position="absolute",n.style.top="0",n.style.left="0";var l=document.body;l.insertBefore(n,l.firstChild)}r=n.getContext("2d");var _=window.devicePixelRatio||1,u=r.webkitBackingStorePixelRatio||r.mozBackingStorePixelRatio||r.msBackingStorePixelRatio||r.oBackingStorePixelRatio||r.backingStorePixelRatio||1;c=_/u;var p=window.requestAnimationFrame||window.msRequestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.oRequestAnimationFrame||function(t){return window.setTimeout(t,1e3/60)},d=o.root(p,e);d.background=function(t){return n.style.backgroundColor=t,this},t(d,n),s(),window.addEventListener("resize",s,!1),window.addEventListener("orientationchange",s,!1)},"image-loader":function(t,i,e){var o=new Image;o.onload=function(){i(o)},o.onerror=e,o.src=t}})},{"../core":60}],66:[function(t,i,e){var o=t("./core");t("./pin");var s=t("./util/stats");o.prototype._textures=null,o.prototype._alpha=1,o.prototype.render=function(t){if(this._visible){s.node++;var i=this.matrix();t.setTransform(i.a,i.b,i.c,i.d,i.e,i.f),
// move this elsewhere!
this._alpha=this._pin._alpha*(this._parent?this._parent._alpha:1);var e=this._pin._textureAlpha*this._alpha;if(t.globalAlpha!=e&&(t.globalAlpha=e),null!==this._textures)for(var o=0,n=this._textures.length;o<n;o++)this._textures[o].draw(t);t.globalAlpha!=this._alpha&&(t.globalAlpha=this._alpha);for(var r,a=this._first;r=a;)a=r._next,r.render(t)}},o.prototype._tickBefore=null,o.prototype._tickAfter=null,o.prototype.MAX_ELAPSE=1/0,o.prototype._tick=function(t,i,e){if(this._visible){t>this.MAX_ELAPSE&&(t=this.MAX_ELAPSE);var o=!1;if(null!==this._tickBefore)for(var n=0;n<this._tickBefore.length;n++){s.tick++;o=!0===this._tickBefore[n].call(this,t,i,e)||o}for(var r,a=this._first;r=a;)a=r._next,r._flag("_tick")&&(o=!0===r._tick(t,i,e)||o);if(null!==this._tickAfter)for(n=0;n<this._tickAfter.length;n++){s.tick++;o=!0===this._tickAfter[n].call(this,t,i,e)||o}return o}},o.prototype.tick=function(t,i){"function"==typeof t&&(i?(null===this._tickBefore&&(this._tickBefore=[]),this._tickBefore.push(t)):(null===this._tickAfter&&(this._tickAfter=[]),this._tickAfter.push(t)),this._flag("_tick",null!==this._tickAfter&&this._tickAfter.length>0||null!==this._tickBefore&&this._tickBefore.length>0))},o.prototype.untick=function(t){if("function"==typeof t){var i;null!==this._tickBefore&&(i=this._tickBefore.indexOf(t))>=0&&this._tickBefore.splice(i,1),null!==this._tickAfter&&(i=this._tickAfter.indexOf(t))>=0&&this._tickAfter.splice(i,1)}},o.prototype.timeout=function(t,i){this.setTimeout(t,i)},o.prototype.setTimeout=function(t,i){function e(o){if(!((i-=o)<0))return!0;this.untick(e),t.call(this)}return this.tick(e),e},o.prototype.clearTimeout=function(t){this.untick(t)}},{"./core":60,"./pin":68,"./util/stats":80}],67:[function(t,i,e){function o(t,i,e,o,s,n){this.reset(t,i,e,o,s,n)}o.prototype.toString=function(){return"["+this.a+", "+this.b+", "+this.c+", "+this.d+", "+this.e+", "+this.f+"]"},o.prototype.clone=function(){return new o(this.a,this.b,this.c,this.d,this.e,this.f)},o.prototype.reset=function(t,i,e,o,s,n){return this._dirty=!0,"object"==typeof t?(this.a=t.a,this.d=t.d,this.b=t.b,this.c=t.c,this.e=t.e,this.f=t.f):(this.a=t||1,this.d=o||1,this.b=i||0,this.c=e||0,this.e=s||0,this.f=n||0),this},o.prototype.identity=function(){return this._dirty=!0,this.a=1,this.b=0,this.c=0,this.d=1,this.e=0,this.f=0,this},o.prototype.rotate=function(t){if(!t)return this;this._dirty=!0;var i=t?Math.cos(t):1,e=t?Math.sin(t):0,o=i*this.a-e*this.b,s=i*this.b+e*this.a,n=i*this.c-e*this.d,r=i*this.d+e*this.c,a=i*this.e-e*this.f,m=i*this.f+e*this.e;return this.a=o,this.b=s,this.c=n,this.d=r,this.e=a,this.f=m,this},o.prototype.translate=function(t,i){return t||i?(this._dirty=!0,this.e+=t,this.f+=i,this):this},o.prototype.scale=function(t,i){return t-1||i-1?(this._dirty=!0,this.a*=t,this.b*=i,this.c*=t,this.d*=i,this.e*=t,this.f*=i,this):this},o.prototype.skew=function(t,i){if(!t&&!i)return this;this._dirty=!0;var e=this.a+this.b*t,o=this.b+this.a*i,s=this.c+this.d*t,n=this.d+this.c*i,r=this.e+this.f*t,a=this.f+this.e*i;return this.a=e,this.b=o,this.c=s,this.d=n,this.e=r,this.f=a,this},o.prototype.concat=function(t){this._dirty=!0;var i=this.a*t.a+this.b*t.c,e=this.b*t.d+this.a*t.b,o=this.c*t.a+this.d*t.c,s=this.d*t.d+this.c*t.b,n=this.e*t.a+t.e+this.f*t.c,r=this.f*t.d+t.f+this.e*t.b;return this.a=i,this.b=e,this.c=o,this.d=s,this.e=n,this.f=r,this},o.prototype.inverse=o.prototype.reverse=function(){if(this._dirty){this._dirty=!1,this.inversed=this.inversed||new o;var t=this.a*this.d-this.b*this.c;this.inversed.a=this.d/t,this.inversed.b=-this.b/t,this.inversed.c=-this.c/t,this.inversed.d=this.a/t,this.inversed.e=(this.c*this.f-this.e*this.d)/t,this.inversed.f=(this.e*this.b-this.a*this.f)/t}return this.inversed},o.prototype.map=function(t,i){return i=i||{},i.x=this.a*t.x+this.c*t.y+this.e,i.y=this.b*t.x+this.d*t.y+this.f,i},o.prototype.mapX=function(t,i){return"object"==typeof t&&(i=t.y,t=t.x),this.a*t+this.c*i+this.e},o.prototype.mapY=function(t,i){return"object"==typeof t&&(i=t.y,t=t.x),this.b*t+this.d*i+this.f},i.exports=o},{}],68:[function(t,i,e){function o(t){this._owner=t,this._parent=null,
// relative to parent
this._relativeMatrix=new r,
// relative to stage
this._absoluteMatrix=new r,this.reset()}function s(t,i,e,o){var s="number"==typeof i,n="number"==typeof e,r="string"==typeof o;t._ts_transform=++a,s&&(t._scaleX=i/t._width_,t._width=t._width_),n&&(t._scaleY=e/t._height_,t._height=t._height_),s&&n&&r&&("out"==o||"out-crop"==o?t._scaleX=t._scaleY=Math.max(t._scaleX,t._scaleY):"in"!=o&&"in-pad"!=o||(t._scaleX=t._scaleY=Math.min(t._scaleX,t._scaleY)),"out-crop"!=o&&"in-pad"!=o||(t._width=i/t._scaleX,t._height=e/t._scaleY))}var n=t("./core"),r=t("./matrix"),a=0;n._init(function(){this._pin=new o(this)}),n.prototype.matrix=function(t){return!0===t?this._pin.relativeMatrix():this._pin.absoluteMatrix()},n.prototype.pin=function(t,i){return"object"==typeof t?(this._pin.set(t),this):"string"==typeof t?void 0===i?this._pin.get(t):(this._pin.set(t,i),this):void 0===t?this._pin:void 0},o.prototype.reset=function(){this._textureAlpha=1,this._alpha=1,this._width=0,this._height=0,this._scaleX=1,this._scaleY=1,this._skewX=0,this._skewY=0,this._rotation=0,
// scale/skew/rotate center
this._pivoted=!1,this._pivotX=null,this._pivotY=null,
// self pin point
this._handled=!1,this._handleX=0,this._handleY=0,
// parent pin point
this._aligned=!1,this._alignX=0,this._alignY=0,
// as seen by parent px
this._offsetX=0,this._offsetY=0,this._boxX=0,this._boxY=0,this._boxWidth=this._width,this._boxHeight=this._height,
// TODO: also set for owner
this._ts_translate=++a,this._ts_transform=++a,this._ts_matrix=++a},o.prototype._update=function(){
// if handled and transformed then be translated
return this._parent=this._owner._parent&&this._owner._parent._pin,this._handled&&this._mo_handle!=this._ts_transform&&(this._mo_handle=this._ts_transform,this._ts_translate=++a),this._aligned&&this._parent&&this._mo_align!=this._parent._ts_transform&&(this._mo_align=this._parent._ts_transform,this._ts_translate=++a),this},o.prototype.toString=function(){return this._owner+" ("+(this._parent?this._parent._owner:null)+")"},
// TODO: ts fields require refactoring
o.prototype.absoluteMatrix=function(){this._update();var t=Math.max(this._ts_transform,this._ts_translate,this._parent?this._parent._ts_matrix:0);if(this._mo_abs==t)return this._absoluteMatrix;this._mo_abs=t;var i=this._absoluteMatrix;return i.reset(this.relativeMatrix()),this._parent&&i.concat(this._parent._absoluteMatrix),this._ts_matrix=++a,i},o.prototype.relativeMatrix=function(){this._update();var t=Math.max(this._ts_transform,this._ts_translate,this._parent?this._parent._ts_transform:0);if(this._mo_rel==t)return this._relativeMatrix;this._mo_rel=t;var i=this._relativeMatrix;
// calculate effective box
if(i.identity(),this._pivoted&&i.translate(-this._pivotX*this._width,-this._pivotY*this._height),i.scale(this._scaleX,this._scaleY),i.skew(this._skewX,this._skewY),i.rotate(this._rotation),this._pivoted&&i.translate(this._pivotX*this._width,this._pivotY*this._height),this._pivoted)
// origin
this._boxX=0,this._boxY=0,this._boxWidth=this._width,this._boxHeight=this._height;else{
// aabb
var e,o;i.a>0&&i.c>0||i.a<0&&i.c<0?(e=0,o=i.a*this._width+i.c*this._height):(e=i.a*this._width,o=i.c*this._height),e>o?(this._boxX=o,this._boxWidth=e-o):(this._boxX=e,this._boxWidth=o-e),i.b>0&&i.d>0||i.b<0&&i.d<0?(e=0,o=i.b*this._width+i.d*this._height):(e=i.b*this._width,o=i.d*this._height),e>o?(this._boxY=o,this._boxHeight=e-o):(this._boxY=e,this._boxHeight=o-e)}return this._x=this._offsetX,this._y=this._offsetY,this._x-=this._boxX+this._handleX*this._boxWidth,this._y-=this._boxY+this._handleY*this._boxHeight,this._aligned&&this._parent&&(this._parent.relativeMatrix(),this._x+=this._alignX*this._parent._width,this._y+=this._alignY*this._parent._height),i.translate(this._x,this._y),this._relativeMatrix},o.prototype.get=function(t){if("function"==typeof m[t])return m[t](this)},
// TODO: Use defineProperty instead? What about multi-field pinning?
o.prototype.set=function(t,i){if("string"==typeof t)"function"==typeof h[t]&&void 0!==i&&h[t](this,i);else if("object"==typeof t)for(i in t)"function"==typeof h[i]&&void 0!==t[i]&&h[i](this,t[i],t);return this._owner&&(this._owner._ts_pin=++a,this._owner.touch()),this};var m={alpha:function(t){return t._alpha},textureAlpha:function(t){return t._textureAlpha},width:function(t){return t._width},height:function(t){return t._height},boxWidth:function(t){return t._boxWidth},boxHeight:function(t){return t._boxHeight},
// scale : function(pin) {
// },
scaleX:function(t){return t._scaleX},scaleY:function(t){return t._scaleY},
// skew : function(pin) {
// },
skewX:function(t){return t._skewX},skewY:function(t){return t._skewY},rotation:function(t){return t._rotation},
// pivot : function(pin) {
// },
pivotX:function(t){return t._pivotX},pivotY:function(t){return t._pivotY},
// offset : function(pin) {
// },
offsetX:function(t){return t._offsetX},offsetY:function(t){return t._offsetY},
// align : function(pin) {
// },
alignX:function(t){return t._alignX},alignY:function(t){return t._alignY},
// handle : function(pin) {
// },
handleX:function(t){return t._handleX},handleY:function(t){return t._handleY}},h={alpha:function(t,i){t._alpha=i},textureAlpha:function(t,i){t._textureAlpha=i},width:function(t,i){t._width_=i,t._width=i,t._ts_transform=++a},height:function(t,i){t._height_=i,t._height=i,t._ts_transform=++a},scale:function(t,i){t._scaleX=i,t._scaleY=i,t._ts_transform=++a},scaleX:function(t,i){t._scaleX=i,t._ts_transform=++a},scaleY:function(t,i){t._scaleY=i,t._ts_transform=++a},skew:function(t,i){t._skewX=i,t._skewY=i,t._ts_transform=++a},skewX:function(t,i){t._skewX=i,t._ts_transform=++a},skewY:function(t,i){t._skewY=i,t._ts_transform=++a},rotation:function(t,i){t._rotation=i,t._ts_transform=++a},pivot:function(t,i){t._pivotX=i,t._pivotY=i,t._pivoted=!0,t._ts_transform=++a},pivotX:function(t,i){t._pivotX=i,t._pivoted=!0,t._ts_transform=++a},pivotY:function(t,i){t._pivotY=i,t._pivoted=!0,t._ts_transform=++a},offset:function(t,i){t._offsetX=i,t._offsetY=i,t._ts_translate=++a},offsetX:function(t,i){t._offsetX=i,t._ts_translate=++a},offsetY:function(t,i){t._offsetY=i,t._ts_translate=++a},align:function(t,i){this.alignX(t,i),this.alignY(t,i)},alignX:function(t,i){t._alignX=i,t._aligned=!0,t._ts_translate=++a,this.handleX(t,i)},alignY:function(t,i){t._alignY=i,t._aligned=!0,t._ts_translate=++a,this.handleY(t,i)},handle:function(t,i){this.handleX(t,i),this.handleY(t,i)},handleX:function(t,i){t._handleX=i,t._handled=!0,t._ts_translate=++a},handleY:function(t,i){t._handleY=i,t._handled=!0,t._ts_translate=++a},resizeMode:function(t,i,e){e&&("in"==i?i="in-pad":"out"==i&&(i="out-crop"),s(t,e.resizeWidth,e.resizeHeight,i))},resizeWidth:function(t,i,e){e&&e.resizeMode||s(t,i,null)},resizeHeight:function(t,i,e){e&&e.resizeMode||s(t,null,i)},scaleMode:function(t,i,e){e&&s(t,e.scaleWidth,e.scaleHeight,i)},scaleWidth:function(t,i,e){e&&e.scaleMode||s(t,i,null)},scaleHeight:function(t,i,e){e&&e.scaleMode||s(t,null,i)},matrix:function(t,i){this.scaleX(t,i.a),this.skewX(t,i.c/i.d),this.skewY(t,i.b/i.a),this.scaleY(t,i.d),this.offsetX(t,i.e),this.offsetY(t,i.f),this.rotation(t,0)}};n.prototype.scaleTo=function(t,i,e){return"object"==typeof t&&(e=i,i=t.y,t=t.x),s(this._pin,t,i,e),this},
// Used by Tween class
o._add_shortcuts=function(t){t.prototype.size=function(t,i){return this.pin("width",t),this.pin("height",i),this},t.prototype.width=function(t){return void 0===t?this.pin("width"):(this.pin("width",t),this)},t.prototype.height=function(t){return void 0===t?this.pin("height"):(this.pin("height",t),this)},t.prototype.offset=function(t,i){return"object"==typeof t&&(i=t.y,t=t.x),this.pin("offsetX",t),this.pin("offsetY",i),this},t.prototype.rotate=function(t){return this.pin("rotation",t),this},t.prototype.skew=function(t,i){return"object"==typeof t?(i=t.y,t=t.x):void 0===i&&(i=t),this.pin("skewX",t),this.pin("skewY",i),this},t.prototype.scale=function(t,i){return"object"==typeof t?(i=t.y,t=t.x):void 0===i&&(i=t),this.pin("scaleX",t),this.pin("scaleY",i),this},t.prototype.alpha=function(t,i){return this.pin("alpha",t),void 0!==i&&this.pin("textureAlpha",i),this}},o._add_shortcuts(n),i.exports=o},{"./core":60,"./matrix":67}],69:[function(t,i,e){function o(t,i){o._super.call(this),this.label("Root");var e=!0,s=this,r=0,a=function(o){if(!0!==e){n.tick=n.node=n.draw=0;var m=r||o,h=o-m;r=o;var c=s._tick(h,o,m);s._mo_touch!=s._ts_touch?(s._mo_touch=s._ts_touch,i(s),t(a)):c?t(a):e=!0,n.fps=h?1e3/h:0}};this.start=function(){return this.resume()},this.resume=function(){return e&&(this.publish("resume"),e=!1,t(a)),this},this.pause=function(){return e||this.publish("pause"),e=!0,this},this.touch_root=this.touch,this.touch=function(){return this.resume(),this.touch_root()}}var s=t("./core");t("./pin"),t("./loop");var n=t("./util/stats"),r=t("./util/create"),a=t("./util/extend");o.prototype=r((o._super=s).prototype),s.root=function(t,i){return new o(t,i)},o.prototype.background=function(t){
// to be implemented by loaders
return this},o.prototype.viewport=function(t,i,e){if(void 0===t)return a({},this._viewport);this._viewport={width:t,height:i,ratio:e||1},this.viewbox();var o=a({},this._viewport);return this.visit({start:function(t){if(!t._flag("viewport"))return!0;t.publish("viewport",[o])}}),this},
// TODO: static/fixed viewbox
o.prototype.viewbox=function(t,i,e){"number"==typeof t&&"number"==typeof i&&(this._viewbox={width:t,height:i,mode:/^(in|out|in-pad|out-crop)$/.test(e)?e:"in-pad"});var o=this._viewbox,s=this._viewport;return s&&o?(this.pin({width:o.width,height:o.height}),this.scaleTo(s.width,s.height,o.mode)):s&&this.pin({width:s.width,height:s.height}),this}},{"./core":60,"./loop":66,"./pin":68,"./util/create":74,"./util/extend":76,"./util/stats":80}],70:[function(t,i,e){function o(){o._super.call(this),this.label("String"),this._textures=[]}var s=t("./core");t("./pin"),t("./loop");var n=t("./util/create"),r=t("./util/is");s.string=function(t){return(new o).frames(t)},/**
 * @deprecated Use frames
 */
(o.prototype=n((o._super=s).prototype)).setFont=function(t,i,e){return this.frames(t,i,e)},o.prototype.frames=function(t){return this._textures=[],"string"==typeof t?(t=s.texture(t),this._item=function(i){return t.one(i)}):"object"==typeof t?this._item=function(i){return t[i]}:"function"==typeof t&&(this._item=t),this},/**
 * @deprecated Use value
 */
o.prototype.setValue=function(t,i,e){return this.value(t,i,e)},o.prototype.value=function(t){if(void 0===t)return this._value;if(this._value===t)return this;this._value=t,null===t?t="":"string"==typeof t||r.array(t)||(t=t.toString()),this._spacing=this._spacing||0;for(var i=0,e=0,o=0;o<t.length;o++){var s=this._textures[o]=this._item(t[o]);i+=o>0?this._spacing:0,s.dest(i,0),i+=s.width,e=Math.max(e,s.height)}return this.pin("width",i),this.pin("height",e),this._textures.length=t.length,this}},{"./core":60,"./loop":66,"./pin":68,"./util/create":74,"./util/is":77}],71:[function(t,i,e){function o(t,i){"object"==typeof t&&this.src(t,i)}var s=t("./util/stats"),n=t("./util/math");o.prototype.pipe=function(){return new o(this)},/**
 * Signatures: (image), (x, y, w, h), (w, h)
 */
o.prototype.src=function(t,i,e,o){if("object"==typeof t){var s=t,n=i||1;this._image=s,this._sx=this._dx=0,this._sy=this._dy=0,this._sw=this._dw=s.width/n,this._sh=this._dh=s.height/n,this.width=s.width/n,this.height=s.height/n,this.ratio=n}else void 0===e?(e=t,o=i):(this._sx=t,this._sy=i),this._sw=this._dw=e,this._sh=this._dh=o,this.width=e,this.height=o;return this},/**
 * Signatures: (x, y, w, h), (x, y)
 */
o.prototype.dest=function(t,i,e,o){return this._dx=t,this._dy=i,this._dx=t,this._dy=i,void 0!==e&&(this._dw=e,this._dh=o,this.width=e,this.height=o),this},o.prototype.draw=function(t,i,e,o,r,a,m,h,c){var l=this._image;if(null!==l&&"object"==typeof l){var _=this._sx,u=this._sy,p=this._sw,d=this._sh,y=this._dx,f=this._dy,v=this._dw,x=this._dh;void 0!==a?(i=n.limit(i,0,this._sw),o=n.limit(o,0,this._sw-i),_+=i,u+=e=n.limit(e,0,this._sh),p=o,d=r=n.limit(r,0,this._sh-e),y=a,f=m,v=h,x=c):void 0!==o?(y=i,f=e,v=o,x=r):void 0!==i&&(v=i,x=e);var g=this.ratio||1;_*=g,u*=g,p*=g,d*=g;try{"function"==typeof l.draw?l.draw(t,_,u,p,d,y,f,v,x):(s.draw++,t.drawImage(l,_,u,p,d,y,f,v,x))}catch(t){l._draw_failed||(console.log("Unable to draw: ",l),console.log(t),l._draw_failed=!0)}}},i.exports=o},{"./util/math":78,"./util/stats":80}],72:[function(t,i,e){function o(t,i){a(i),a(t),i.remove(),t._last&&(t._last._next=i,i._prev=t._last),i._parent=t,t._last=i,t._first||(t._first=i),i._parent._flag(i,!0),i._ts_parent=++c,t._ts_children=++c,t.touch()}function s(t,i){a(i),a(t),i.remove(),t._first&&(t._first._prev=i,i._next=t._first),i._parent=t,t._first=i,t._last||(t._last=i),i._parent._flag(i,!0),i._ts_parent=++c,t._ts_children=++c,t.touch()}function n(t,i){a(t),a(i),t.remove();var e=i._parent,o=i._prev;i._prev=t,o&&(o._next=t)||e&&(e._first=t),t._parent=e,t._prev=o,t._next=i,t._parent._flag(t,!0),t._ts_parent=++c,t.touch()}function r(t,i){a(t),a(i),t.remove();var e=i._parent,o=i._next;i._next=t,o&&(o._prev=t)||e&&(e._last=t),t._parent=e,t._prev=i,t._next=o,t._parent._flag(t,!0),t._ts_parent=++c,t.touch()}function a(t){if(t&&t instanceof m)return t;throw"Invalid node: "+t}var m=t("./core"),h=t("./util/is"),c=0;
// TODO: do not clear next/prev/parent on remove
m.prototype._label="",m.prototype._visible=!0,m.prototype._parent=null,m.prototype._next=null,m.prototype._prev=null,m.prototype._first=null,m.prototype._last=null,m.prototype._attrs=null,m.prototype._flags=null,m.prototype.toString=function(){return"["+this._label+"]"},/**
 * @deprecated Use label()
 */
m.prototype.id=function(t){return this.label(t)},m.prototype.label=function(t){return void 0===t?this._label:(this._label=t,this)},m.prototype.attr=function(t,i){return void 0===i?null!==this._attrs?this._attrs[t]:void 0:((null!==this._attrs?this._attrs:this._attrs={})[t]=i,this)},m.prototype.visible=function(t){return void 0===t?this._visible:(this._visible=t,this._parent&&(this._parent._ts_children=++c),this._ts_pin=++c,this.touch(),this)},m.prototype.hide=function(){return this.visible(!1)},m.prototype.show=function(){return this.visible(!0)},m.prototype.parent=function(){return this._parent},m.prototype.next=function(t){for(var i=this._next;i&&t&&!i._visible;)i=i._next;return i},m.prototype.prev=function(t){for(var i=this._prev;i&&t&&!i._visible;)i=i._prev;return i},m.prototype.first=function(t){for(var i=this._first;i&&t&&!i._visible;)i=i._next;return i},m.prototype.last=function(t){for(var i=this._last;i&&t&&!i._visible;)i=i._prev;return i},m.prototype.visit=function(t,i){var e=t.reverse,o=t.visible;if(!t.start||!t.start(this,i)){for(var s,n=e?this.last(o):this.first(o);s=n;)if(n=e?s.prev(o):s.next(o),s.visit(t,i))return!0;return t.end&&t.end(this,i)}},m.prototype.append=function(t,i){if(h.array(t))for(var e=0;e<t.length;e++)o(this,t[e]);else if(void 0!==i)// deprecated
for(e=0;e<arguments.length;e++)o(this,arguments[e]);else void 0!==t&&o(this,t);return this},m.prototype.prepend=function(t,i){if(h.array(t))for(var e=t.length-1;e>=0;e--)s(this,t[e]);else if(void 0!==i)// deprecated
for(e=arguments.length-1;e>=0;e--)s(this,arguments[e]);else void 0!==t&&s(this,t);return this},m.prototype.appendTo=function(t){return o(t,this),this},m.prototype.prependTo=function(t){return s(t,this),this},m.prototype.insertNext=function(t,i){if(h.array(t))for(var e=0;e<t.length;e++)r(t[e],this);else if(void 0!==i)// deprecated
for(e=0;e<arguments.length;e++)r(arguments[e],this);else void 0!==t&&r(t,this);return this},m.prototype.insertPrev=function(t,i){if(h.array(t))for(var e=t.length-1;e>=0;e--)n(t[e],this);else if(void 0!==i)// deprecated
for(e=arguments.length-1;e>=0;e--)n(arguments[e],this);else void 0!==t&&n(t,this);return this},m.prototype.insertAfter=function(t){return r(this,t),this},m.prototype.insertBefore=function(t){return n(this,t),this},m.prototype.remove=function(t,i){if(void 0!==t){if(h.array(t))for(var e=0;e<t.length;e++)a(t[e]).remove();else if(void 0!==i)for(e=0;e<arguments.length;e++)a(arguments[e]).remove();else a(t).remove();return this}
// this._parent.touch();
return this._prev&&(this._prev._next=this._next),this._next&&(this._next._prev=this._prev),this._parent&&(this._parent._first===this&&(this._parent._first=this._next),this._parent._last===this&&(this._parent._last=this._prev),this._parent._flag(this,!1),this._parent._ts_children=++c,this._parent.touch()),this._prev=this._next=this._parent=null,this._ts_parent=++c,this},m.prototype.empty=function(){for(var t,i=this._first;t=i;)i=t._next,t._prev=t._next=t._parent=null,this._flag(t,!1);return this._first=this._last=null,this._ts_children=++c,this.touch(),this},m.prototype.touch=function(){return this._ts_touch=++c,this._parent&&this._parent.touch(),this},/**
 * Deep flags used for optimizing event distribution.
 */
m.prototype._flag=function(t,i){if(void 0===i)return null!==this._flags&&this._flags[t]||0;if("string"==typeof t&&(i?(this._flags=this._flags||{},!this._flags[t]&&this._parent&&this._parent._flag(t,!0),this._flags[t]=(this._flags[t]||0)+1):this._flags&&this._flags[t]>0&&(1==this._flags[t]&&this._parent&&this._parent._flag(t,!1),this._flags[t]=this._flags[t]-1)),"object"==typeof t&&t._flags)for(var e in t._flags)t._flags[e]>0&&this._flag(e,i);return this},/**
 * @private
 */
m.prototype.hitTest=function(t){return!!this.attr("spy")||t.x>=0&&t.x<=this._pin._width&&t.y>=0&&t.y<=this._pin._height},i.exports=m},{"./core":60,"./util/is":77}],73:[function(t,i,e){i.exports=function(){function t(t,o){return i+=o="number"==typeof o&&o>=1?o:1,function(){t&&t.apply(this,arguments),o>0&&(o--,i--,function(){if(0===i)for(;e.length;)setTimeout(e.shift(),0)}())}}var i=0,e=[];return t.then=function(t){0===i?setTimeout(t,0):e.push(t)},t}},{}],74:[function(t,i,e){function o(){}"function"==typeof Object.create?i.exports=function(t,i){return Object.create.call(Object,t,i)}:i.exports=function(t,i){if(i)throw Error("Second argument is not supported!");if("object"!=typeof t||null===t)throw Error("Invalid prototype!");return o.prototype=t,new o}},{}],75:[function(t,i,e){i.exports=function(t,i){t._listeners=null,t.on=t.listen=function(t,e){if(!t||!t.length||"function"!=typeof e)return this;null===this._listeners&&(this._listeners={});if(t=("string"!=typeof t&&"function"==typeof t.join?t.join(" "):t).match(/\S+/g))for(var o=0;o<t.length;o++){var s=t[o];this._listeners[s]=this._listeners[s]||[],this._listeners[s].push(e),"function"==typeof i&&i(this,s,!0)}return this},t.off=function(t,e){if(!t||!t.length||"function"!=typeof e)return this;if(null===this._listeners)return this;if(t=("string"!=typeof t&&"function"==typeof t.join?t.join(" "):t).match(/\S+/g))for(var o=0;o<t.length;o++){var s,n=t[o],r=this._listeners[n];r&&(s=r.indexOf(e))>=0&&(r.splice(s,1),r.length||delete this._listeners[n],"function"==typeof i&&i(this,n,!1))}return this},t.listeners=function(t){return this._listeners&&this._listeners[t]},t.publish=function(t,i){var e=this.listeners(t);if(!e||!e.length)return 0;for(var o=0;o<e.length;o++)e[o].apply(this,i);return e.length},t.trigger=function(t,i){return this.publish(t,i),this}}},{}],76:[function(t,i,e){i.exports=function(t){for(var i=1;i<arguments.length;i++){var e=arguments[i];for(var o in e)e.hasOwnProperty(o)&&(t[o]=e[o])}return t}},{}],77:[function(t,i,e){/**
 * ! is the definitive JavaScript type testing library
 * 
 * @copyright 2013-2014 Enrico Marino / Jordan Harband
 * @license MIT
 */
var o=Object.prototype,s=o.hasOwnProperty,n=o.toString,r=/^[A-Fa-f0-9]+$/,a=i.exports={};a.a=a.an=a.type=function(t,i){return typeof t===i},a.defined=function(t){return void 0!==t},a.empty=function(t){var i,e=n.call(t);if("[object Array]"===e||"[object Arguments]"===e||"[object String]"===e)return 0===t.length;if("[object Object]"===e){for(i in t)if(s.call(t,i))return!1;return!0}return!t},a.equal=function(t,i){if(t===i)return!0;var e,o=n.call(t);if(o!==n.call(i))return!1;if("[object Object]"===o){for(e in t)if(!(a.equal(t[e],i[e])&&e in i))return!1;for(e in i)if(!(a.equal(t[e],i[e])&&e in t))return!1;return!0}if("[object Array]"===o){if((e=t.length)!==i.length)return!1;for(;--e;)if(!a.equal(t[e],i[e]))return!1;return!0}return"[object Function]"===o?t.prototype===i.prototype:"[object Date]"===o&&t.getTime()===i.getTime()},a.instance=function(t,i){return t instanceof i},a.nil=function(t){return null===t},a.undef=function(t){return void 0===t},a.array=function(t){return"[object Array]"===n.call(t)},a.emptyarray=function(t){return a.array(t)&&0===t.length},a.arraylike=function(t){return!!t&&!a.boolean(t)&&s.call(t,"length")&&isFinite(t.length)&&a.number(t.length)&&t.length>=0},a.boolean=function(t){return"[object Boolean]"===n.call(t)},a.element=function(t){return void 0!==t&&"undefined"!=typeof HTMLElement&&t instanceof HTMLElement&&1===t.nodeType},a.fn=function(t){return"[object Function]"===n.call(t)},a.number=function(t){return"[object Number]"===n.call(t)},a.nan=function(t){return!a.number(t)||t!=t},a.object=function(t){return"[object Object]"===n.call(t)},a.hash=function(t){return a.object(t)&&t.constructor===Object&&!t.nodeType&&!t.setInterval},a.regexp=function(t){return"[object RegExp]"===n.call(t)},a.string=function(t){return"[object String]"===n.call(t)},a.hex=function(t){return a.string(t)&&(!t.length||r.test(t))}},{}],78:[function(t,i,e){var o=t("./create"),s=Math;i.exports=o(Math),i.exports.random=function(t,i){return void 0===t?(i=1,t=0):void 0===i&&(i=t,t=0),t==i?t:s.random()*(i-t)+t},i.exports.rotate=function(t,i,e){return void 0===i?(e=1,i=0):void 0===e&&(e=i,i=0),e>i?(t=(t-i)%(e-i))+(t<0?e:i):(t=(t-e)%(i-e))+(t<=0?i:e)},i.exports.limit=function(t,i,e){return t<i?i:t>e?e:t},i.exports.length=function(t,i){return s.sqrt(t*t+i*i)}},{"./create":74}],79:[function(t,i,e){i.exports=function(t,i,e,o,s,n){var r=t.width,a=t.height,m=t.left,h=t.right,c=t.top,l=t.bottom;r=r-(m="number"==typeof m&&m==m?m:0)-(h="number"==typeof h&&h==h?h:0),a=a-(c="number"==typeof c&&c==c?c:0)-(l="number"==typeof l&&l==l?l:0),s||(i=Math.max(i-m-h,0),e=Math.max(e-c-l,0));var _=0;if(c>0&&m>0&&n(_++,0,0,m,c,0,0,m,c),l>0&&m>0&&n(_++,0,a+c,m,l,0,e+c,m,l),c>0&&h>0&&n(_++,r+m,0,h,c,i+m,0,h,c),l>0&&h>0&&n(_++,r+m,a+c,h,l,i+m,e+c,h,l),o)c>0&&n(_++,m,0,r,c,m,0,i,c),l>0&&n(_++,m,a+c,r,l,m,e+c,i,l),m>0&&n(_++,0,c,m,a,0,c,m,e),h>0&&n(_++,r+m,c,h,a,i+m,c,h,e),
// center
n(_++,m,c,r,a,m,c,i,e);else for(// tile
var u,p=m,d=i;d>0;){u=Math.min(r,d),d-=r;for(var y,f=c,v=e;v>0;)y=Math.min(a,v),v-=a,n(_++,m,c,u,y,p,f,u,y),d<=0&&(m&&n(_++,0,c,m,y,0,f,m,y),h&&n(_++,r+m,c,h,y,p+u,f,h,y)),f+=y;c&&n(_++,m,0,u,c,p,0,u,c),l&&n(_++,m,a+c,u,l,p,f,u,l),p+=u}return _}},{}],80:[function(t,i,e){i.exports={}},{}],81:[function(t,i,e){i.exports.startsWith=function(t,i){return"string"==typeof t&&"string"==typeof i&&t.substring(0,i.length)==i}},{}],82:[function(t,i,e){i.exports=t("../lib/"),i.exports.internal={},t("../lib/canvas"),i.exports.internal.Image=t("../lib/image"),t("../lib/anim"),t("../lib/str"),t("../lib/layout"),t("../lib/addon/tween"),i.exports.Mouse=t("../lib/addon/mouse"),i.exports.Math=t("../lib/util/math"),i.exports._extend=t("../lib/util/extend"),i.exports._create=t("../lib/util/create"),t("../lib/loader/web")},{"../lib/":63,"../lib/addon/mouse":55,"../lib/addon/tween":56,"../lib/anim":57,"../lib/canvas":59,"../lib/image":62,"../lib/layout":64,"../lib/loader/web":65,"../lib/str":70,"../lib/util/create":74,"../lib/util/extend":76,"../lib/util/math":78}]},{},[1])(1)});